/* Copyright (C) 2014 McAfee, Inc.  All rights reserved.*/
/* Each procedure,function etc. should be dropped first and then created.This is done so as to make the sqls reentrant.
To drop a procedure,function etc. the name of the view should be passed to the corresponding dropping procedure.
For example to drop a function pass the function name to procedure dbo.SCOR_DROP_FUNCTION
*/

dbo.SCOR_DROP_PROCEDURE SCOR_EVENT_INSERT;
GO

CREATE PROCEDURE [dbo].[SCOR_EVENT_INSERT]
(
        @EVT_ATTR_NAME nvarchar(1024) = NULL,
        @EVT_COMMENT nvarchar(4000) = NULL,
        @EVT_ERROR nvarchar(128) = NULL,
        @EVT_DISPLAY_KEY nvarchar(256) = NULL,
        @EVT_NAME nvarchar(100),
        @EVT_CMD_LINE nvarchar(4000) = NULL,
        @EVT_CMD_USER_NAME nvarchar(512) = NULL,
        @EVT_CMD_STATUS nvarchar(128) = NULL,
        @EVT_SEQ_NO numeric(19,0) = NULL,
        @EVT_FILE_NAME nvarchar(1024) = NULL,
        @HOST_NAME nvarchar(256) = NULL,
	@AgentGUID uniqueidentifier = NULL,
        @EVT_LOGON_HOST_NAME nvarchar(256) = NULL,
        @EVT_LOGON_PROCESS nvarchar(1024) = NULL,
        @EVT_LOGON_REMOTE_HOST_NAME nvarchar(256) = NULL,
        @EVT_MODOFICATION_TYPE nvarchar(256) = NULL,
        @EVT_NEW_FILE_NAME nvarchar(1024) = NULL,
        @EVT_OBJECT nvarchar(1024) = NULL,
        @EVT_VALUE1 nvarchar(1024) = NULL,
        @EVT_ORIG_USER_NAME nvarchar(256) = NULL,
        @EVT_PROCESS_ID nvarchar(1024) = NULL,
	@EVT_PROG_NAME nvarchar(1024) = NULL,
        @EVT_REG_KEY_NAME nvarchar(1024) = NULL,
        @EVT_REG_VALUE_DATA nvarchar(1024) = NULL,
        @EVT_REG_VALUE_NAME nvarchar(1024) = NULL,
        @EVT_REG_VALUE_TYPE nvarchar(64) = NULL,
	@EVT_MODIFICATION_TYPE nvarchar(64) = NULL,
        @DetectedUTC datetime,
        @EVT_USER_NAME nvarchar(256) = NULL,
        @EVT_USER_ACCOUNT_NAME nvarchar(256) = NULL,
        @EVT_WORKFLOW_ID nvarchar(1024) = NULL,
	@EVT_PAR_PROC_NAME nvarchar(1024) = NULL,
        @EVT_PAR_PROCESS_ID nvarchar(256) = NULL,
	@EVT_PROCESS_SYS_CALL_NUMBER nvarchar(128) = NULL,
	@EVT_PROCESS_RETURN_ADDRESS nvarchar(128) = NULL,
	@EVT_PROCESS_API_NAME nvarchar(1024) = NULL,
	@EVT_VOLUME_NAME nvarchar(1024) = NULL,
	@EVT_FAULTING_ADDR nvarchar(1024) = NULL,
	@THREATEVENTID int,
	@RECON_FLAG numeric(8,0) = NULL,
	@RECON_TIX nvarchar(256) = NULL,
	@IS_UPDATER nchar(1) = NULL,
	@IS_WINDOW nchar(1) = NULL,
	@EPO_EVENT_AUTO_ID bigint = NULL,
	@THREATSEVERITY tinyint = NULL,
	@EVT_FILE_SHA1 varchar(40) = NULL,
	@EVT_FILE_SHA256 varchar(64) = NULL,
	@EVT_FILE_MD5 varchar(32) = NULL,
	@EVT_FILE_TYPE varchar(30) = NULL,
	@EVT_PROCESS_SHA1 varchar(40) = NULL,
	@EVT_PROCESS_SHA256 varchar(64) = NULL,
	@EVT_PROCESS_MD5 varchar(32) = NULL,
	@EVT_DENY_REASON nvarchar(4000) = NULL,
	@EVT_DENY_REASON_ID int = NULL,
	@EVT_REPUTATION_SCORE int = NULL,
	@AutoID bigint = NULL OUTPUT,
	@AutoGUID uniqueidentifier = NULL OUTPUT
)
AS
BEGIN
	-- used for guid insertion and returning
	SET @AutoID = NULL;
	SET @AutoGUID = NULL;

	DECLARE @tmpGUID uniqueidentifier;
	SET @tmpGUID = NEWID();

	INSERT INTO [dbo].[SCOR_EVENTS] (
	 AutoGUID,
         EVT_ATTR_NAME,
         EVT_COMMENT,
         EVT_ERROR,
         EVT_DISPLAY_KEY,
         EVT_NAME,
         EVT_CMD_LINE,
         EVT_CMD_USER_NAME,
         EVT_CMD_STATUS,
         EVT_SEQ_NO,
         EVT_FILE_NAME,
         HOST_NAME,
	 AgentGUID,
         EVT_LOGON_HOST_NAME,
         EVT_LOGON_PROCESS,
         EVT_LOGON_REMOTE_HOST_NAME,
         EVT_NEW_FILE_NAME,
         EVT_OBJECT,
         EVT_VALUE1,
         EVT_ORIG_USER_NAME,
         EVT_PROCESS_ID,
	 EVT_PROG_NAME,
         EVT_REG_KEY_NAME,
         EVT_REG_VALUE_DATA,
         EVT_REG_VALUE_NAME,
         EVT_REG_VALUE_TYPE,
	 EVT_MODIFICATION_TYPE,
         DetectedUTC,
         EVT_USER_NAME,
         EVT_USER_ACCOUNT_NAME,
         EVT_WORKFLOW_ID,
	 EVT_PAR_PROC_NAME,
         EVT_PAR_PROCESS_ID,
	 EVT_PROCESS_SYS_CALL_NUMBER,
	 EVT_PROCESS_RETURN_ADDRESS,
	 EVT_PROCESS_API_NAME,
	 EVT_VOLUME_NAME,
	 EVT_FAULTING_ADDR,
	 THREATEVENTID,
	 THREATSEVERITY,
         RECON_FLAG,
         RECON_TIX,
	 IS_UPDATER,
	 IS_WINDOW,
	 EVT_FILE_SHA1,
	 EVT_FILE_SHA256,
	 EVT_FILE_MD5,
	 EVT_FILE_TYPE,
	 EVT_PROCESS_SHA1,
	 EVT_PROCESS_SHA256,
	 EVT_PROCESS_MD5,
	 EVT_DENY_REASON,
	 EVT_DENY_REASON_ID,
	 EVT_REPUTATION_SCORE,
	 EPO_EVENT_AUTO_ID
	)
	VALUES
	(
	 @tmpGUID,
         @EVT_ATTR_NAME,
         @EVT_COMMENT,
         @EVT_ERROR,
         @EVT_DISPLAY_KEY,
         @EVT_NAME,
         @EVT_CMD_LINE,
         @EVT_CMD_USER_NAME,
         @EVT_CMD_STATUS,
         @EVT_SEQ_NO,
         @EVT_FILE_NAME,
         @HOST_NAME,
	 @AgentGUID,
         @EVT_LOGON_HOST_NAME,
         @EVT_LOGON_PROCESS,
         @EVT_LOGON_REMOTE_HOST_NAME,
         @EVT_NEW_FILE_NAME,
         @EVT_OBJECT,
         @EVT_VALUE1,
         @EVT_ORIG_USER_NAME,
         @EVT_PROCESS_ID,
	 @EVT_PROG_NAME,
         @EVT_REG_KEY_NAME,
         @EVT_REG_VALUE_DATA,
         @EVT_REG_VALUE_NAME,
         @EVT_REG_VALUE_TYPE,
	 @EVT_MODIFICATION_TYPE,
         @DetectedUTC,
         @EVT_USER_NAME,
         @EVT_USER_ACCOUNT_NAME,
         @EVT_WORKFLOW_ID,
	 @EVT_PAR_PROC_NAME,
         @EVT_PAR_PROCESS_ID,
	 @EVT_PROCESS_SYS_CALL_NUMBER,
	 @EVT_PROCESS_RETURN_ADDRESS,
	 @EVT_PROCESS_API_NAME,
	 @EVT_VOLUME_NAME,
	 @EVT_FAULTING_ADDR,
	 @THREATEVENTID,
	 @THREATSEVERITY,
	 @RECON_FLAG,
         @RECON_TIX,
	 @IS_UPDATER,
	 @IS_WINDOW,
	 @EVT_FILE_SHA1,
	 @EVT_FILE_SHA256,
	@EVT_FILE_MD5,
	@EVT_FILE_TYPE,
	@EVT_PROCESS_SHA1,
	@EVT_PROCESS_SHA256,
	@EVT_PROCESS_MD5,
	@EVT_DENY_REASON,
	@EVT_DENY_REASON_ID,
	@EVT_REPUTATION_SCORE,
	 @EPO_EVENT_AUTO_ID
	);

	-- assign return result
	SET @AutoID = SCOPE_IDENTITY();
	SET @AutoGUID = @tmpGUID;

	-- return the autoid in case anyone is watching
END
GO


dbo.SCOR_DROP_FUNCTION ScorSplit;
GO

CREATE FUNCTION [dbo].[ScorSplit](@List As varchar(8000))
RETURNS @Items table (Item int Not Null)
AS
BEGIN
    DECLARE @Item As int, @Pos As int
    WHILE DATALENGTH(@List)>0
    BEGIN
        SET @Pos=CHARINDEX(',',@List)
        IF @Pos=0 SET @Pos=DATALENGTH(@List)+1
        SET @Item =  LTRIM(RTRIM(LEFT(@List,@Pos-1)))
        IF @Item<>'' INSERT INTO @Items SELECT @Item
        SET @List=SUBSTRING(@List,@Pos+DATALENGTH(','),8000)
    END
    RETURN
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_CONFIG_PROC_UPDATE;
GO

CREATE PROCEDURE dbo.SCOR_CONFIG_PROC_UPDATE
       @context nvarchar(255),
       @name nvarchar(100),
       @value nvarchar(max),
       @valueType nvarchar(32) = 'TEXT',
       @editable  nchar(1) = 'Y',
       @viewable nchar(1) = 'Y'
AS
BEGIN
    SET NOCOUNT ON;
    if exists (select 1 from [dbo].[SCOR_CONFIG] where name = @name)
        update [dbo].[SCOR_CONFIG] SET CONTEXT= @context,VALUE= @value,DEFAULT_VALUE=@value, VALUE_TYPE= @valueType,EDITABLE= @editable,VIEWABLE= @viewable where name = @name;
    else
	    insert into [dbo].[SCOR_CONFIG] (CONTEXT, NAME, VALUE, DEFAULT_VALUE, VALUE_TYPE, EDITABLE, VIEWABLE) values (@context, @name, @value, @value, @valueType, @editable, @viewable);
END
GO


dbo.SCOR_DROP_PROCEDURE SCOR_CONFIG_PROC;
GO

CREATE PROCEDURE dbo.SCOR_CONFIG_PROC
       @context nvarchar(255),
       @name nvarchar(100),
       @value nvarchar(max),
       @valueType nvarchar(32) = 'TEXT',
       @editable  nchar(1) = 'Y',
       @viewable nchar(1) = 'Y'
AS
BEGIN
    SET NOCOUNT ON;
    if exists (select 1 from [dbo].[SCOR_CONFIG] where name = @name)
        update [dbo].[SCOR_CONFIG] SET CONTEXT= @context,DEFAULT_VALUE=@value, VALUE_TYPE= @valueType,EDITABLE= @editable,VIEWABLE= @viewable where name = @name;
    else
	    insert into [dbo].[SCOR_CONFIG] (CONTEXT, NAME, VALUE, DEFAULT_VALUE, VALUE_TYPE, EDITABLE, VIEWABLE) values (@context, @name, @value, @value, @valueType, @editable, @viewable);
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_CONFIG_PROC_LICENSE;
GO

CREATE PROCEDURE dbo.SCOR_CONFIG_PROC_LICENSE
       @context nvarchar(255),
       @name nvarchar(100),
       @value nvarchar(4000),
       @valueType nvarchar(32) = 'TEXT',
       @editable  nchar(1) = 'Y',
       @viewable nchar(1) = 'Y'
AS
BEGIN
    SET NOCOUNT ON;
    if not exists (select 1 from [dbo].[SCOR_CONFIG] where name = @name)
    BEGIN
	DECLARE @licensesWithValueCount INT;
	select @licensesWithValueCount = count(*) from [dbo].[SCOR_CONFIG] where context='featureLicenseKey' and value <> '';
	if (@licensesWithValueCount > 0)
		set @value = '3';
	insert into [dbo].[SCOR_CONFIG] (CONTEXT, NAME, VALUE, DEFAULT_VALUE, VALUE_TYPE, EDITABLE, VIEWABLE)  values (@context, @name, @value, @value , @valueType, @editable, @viewable);
    END
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_RECON_CONFIG_PROC;
GO

CREATE PROCEDURE dbo.SCOR_RECON_CONFIG_PROC
	@paramName nvarchar(128),
    @paramValue nvarchar(512),
    @description nvarchar(256)
AS
BEGIN
	SET NOCOUNT ON;
	if not exists (select 1 from [dbo].[SCOR_RECON_CONFIG] where PARAM_NAME = @paramName)
		insert into [dbo].[SCOR_RECON_CONFIG] (PARAM_NAME, PARAM_VALUE, DESCRIPTION)
			values (@paramName, @paramValue, @description);
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_SKU_FEATURE_MAPPING_PROC;
GO

dbo.SCOR_DROP_PROCEDURE SCOR_EVENT_INFO_PROC;
GO

CREATE PROCEDURE dbo.SCOR_EVENT_INFO_PROC
	 @eventDisplayKey nvarchar(255),
         @enabled nchar(1) = 'Y',
	 @eventType nvarchar(255),
         @searchable nchar(1) = 'Y',
         @isEpoEvent nchar(1) = 'N',
         @threatCategory nvarchar(255),
         @threatName nvarchar(255),
         @threatType nvarchar(255),
         @threatActionTaken nvarchar(255),
         @isScorEvent nchar(1) = 'Y',
         @isReconRequired nchar(1) = 'Y',
		 @threatHandled bit = NULL,
		 @fdSupport tinyint = 0
AS
BEGIN
    SET NOCOUNT ON;
    if exists (select 1 from [dbo].[SCOR_EVENT_INFO] where event_type = @eventType)
	update [dbo].[SCOR_EVENT_INFO] SET EVENT_DISPLAY_KEY= @eventDisplayKey,ENABLED= @enabled,SEARCHABLE= @searchable,IS_EPO_EVENT= @isEpoEvent,THREAT_CATEGORY= @threatCategory,
	THREAT_NAME= @threatName,THREAT_TYPE= @threatType,THREAT_ACTION_TAKEN= @threatActionTaken,IS_SCOR_EVENT= @isScorEvent,IS_RECON_REQUIRED= @isReconRequired,THREAT_HANDLED=@threatHandled, EVENT_TYPE=@eventType, FD_SUPPORT=@fdSupport WHERE event_type = @eventType;
     else
	 insert into [dbo].[SCOR_EVENT_INFO] values (@eventDisplayKey, @enabled, @searchable, @isEpoEvent, @threatCategory, @threatName, @threatType, @threatActionTaken, @eventType, @isScorEvent, @isReconRequired, @threatHandled, @fdSupport);
END
GO


dbo.SCOR_DROP_PROCEDURE SCOR_EVENT_DATA_FIELD_MAPPING_PROC;
GO

CREATE PROCEDURE dbo.SCOR_EVENT_DATA_FIELD_MAPPING_PROC
	@sourceField nvarchar(255),
        @tableField nvarchar(255),
        @trimValue numeric(19,0),
        @forEpoEvent nchar(1) = 'N',
        @forScorEvent nchar(1) = 'Y',
        @tableFieldType nvarchar(5) = '202',
	@eventType nvarchar(255)
AS
BEGIN
    SET NOCOUNT ON;
    if not exists (select 1 from [dbo].[SCOR_EVENT_DATA_FIELD_MAPPING] dfm, dbo.SCOR_EVENT_INFO ei where dfm.source_field = @sourceField
    and dfm.table_field = @tableField and ei.event_type = @eventType and ei.id=dfm.event_info_id)
       insert into [dbo].[SCOR_EVENT_DATA_FIELD_MAPPING] select  @sourceField, @tableField, @trimValue, @forEpoEvent, id, @forScorEvent, @tableFieldType
       from  [dbo].[SCOR_EVENT_INFO] WHERE event_type = @eventType;
    else
        update [dbo].[SCOR_EVENT_DATA_FIELD_MAPPING] SET TRIM_VALUE= @trimValue,FOR_EPO_EVENT= @forEpoEvent,FOR_SCOR_EVENT= @forScorEvent,TABLE_FIELD_TYPE= @tableFieldType where source_field = @sourceField and table_field = @tableField and event_info_id in (select id from [dbo].[SCOR_EVENT_INFO] where event_type = @eventType);
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_PUBLISHERS_PROC;
GO

CREATE PROCEDURE dbo.SCOR_PUBLISHERS_PROC
    @issuedTo nvarchar(256),
    @pem ntext,
    @issuedBy nvarchar(256),
    @expDate datetime,
    @lastMod datetime,
    @issuerKey nvarchar(256),
    @purpose nvarchar(256),
    @altrName nvarchar(256),
    @binaryName nvarchar(256),
	@certSrc nvarchar(256)
AS
BEGIN
    SET NOCOUNT ON;
    if exists (select 1 from [dbo].[SCOR_PUBLISHERS] where issuerkey = @issuerKey)
       update [dbo].[SCOR_PUBLISHERS]
	   SET ISSUEDTO= @issuedTo,PEM= @pem,ISSUEDBY= @issuedBy,EXPDATE= @expDate,PURPOSE= @purpose,
	   ALTRNAME= @altrName,BINNAME=@binaryName,CERTSRC=@certSrc,LASTMOD=@lastMod   where issuerkey = @issuerKey;
    else
       insert into [dbo].[SCOR_PUBLISHERS] (ISSUEDTO,PEM,ISSUEDBY,EXPDATE,LASTMOD,ISSUERKEY,PURPOSE,ALTRNAME,BINNAME,CERTSRC)
		values (@issuedTo, @pem, @issuedBy, @expDate,getutcdate(), @issuerKey, @purpose, @altrName,@binaryName,@certSrc);
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_INV_SAVED_SEARCHES_PROC;
GO

CREATE PROCEDURE dbo.SCOR_INV_SAVED_SEARCHES_PROC
	@searchName nvarchar(256),
    @viewType nvarchar(32),
    @advanceFilter nvarchar(max)
AS
BEGIN
	SET NOCOUNT ON;
	if not exists (select 1 from [dbo].[SCOR_INV_SAVED_SEARCHES] where SEARCH_NAME = @searchName)
		insert into [dbo].[SCOR_INV_SAVED_SEARCHES] (SEARCH_NAME, INV_VIEW_TYPE, ADVANCE_FILTER)
			values (@searchName, @viewType, @advanceFilter);
END
GO


dbo.SCOR_DROP_PROCEDURE SCOR_INSERT_RULE_GROUP;
GO


CREATE PROCEDURE dbo.SCOR_INSERT_RULE_GROUP
	@groupName nvarchar(255),
    @groupPlatform nvarchar(50),
    @groupType nvarchar(50),
    @isReadOnly nvarchar(50)
AS
BEGIN
	SET NOCOUNT ON;
	if not exists (select 1 from [dbo].[SCOR_POLICY_GROUP] where GROUP_NAME = @groupName and GROUP_PLATFORM = @groupPlatform and GROUP_TYPE = @groupType)
		insert into [dbo].[SCOR_POLICY_GROUP] (GROUP_NAME, GROUP_PLATFORM, GROUP_TYPE, IS_READ_ONLY)
			values (@groupName, @groupPlatform, @groupType, @isReadOnly);
END
GO

dbo.SCOR_DROP_PROCEDURE SCOR_INSERT_SCOR_APPLICATIONS;
GO

CREATE PROCEDURE dbo.SCOR_INSERT_SCOR_APPLICATIONS
    @appName nvarchar(1024),
    @version nvarchar(100),
    @vendor nvarchar(254),
    @checksum nvarchar(254),
    @binName nvarchar(1024)
AS
BEGIN
	SET NOCOUNT ON;
	if not exists (select 1 from [dbo].[SCOR_APPLICATIONS] where CHECKSUM = @checksum )
		insert into [dbo].[SCOR_APPLICATIONS] (APP_NAME, VERSION, VENDOR, CHECKSUM,BINNAME)
			values (@appName, @version, @vendor, @checksum,@binName);
	else
		update [dbo].[SCOR_APPLICATIONS] set APP_NAME=@appName, VERSION=@version, VENDOR=@vendor ,BINNAME=@binName
		where CHECKSUM = @checksum;

END
GO


dbo.SCOR_DROP_PROCEDURE SCOR_INSERT_VENDOR;
GO

CREATE PROCEDURE dbo.SCOR_INSERT_VENDOR
       @name nvarchar(1024)
AS
BEGIN
    SET NOCOUNT ON;
    if not exists (select 1 from [dbo].[SCOR_NORM_VENDORS] where name = @name)
	insert into [dbo].[SCOR_NORM_VENDORS] values (@name);
END
GO
