/* Copyright (C) 2016 McAfee, Inc.  All rights reserved. This file is created to upgrade scor_events table to big int*/

IF  EXISTS(SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE DATA_TYPE = 'BIGINT' AND TABLE_NAME = 'EPOEventsMT' AND COLUMN_NAME = 'AutoID')
AND EXISTS(SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE DATA_TYPE = 'INT' AND TABLE_NAME = 'SCOR_EVENTS' AND COLUMN_NAME = 'EPO_EVENT_AUTO_ID')
BEGIN
	declare @scor_events_pk varchar(500)
	
	select @scor_events_pk=name from sys.key_constraints where type = 'PK' AND [parent_object_id] = OBJECT_ID('scor_events')

	declare @sql varchar(max)

	
    -- NOTE: Make sure you drop all indexes on the custom table before altering table
    set @sql = 'EXEC    EPOUtil_DropIndexesAndCreateIndexScript ''SCOR_EVENTS'' , ' +  @scor_events_pk + ''

	EXEC (@sql)
	
    -- Finally drop PK constraint
    set @sql = ' IF EXISTS (SELECT 1 FROM sys.indexes WHERE object_id = OBJECT_ID(N''[dbo].[SCOR_EVENTS]'') AND name = ''' + @scor_events_pk + ''')'
		+ ' BEGIN '
		+'  ALTER TABLE [dbo].[SCOR_EVENTS] DROP CONSTRAINT ['+ @scor_events_pk + ']'
		+' END '
		
	EXEC (@sql)

    -- Update the column to BIGINT
    --------------------------------------------------------------------------------
    ALTER TABLE [dbo].[SCOR_EVENTS] ALTER COLUMN EPO_EVENT_AUTO_ID BIGINT NOT NULL;

    ALTER TABLE [dbo].[SCOR_EVENTS] ALTER COLUMN AutoID BIGINT NOT NULL;

    --------------------------------------------------------------------------------

    -- Add PK
    ALTER TABLE [dbo].[SCOR_EVENTS] ADD CONSTRAINT [PK_SCOR_EVENTS] PRIMARY KEY CLUSTERED
    (
        [AutoID]    ASC
    );

    ALTER TABLE [dbo].[SCOR_EVENTS]
    WITH CHECK ADD CONSTRAINT [SCOR_EVENTS_EPO_EVENTS] FOREIGN KEY
    (
        [EPO_EVENT_AUTO_ID]
    )
    REFERENCES [dbo].[EPOEventsMT]
    (
        [AutoID]
    )
    ON UPDATE NO ACTION
    ON DELETE CASCADE;

    -- Recreate other indexes
    EXEC   EPOUtil_ReCreateDroppedIndexes 'SCOR_EVENTS'
END
GO
