/* Copyright (C) 2016 McAfee, Inc.  All rights reserved. This file is created to upgrade scor_rollup_events table to big int*/

IF  EXISTS(SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE DATA_TYPE = 'BIGINT' AND TABLE_NAME = 'EPOEventsMT' AND COLUMN_NAME = 'AutoID')
AND EXISTS(SELECT 1 FROM INFORMATION_SCHEMA.COLUMNS WHERE DATA_TYPE = 'INT' AND TABLE_NAME = 'SCOR_ROLLUP_EVENTS' AND COLUMN_NAME = 'Rollup_EventId')
BEGIN
	declare @scor_rollup_events_pk varchar(500)
	
	select @scor_rollup_events_pk=name from sys.key_constraints where type = 'PK' AND [parent_object_id] = OBJECT_ID('SCOR_ROLLUP_EVENTS')

	declare @sql varchar(max)

	
    -- NOTE: Make sure you drop all indexes on the custom table before altering table
    set @sql = 'EXEC    EPOUtil_DropIndexesAndCreateIndexScript ''SCOR_ROLLUP_EVENTS'' , ' +  @scor_rollup_events_pk + ''

	EXEC (@sql)
	
    -- Finally drop PK constraint
    set @sql = ' IF EXISTS (SELECT 1 FROM sys.indexes WHERE object_id = OBJECT_ID(N''[dbo].[SCOR_ROLLUP_EVENTS]'') AND name = ''' + @scor_rollup_events_pk + ''')'
		+ ' BEGIN '
		+'  ALTER TABLE [dbo].[SCOR_ROLLUP_EVENTS] DROP CONSTRAINT ['+ @scor_rollup_events_pk + ']'
		+' END '
		
	EXEC (@sql)

    -- Update the column to BIGINT
    --------------------------------------------------------------------------------
    ALTER TABLE [dbo].[SCOR_ROLLUP_EVENTS] ALTER COLUMN Rollup_EventId BIGINT NOT NULL;

    ALTER TABLE [dbo].[SCOR_ROLLUP_EVENTS] ALTER COLUMN EPO_EVENT_AUTO_ID BIGINT NOT NULL;

    ALTER TABLE [dbo].[SCOR_ROLLUP_EVENTS] ALTER COLUMN AutoID BIGINT NOT NULL;

    --------------------------------------------------------------------------------

    -- Add PK
    ALTER TABLE [dbo].[SCOR_ROLLUP_EVENTS] ADD CONSTRAINT [PK_SCOR_ROLLUP_EVENTS] PRIMARY KEY CLUSTERED
    (
    			[RegSvrId] ASC,
    			[AutoID] ASC
    );

    -- Recreate other indexes
    EXEC   EPOUtil_ReCreateDroppedIndexes 'SCOR_ROLLUP_EVENTS'
END
GO
