<!-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved-->
<%@ page import="com.mcafee.scor.auth.ScorAuthConstants"%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="mfs"%>
<%@ page import="com.mcafee.scor.common.HelpConstants"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<jsp:include page="/common/includejQuery.jsp" />

<mfs:message key="scor.auth.rg.note" var="noteText" escape="html"/>
<mfs:message key="scor.auth.rg.help" var="ruleGroupHelpText" escape="html"/>
<mfs:message key="scor.perm.view" var="viewText" escape="javascript"/>
<mfs:message key="scor.perm.edit" var="editText" escape="javascript"/>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.GENERAL_PERMISSIONS%>");
	
	var scor = scor || {};
	scor.auth = scor.auth || {};

	$j( document ).ready(function() {
		$j("label[for='scor.perm.ruleGroup.view.allow']").text("${viewText}");
		$j("label[for='scor.perm.ruleGroup.view.edit.allow']").text("${editText}");
		var featureSelectedPermissionObj = $j('input[name="scor.perm.ruleGroup"]:checked');
		scor.auth.setSubFeaturePermissionsRadioAfterPageLoad(featureSelectedPermissionObj.get(0));
		
	});
	
	scor.auth.checkSubFeatureRadioButtons = function(subFeaturePermissionObj, featureSelectedPermissionObj){	
		var featurePerm= scor.auth.getPermissionFromURI(featureSelectedPermissionObj.id, featureSelectedPermissionObj.name);	
		var subFeaturePerm= scor.auth.getPermissionFromURI(subFeaturePermissionObj.id, subFeaturePermissionObj.name);
		if(featurePerm.indexOf(subFeaturePerm) >= 0){
			document.getElementById(subFeaturePermissionObj.id).checked = true;
		}
		if(subFeaturePerm=== "noaccess" && featurePerm=== "noaccess"){
			document.getElementById(subFeaturePermissionObj.id).checked = true;
		}			
	}

	scor.auth.enableDisableSubFeatureRadioButtons = function(subFeaturePermissionObj, featureSelectedPermissionObj){
		var featurePerm= scor.auth.getPermissionFromURI(featureSelectedPermissionObj.id, featureSelectedPermissionObj.name);	
		var subFeaturePerm= scor.auth.getPermissionFromURI(subFeaturePermissionObj.id, subFeaturePermissionObj.name);
		if(subFeaturePerm=== "noaccess" || featurePerm.indexOf(subFeaturePerm) >= 0){
			document.getElementById(subFeaturePermissionObj.id).disabled = false;
		}else{			
			document.getElementById(subFeaturePermissionObj.id).disabled = true;
		}
	}

	scor.auth.setSubFeaturePermissions = function(featureSelectedPermissionObj){
		$j('[name^="'+featureSelectedPermissionObj.name+'"]').each(		
				function( index ) {
					if(this.name !== featureSelectedPermissionObj.name){
						scor.auth.checkSubFeatureRadioButtons(this, featureSelectedPermissionObj);
						scor.auth.enableDisableSubFeatureRadioButtons(this, featureSelectedPermissionObj);	
					}			
				});
	}

	scor.auth.setSubFeaturePermissionsRadioAfterPageLoad = function(featureSelectedPermissionObj){
		$j('[name^="'+featureSelectedPermissionObj.name+'"]').each(		
				function( index ) {
					if(this.name !== featureSelectedPermissionObj.name){
						scor.auth.enableDisableSubFeatureRadioButtons(this, featureSelectedPermissionObj);	
					}			
				});
	}
	
	scor.auth.getPermissionFromURI = function(permissionURI, featureId){
		var perm = permissionURI.substring((featureId+".").length, permissionURI.length);
		if(perm.split(".").length > 1){
			return perm.substring(0, perm.indexOf(".allow"));
		}
		return perm;
	}
	
</script>

<c:forEach var="feature" items="${featureList}">
	<mfs:message var="featureName" key="${feature.featureId}" escape="HTML" />
	<table width="100%" cellpadding="0" cellspacing="0">
		<tr>			
			<c:choose>
				<c:when test="${feature.featureId == 'scor.perm.ruleGroup'}">	
											<td class="orionSummaryHeader">${featureName}<br><br><br><br><span style="font-style: italic;color: gray;font-size: 9px;">
${noteText}</span></td>
					
					<td class="orionSummaryColumn">
					<table>
						<tr>
							<td width="200"><b>${ruleGroupHelpText}</b></td>
							<c:forEach var="roleURI" items="${feature.rolesURIs}">
								<td>								
									<mfs:message var="roleName" key="${roleURI}" escape="none" />
									<mfs:radiobutton id="${roleURI}" name="${feature.featureId}" value="${roleURI}" text="${roleName}" checked="${permissionUriMap[roleURI]}" onclick="scor.auth.setSubFeaturePermissions(this);" />
								</td>
							</c:forEach>
						</tr>
						
						<c:forEach var="subFeature" items="${feature.subFeatures}">
							<tr>
								<mfs:message var="subFeatureName" key="${subFeature.featureId}" escape="HTML" />
								<td width="200">${subFeatureName}</td>
								<c:forEach var="roleURI" items="${subFeature.rolesURIs}">
								<td>									
									<mfs:radiobutton id="${roleURI}" name="${subFeature.featureId}" value="${roleURI}" checked="${permissionUriMap[roleURI]}" />
								</td>
								</c:forEach> 
							</tr>
						</c:forEach>        				
					</table>
					</td>
   				 </c:when>
   				 
				<c:otherwise>
					<td class="orionSummaryHeader">${featureName}</td>
					<td class="orionSummaryColumn">
					<c:forEach var="roleURI" items="${feature.rolesURIs}">
						<mfs:message var="roleName" key="${roleURI}" escape="none" />
						<mfs:radiobutton id="${roleURI}" name="${feature.featureId}"
							value="${roleURI}" text="${roleName}"
							checked="${permissionUriMap[roleURI]}" />
						<br />
					</c:forEach>
					</td>
				</c:otherwise>
			</c:choose>
		</tr>
	</table>
</c:forEach>
