<!-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ page import="com.mcafee.scor.publisher.PublisherConstants" %>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.PUBLISHERS%>");
</script>
<orion:script context="/core" src="/majic.js"/>
<orion:script context="/core" src="/yui/connection/connection-min.js"/>
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>


<jsp:include page="/common/includejQuery.jsp"/>

<orion:message key="scor.publisher.table.title" var="pubTableTitle"  escape="none"/>
<orion:message key="scor.error.dialogBox.title" var="scorErrorTitle" escape="javascript"/>
<orion:message key="scor.cert.da.issuedTo" var="issuedToH" escape="none"/>
<orion:message key="scor.cert.da.issuedBy" var="issuedByH" escape="none"/>
<orion:message key="scor.cert.da.expDate" var="expDateH" escape="none"/>
<orion:message key="scor.cert.da.binaryName" var="binNameH" escape="none"/>
<orion:message key="scor.cert.da.intendedPurpose" var="intdPurposeH" escape="none"/>
<orion:message key="scor.cert.da.friendlyName" var="frdNameH" escape="none"/>
<orion:message key="scor.publisher.filter.TitleBar" var="pubFilterTitle" escape="none"/>
<orion:message key="scor.publisher.findBtn.Txt" var="findBtnTxt" escape="none"/>
<orion:message key="scor.publisher.usageGrp" var="usageGrp" escape="javascript"/>
<orion:message key="scor.publisher.usagePolicy" var="usagePolicy" escape="javascript"/>
<orion:message key="scor.publisher.checkUsage.title" var="checkUsageTitle" escape="javascript"/>
<orion:message key="scor.publisher.checkUsage.failure" var="checkUsageError" escape="javascript"/>
<orion:message key="scor.publisher.checkUsage.nousage" var="noUsage" escape="javascript"/>
<orion:message key="scor.publisher.search.lbl" var="searchLbl" escape="HTML"/>

<orion:vbox>
		<!-- Search Tab -->
		<orion:box height="83">
	        <orion:titlebar text="${pubFilterTitle}">
	        </orion:titlebar>
	        <table width="100%" height="70%" cellspacing="1px" cellpadding="1px" style="background-color: rgb(235, 235, 235); width: 100%;">
	             <tr>
	            	<td>${searchLbl}
						<orion:radiobutton id="issuedTo_label" name="searchType" value="issuedToCrit"
						text="${issuedToH}" disabled="false" checked="true" onclick="setSearchCriteria('ISSUEDTO')"/>
						<orion:radiobutton id="issuedBy_label" name="searchType" value="issuedByCrit"
						 text="${issuedByH}"  disabled="false" checked="false" onclick="setSearchCriteria('ISSUEDBY')"/>
						<orion:radiobutton id="issuedBy_binName" name="searchType" value="issuedByCrit"
						 text="${binNameH}"  disabled="false" checked="false" onclick="setSearchCriteria('BINNAME')"/>
						 <orion:radiobutton id="issuedBy_Frd" name="searchType" value="issuedByCrit"
						 text="${frdNameH}"  disabled="false" checked="false" onclick="setSearchCriteria('ALTRNAME')"/>
						<input type="hidden" id="pubSearchCrit" value="ISSUEDTO"/>
					</td>
           		 </tr>
	             <tr>
					<td>
						<orion:textbox id="pub_search_str" onchange="scor.utils.reSetInputValue(this.id)"/>
		                               &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		                <orion:button id="search_button" text="${findBtnTxt}" disabled="false" onclick="getCertData()"/>
	                </td>
				</tr>
	        </table>

	    </orion:box>

    	<!--  Publisher Table -->
        <orion:table2 id="publisherTable" 
        				titleText="${pubTableTitle}"
        				registeredTypeUID="SCOR_PUB_ACTIONS" 
        				cellRendererAttr="<%=PublisherConstants.PUBLISHER_CELL_RENDR_ATTR%>"
        				datasourceAttr="<%=PublisherConstants.PUBLISHER_DATASOURCE_ATTR%>" 
        				showCheckboxColumn="true"
        				enableDrilldown="true" 
        				sortColumn="issuedTo" 
        				sortOrder="0"
        				allowExport="true"
        				properties="issuedTo,issuedBy,binaryName,lastMod,friendlyName"/>        
      
 </orion:vbox>

<script type="text/javascript">
	var scor = scor || {};
	scor.publisher = scor.publisher || {};

	scor.publisher.page = (function(){
    	var tab ;
    	return {
        	getTable : function(){
    				return tab;
    			},
			setTable : function(table){
    				tab = table;
    			}
        	}
    	})();

	showAssignements = function(response){
		var resultObj = JSON.parse(response);
		var returnCode = resultObj.returnCode.code;		
		if(returnCode===0){
			OrionCore.setDialogBoxTitle('${checkUsageTitle}');
			var usageResult = resultObj.result;
			var ruleGrps = usageResult.ruleGroups;
			var policy = usageResult.policyNames;
			if(ruleGrps.length === 0 && policy.length ===0){
				showMsg('${noUsage}',false);
				return;
			}
			var ruleUsage="";
			var policyUsage="";
			if(ruleGrps.length !== 0){
				ruleUsage = '${usageGrp} : '+OrionCore.escapeHtml(ruleGrps.join(","));
			}
			if(policy.length !== 0){
				policyUsage = '${usagePolicy} : '+OrionCore.escapeHtml(policy.join(","));
			}
			var msg = "<pre>" + ruleUsage +'\n'+policyUsage +"</pre>";
			showMsg(msg,false);
		}else{
			showMsg('${checkUsageError}',true);
		}
	}
	function setSearchCriteria(type){
		$("pubSearchCrit").value=type;
	}

	function setSearchCriteria(type){
		$("pubSearchCrit").value=type;
	}

    function refreshTable(){
    	scor.publisher.page.getTable().refresh();
    }

    function getCertData(){
        var searchCrit= document.getElementById("pubSearchCrit").value;
        var searchStr = document.getElementById("pub_search_str").value;
        var filter =  searchCrit+":::"+searchStr;
      //setFilter internally reload the table data. Hence no need to call refresh on table.
        scor.publisher.page.getTable().setFilter(filter);
    }

	 function formatDataValue(input){
			if(input === undefined||input ===null){
				return "";
			}
			return input;
	 }


	function showMsg(msg,isError){
	 	if(isError === true){
	 		OrionCore.setDialogBoxTitle('${scorErrorTitle}');
	 	}
	 	OrionCore.showDialogBox(true,msg,OrionCore.DIALOG_OK);
	 	OrionCore.dialogBoxOkHandler=function(){
			refreshTable();
		}
	}
	
    //Search box should be exempted from validation
	function _initPub(){
		scor.publisher.page.setTable(MFSTable.get("publisherTable"));
		//Search box
	    OrionForm.markInputExempt('pub_search_str');
	    //Radio buttons
	    OrionForm.markInputExempt('issuedTo_label');
	    OrionForm.markInputExempt('issuedBy_label');
	    OrionForm.markInputExempt('issuedBy_binName');
	    OrionForm.markInputExempt('issuedBy_Frd');
	    $j('#pub_search_str').keypress(function(e) {
	    	var code = e.keyCode ? e.keyCode : e.which;
	    	if (code === 13) {
	    		getCertData();
	    	}
	    });
	}
    
	OrionCore.addLoadHandler(_initPub);
</script>
