<!-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.publisher.PublisherConstants" %>
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>


<orion:message key="scor.cert.da.issuedTo" var="issuedToH" escape="none"/>
<orion:message key="scor.cert.da.issuedBy" var="issuedByH" escape="none"/>
<orion:message key="scor.cert.da.friendlyName" var="frdNameH" escape="none"/>
<orion:message key="scor.cert.da.binaryName" var="binNameH" escape="none"/>
<orion:message key="scor.publisher.filter.infoTxt" var="pubFilterTitle" escape="HTML"/>
<orion:message key="scor.publisher.findBtn.Txt" var="findBtnTxt" escape="none"/>
<orion:message key="scor.publisher.search.lbl" var="searchLbl" escape="HTML"/>
<orion:message key="scor.publisher.updaterWarnMsg" var="updaterWarnMsg" escape="javascript"/>
<orion:message key="scor.publisher.updaterCheckBoxMsg" var="updaterChkBoxMsg" escape="none"/>
<orion:message key="scor.publisher.updaterTagLabel" var="updaterLabel" escape="HTML"/>
<orion:message key="scor.publisher.updaterHelpText" var="updaterHelpText" escape="HTML"/>
   
<script type="text/javascript">

	function setSearchCriteria(type){
		$("pubSearchCriteria").value=type;
	}
	

	function getCertData(){
	    var searchCrit= document.getElementById("pubSearchCriteria").value;
	    var searchStr = document.getElementById("pub_search_string").value;
	    var filter =  searchCrit+":::"+searchStr;       
	    ScorDialogTable.refresh("publisherTableD", filter, ScorDialogTable.tableParameters["publisherTableD"].visibleRows);
	    ScorDialogTable.beginning('publisherTableD');
	}

    function refreshTable(){            
    	ScorDialogTable.refresh("publisherTableD", null, ScorDialogTable.tableParameters["publisherTableD"].visibleRows);
    }  
   
  function verifySuccess(result){
   	if(result.indexOf("<%=URLConstants.SUCCESS_TEXT%>") === -1){
   		 showMsg(result,true);
   		 return false;
       }        
       return true;
    }

	function resetValue(elmId){
 		var element =  $(elmId);
 		if(element){
 			element.value="";
 		}
 	} 

  function formatDataValue(input){
		if(input === undefined||input ===null){
			return "";
		} 
		return input;
	 }
	
  	function showMsg(msg,isError){
	 	if(isError === true){
	 		OrionCore.setDialogBoxTitle('${scorErrorTitle}');
	 	}
		OrionCore.showDialogBox(true,msg,OrionCore.DIALOG_OK);
	}

	function showUpdaterLabel(addAsUpdater) {
	    if(addAsUpdater.checked) {
	       alert('${updaterWarnMsg}');
	        OrionCore.setEnabledById("pubUpdaterLabel", true);
	    } else {
	        OrionCore.setEnabledById("pubUpdaterLabel", false);
	    }
	}

	
</script>

<orion:vbox>
		<!-- Search Tab -->
		<orion:box height="83">
	        <pre><b>${pubFilterTitle}</b></pre> 
	        <table width="100%" height="70%" cellspacing="1px" cellpadding="1px" style="background:none #D6E4F0; width: 100%;">
	              <tr>
	            	<td>${searchLbl}					
						<orion:radiobutton id="issuedTo_label" name="searchType" value="issuedToCrit" 
						text="${issuedToH}" disabled="false" checked="true" onclick="setSearchCriteria('ISSUEDTO')"/>					
						<orion:radiobutton id="issuedBy_label" name="searchType" value="issuedByCrit"
						 text="${issuedByH}" disabled="false" checked="false" onclick="setSearchCriteria('ISSUEDBY')"/>
						 <orion:radiobutton id="binName_label" name="searchType" value="binNameCrit"
						 text="${binNameH}"  disabled="false" checked="false" onclick="setSearchCriteria('BINNAME')"/>
						  <orion:radiobutton id="frdName_label" name="searchType" value="frdNameCrit"
						 text="${frdNameH}"  disabled="false" checked="false" onclick="setSearchCriteria('ALTRNAME')"/>					
						<input type="hidden" id="pubSearchCriteria" value="ISSUEDTO"/>
					</td>
           		 </tr>
	             <tr>						
					<td>							
						<orion:textbox id="pub_search_string" onchange="scor.utils.reSetInputValue(this.id)"/> 
		                               &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		                <orion:button id="search_button" text="${findBtnTxt}" disabled="false" onclick="getCertData()"/>   
	                </td>				
				</tr>
	        </table>
	
	    </orion:box>
	    
    	<!--  Publisher Search Table -->    			
        <scor:dialogTable id="publisherTableD" cellRendererAttr="<%=PublisherConstants.PUB_DIALOG_CELL_RENDR_ATTR%>"
        datasourceAttr="<%=PublisherConstants.PUB_DIALOG_DATASOURCE_ATTR%>" showCheckboxColumn="true"  paginated="true" 
        properties="issuedTo,issuedBy,friendlyName,binaryName,lastMod" columnWidths="16,18,22,23,20" noRecordsKey="scor.apps.search.publishers.noRecordsFoundMessage"/>


        <table width="100%">
            <tr>
                <td colspan="2">
                    <orion:checkbox id="pubAddAsUpdater" text="${updaterChkBoxMsg}"
                    onclick="showUpdaterLabel(this)"/>
                </td>
            </tr>
            <tr>
                <td>
                    ${updaterLabel}
                </td>
                <td>
                    <orion:textbox id="pubUpdaterLabel" value="" disabled="true" />
                </td>                
            </tr>
            <tr>
                <td colspan="2" style="padding:5px;">
                    ${updaterHelpText}
                </td>                
            </tr>

        </table>
                   
</orion:vbox>
