<%-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<orion:message key="scor.error.dialogBox.title" var="scorErrorDialogBoxTitle" escape="javascript"/>
<orion:message key="scor.cert.da.friendlyName" var="frdNameLbl" escape="HTML"/>
<orion:message key="scor.publisher.upload.infoLbl" var="uploadinfoLbl" escape="HTML"/>
<orion:message key="scor.publisher.upload.title" var="uplTitle" escape="none"/>
<orion:message key="scor.publisher.upload.btn" var="uploadBtn" escape="none"/>
<orion:message key="scor.publisher.cancel.btn" var="cancelBtn" escape="none" />
<orion:message key="scor.publisher.upload.cert.successMsg" var="scorUploadSuccessMsg" escape="javascript"/>
<orion:message key="scor.publisher.issToHeader" var="scorIssuedToHeader" escape="javascript"/>
<orion:message key="scor.publisher.issByHeader" var="scorIssuedByHeader" escape="javascript"/>

<orion:core>
    <orion:corehead>
	<orion:script context="/core" src="/yui/yahoo-dom-event/yahoo-dom-event.js"/>
	<orion:script context="/core" src="/yui/connection/connection-min.js"/>
	<jsp:include page="/common/commonUtils.jsp"/>
	
	
        <script type="text/javascript">
        function initialize()
        {
            OrionForm.setOnSubmitHandler(onUploadButtonClick);
            OrionForm.setOnCancelHandler( onCancel );
            OrionForm.setStateChangeHandler( onFormStateChange);            
            OrionForm.revalidate();
            OrionHelp.setHelpId('${scorUploadCertHelpURL}');
        }


        function onCancel()
        {
        	OrionNavigation.navigate('/SOLIDCORE_META/showSolidcoreConfigurationTabs.do' + scor.actions.getSecTokenParamLq() , false);
        }

        function onFormStateChange( isDirty, isValid )
        {
            OrionCore.setEnabledById("saveButton", isValid && isDirty );
        }
            
        onUploadButtonClick = function(e){
        	
        	scor.utils.fixYUIFileUploadOnIe();
    	    YAHOO.util.Connect.setForm(OrionForm.getForm(), true);

    	    var uploadHandler = {
    	      upload: function(res) {
    		      var result = res.responseText;    		      
    		  		showMsg(result);		  
    	      }
    	    };		   
    	  OrionForm.setEncoding(OrionForm.MULTIPART);
    	  try {
    	  	YAHOO.util.Connect.asyncRequest('POST', "/SOLIDCORE_META/loadCertificate.do", uploadHandler);
    	  } catch(e) { alert ("${uploadException}"); 
    	  }
        };
        
        var scor = scor || {};
        scor.pub = scor.pub || {};
        scor.pub.upload = scor.pub.upload || {};
        scor.pub.upload.onOkSuccess = function() {
        	OrionNavigation.navigate('/SOLIDCORE_META/showSolidcoreConfigurationTabs.do' + scor.actions.getSecTokenParamLq(), false);
        }
        
        function showMsg(result){
        	var resultObj = JSON.parse(result);
        	var resultVO = scor.vos.Result(resultObj);
        	if (resultVO.isFailure()) {
        		OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
        		OrionCore.showDialogBox(true, resultVO.getMsg(), OrionCore.DIALOG_OK);
        	}else{
        		OrionForm.markInputExempt("cert.upload.file");
        		OrionCore.dialogBoxOkHandler = scor.pub.upload.onOkSuccess;
        		var upload_success_msg = '${scorUploadSuccessMsg}: <br/> ${scorIssuedToHeader}: ' +
        				resultObj.result.issuedTo + '<br/> ${scorIssuedByHeader}: ' + resultObj.result.issuedBy;
        		OrionCore.showDialogBox(true, upload_success_msg, OrionCore.DIALOG_OK);
        	}
        }  

        </script>
    	</orion:corehead>
        <orion:corebody onload="initialize()">        
        <orion:navigation/>
        <orion:content>
			<orion:vbox>
			 <orion:titlebar id="uploadTitle" text='${uplTitle}'>
			 </orion:titlebar>	
			  <orion:box id="uplBox" height="auto">
              	  <table width="100%">
			  		<tr>
		  				<td class="orionSummaryHeader">
		  					<b>${uploadinfoLbl}</b>
		  				</td>
					</tr>
					<tr>
						<td class = "orionSummaryColumn">
							<orion:fileupload  id="cert.upload.file"  name="upload.file"  required="true" contentEditable="false"/>	
						</td>				
					</tr>							
				  </table>
              </orion:box>			  	
			  <orion:footerbar>
			      <orion:button id="saveButton" text='${uploadBtn}' onclick="onUploadButtonClick();"/>
			      <orion:button id="cancelButton" text='${cancelBtn}' onclick="onCancel();" />
			  </orion:footerbar>	
			</orion:vbox>			
		</orion:content>     
    </orion:corebody>
</orion:core>
