<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved.  -->
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.rulegroup.RuleGroupConstants" %>
<%@ page import="com.mcafee.scor.policy.PolicyConstants" %>
<%@ page import="com.mcafee.scor.awl.AWLConstants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<orion:script context="/core" src="/majic.js"/>
<jsp:include page="/common/includejQuery.jsp" />

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/vos/profilevos.js"/>

<orion:message key="policy.mon.include" var="include" escape="html"/>
<orion:message key="policy.mon.exclude" var="exclude" escape="html"/>
<orion:message key="scor.policy.cc.groups" var="groups"  escape="none"/>
<orion:message key="scor.mon.policy.addGroup.button.txt" var="addGroup"  escape="none"/>
<orion:message key="scor.mon.policy.deleteGroup.button.txt" var="deleteGroupTxt"  escape="none"/>

<c:set var="WIN_OS" scope="request" value="<%=PolicyConstants.POLICY_OS.WIN.getValue()%>"/>
<c:set var="UNIX_OS" scope="request" value="<%=PolicyConstants.POLICY_OS.UNIX.getValue()%>"/>

<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupUpdaterRules" authToken = "isAuthorizedToViewUpdaterRules"/>
<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupTrustedUserRules" authToken = "isAuthorizedToViewTrustedUserRules"/>

<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupUpdaterRules" authToken = "isAuthorizedToEditUpdaterRules"/>
<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupTrustedUserRules" authToken = "isAuthorizedToEditTrustedUserRules"/>

<%@ include file="../widgets/addGroup.jsp" %>
<%@ include file="../monpolicy/PolicyCommon.jsp" %>

<script type="text/javascript">
    var ccPolDetailedVOs = [];
    var currentListGroupSelected;
    var _itemSelected = function (itemKey, itemLabel)
    {
    	var selectedGroup = OrionCore.unescapeHtml(OrionList.getSelectedItemText("<%=Constants.POLICY_LIST_NAME%>"));
        groupChange(selectedGroup);
    }

    var addNewGroup = function() {
		var queryString;
    <c:if test="${param.osType != null}">
        scorMonOsType = "${orion:escapeJavaScriptString(param.osType)}"
        queryString = "<%=Constants.GROUP_PLATFORM%>" + "=" + scorMonOsType;
    </c:if>

        scor.widgets.addGrp.scorAddNewGrps("<%=RuleGroupConstants.RULE_GROUP_TYPES.CHANGE_CONTROL.getValue()%>", scorCCPolicyGetRulesSuccess, queryString);
    }

    var scorCCPolicyGetRulesSuccess = function (result) {
        addNewCCPolicyGroups(result);
        myEpoEnableApplyButton();
    }

    var deleteGroup = function () {
        scor.widgets.deleteSelectedGrp("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", onDeleteGroup);
    }
    var onDeleteGroup = function(deletedObj) {
        var i, indexToDelete;
        var groupName = OrionCore.unescapeHtml(deletedObj.text);

        for (i = 0; i < ccPolDetailedVOs.length; i++) {
            var ccPolDetailedVO = ccPolDetailedVOs[i];
            if (groupName === ccPolDetailedVO.common.getProperty("groupName")) {
                indexToDelete = i;
                break;
            }
        }

        if (typeof indexToDelete === 'number') {
            ccPolDetailedVOs.splice(indexToDelete, 1);
        }
        scor.widgets.policyVOs = ccPolDetailedVOs;
    }
    var addNewCCPolicyGroups = function(newGroups) {
        var i;
        for (i = 0; i < newGroups.length; i++) {

            var ccPolDetailedVO = getCcPolDetailedVOFromJson(newGroups[i]);
            var groupName = ccPolDetailedVO.common.getProperty("groupName");
            var groupId = ccPolDetailedVO.common.getProperty("id");
            if ( ! scor.widgets.addGrp.isExist(groupId, "<%=Constants.POLICY_LIST_NAME%>") ) {
                ccPolDetailedVOs.push(ccPolDetailedVO);
                //No need to send 4th parameter in addNewRow function call as this parameter is needed when initializing page and policy VO has RGs that do not exist.
                addNewRow("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", groupName, groupId);
            }
        }
        scor.widgets.policyVOs = ccPolDetailedVOs;
    }


    function addNewRow(listName, listGroupName, groupName, groupId, counterObj) {
        var groupNameEscapedHTML = OrionCore.escapeHtml(groupName);
        var key = groupId;
        if(key === <%=PolicyConstants.DEFAULT_GROUP_ID_WHEN_RULE_GROUP_NOT_EXIST%>){
        	counterObj.increment();
        	key = "CC_empty." + counterObj.getCounter();      		
         }
        var item = {"key":key, "label": groupNameEscapedHTML};
        OrionList.insertRow(listName, item, listGroupName);
        return key;
    }

    function fnAddRpPathFilterCallback()
    { 
    	fnAddEditRpPathFilterCallback(false);
    }
    function fnEditRpPathFilterCallback()
    { 
      var selectedRow = rppathFilterList.selrow;
	  if(selectedRow){
		  fnAddEditRpPathFilterCallback(true);
	   } else{
	      return;
	        }
	 }
    function fnAddEditRpPathFilterCallback(isEdit){
    	var dialogBoxTitle;
    	if(isEdit){
    	   dialogBoxTitle='<orion:message key="policy.mon.file.edit.filters" escape="javascript"/>';
    	}
    	else{
    	   dialogBoxTitle='<orion:message key="policy.mon.file.add.filters" escape="javascript"/>';
    	}
        fnCommonAddEditFilterCallback(scor.ccpolicy.validation.isPathFilterValid, dialogBoxTitle, rppathFilterList);
    }    
    
</script>

<orion:hbox height="auto">
    <orion:vbox id="ccPolicyListBox" width="250">

        <orion:titlebar id="listTitle" text="${groups}"/>
        <orion:list id="<%=Constants.POLICY_LIST_NAME%>" context="<%=Constants.WEB_APP_NAME%>"
                    contentURI="<%=URLConstants.CC_GROUPS_LIST%>"/>
        <script type="text/javascript">
            OrionList.setSelectRowHandler(_itemSelected);
        </script>

        <orion:listbuttonarea>
            <orion:button id="scorCCAddGroup" text="${addGroup}"
                          onclick="addNewGroup();"/>
            <orion:button id="scorCCPolicyDeleteGroup" text="${deleteGroupTxt}"
                          onclick="deleteGroup();"/>
        </orion:listbuttonarea>
        <script type="text/javascript">
            (function() {
                if ("${epoReadOnlyPolicyObject}" === "true") {
                    var addButton = new Button("scorCCAddGroup");
                    addButton.setEnabled(false);
                }
            }());
        </script>

    </orion:vbox>

    <orion:vdivider id="scorCCdivider" resizeTarget="ccPolicyListBox"/>
    <orion:vbox>
        <orion:box id="idTab" height="24"/>     
        <orion:box id="read-protect">
            <table cellspacing="0" cellpadding="0" width="98%">
                <tr>
                    <td class="orionSummaryColumn">
                        <table cellspacing='3' cellpadding='0' width='620px'>
                            <tr>
                                <td width="10%"><b><orion:message key="policy.mon.filter"
                                                                  escape="html"/></b></td>
                                <td width="90%"><b><orion:message key="scor.policy.cc.file"
                                                                  escape="html"/></b>
                                </td>
                            </tr>
                        </table>
                        <orion:box id="rpidPathFilterList" height="auto" width="620"/>
                    </td>
                </tr>
            </table>
        </orion:box>
            <jsp:include page="./ccPathFilters.jsp"/>
        <orion:box id="wpreg">
            <table cellspacing="0" cellpadding="0" width="98%">
                <%@ include file="../AdjustOtherTabs.jsp" %>
                <tr>
                    <td class="orionSummaryColumn">
                        <table cellspacing='3' cellpadding='0' width='620px'>
                            <tr>
                                <td width="10%"><b><orion:message key="policy.mon.filter"
                                                                  escape="html"/></b></td>
                                <td width="90%"><b><orion:message key="scor.policy.cc.registry"
                                                                  escape="html"/></b>
                                </td>
                            </tr>
                        </table>
                        <orion:box id="idRegistryFilterList" height="auto" width="620"/>
                    </td>
                </tr>
            </table>
        </orion:box>
        <jsp:include page="../awl/_updaters.jsp"/>
         <c:if test="${param.osType == WIN_OS}">
            <jsp:include page="../awl/trustedUsers.jsp"/>
        </c:if>

    </orion:vbox>

</orion:hbox>
<script type="text/javascript">
    var rppathFilterList = new majic.ListWidget({
        container: "rpidPathFilterList",
        width: "620px",
        height: "320px",
        addCallback: fnAddRpPathFilterCallback,
        editCallback: fnEditRpPathFilterCallback,
        removeCallback: myEpoEnableApplyButton,
        buttons: {
            'add': '<orion:message key="policy.mon.button.add" escape="javascript"/>',
            'edit': '<orion:message key="policy.mon.button.edit" escape="javascript"/>',
            'remove': '<orion:message key="policy.mon.button.remove"  escape="javascript"/>'
        },
        content: $('rp_path_filter_editor_template').innerHTML,
        displayText: $('filter_list_row_template').innerHTML,
	formatCallback: listWidgetformatCallback 
    });
    var registryFilterList = new majic.ListWidget({
        container: "idRegistryFilterList",
        width: "620px",
        height: "320px",
        addCallback: fnAddRegistryFilterCallback,
        editCallback: fnEditRegistryFilterCallback,
        removeCallback: myEpoEnableApplyButton,
        buttons: {
            'add': '<orion:message key="policy.mon.button.add"  escape="javascript"/>',
            'edit': '<orion:message key="policy.mon.button.edit" escape="javascript"/>',
            'remove': '<orion:message key="policy.mon.button.remove"  escape="javascript"/>'
        },
        content: $('registry_filter_editor_template').innerHTML,
        displayText: $('filter_list_row_template').innerHTML,
	formatCallback: listWidgetformatCallback 
    });

    function fnSetTabStrip()
    {
        var tabSwapper = new majic.SwapTabStrip("idTab", {
            "read-protect": {
                title: '<orion:message key="scor.policy.cc.rp" escape="javascript"/>',
                callback:function(){OrionHelp.setHelpId("<%=HelpConstants.CHANGE_CONTROL_POLICY_READ_PROTECT%>");}
            },"wpfile": {
                title: '<orion:message key="scor.policy.cc.wp.file" escape="javascript"/>',
                callback:function(){OrionHelp.setHelpId("<%=HelpConstants.CHANGE_CONTROL_POLICY_WRITE_PROTECT_FILE%>");}
            },
            <c:if test="${param.osType == WIN_OS}">
            "wpreg": {
                title: '<orion:message key="scor.policy.cc.wp.reg" escape="javascript"/>',
                callback:function(){OrionHelp.setHelpId("<%=HelpConstants.CHANGE_CONTROL_POLICY_WRITE_PROTECT_REGISTRY%>");}
            },
            </c:if>

            "<%=AWLConstants.updaterTabId%>": {
                title: '<orion:message key="scor.policy.cc.updaters" escape="javascript"/>',
                callback:function(){OrionHelp.setHelpId("<%=HelpConstants.APPLICATION_CONTROL_POLICY_UPDATERS%>");}
            }
            <c:if test="${param.osType == WIN_OS}">
            ,"trustedUsersTabId": {
                title: '<orion:message key="scor.policy.cc.trustedUsers" escape="javascript"/>',
                callback:function(){OrionHelp.setHelpId("<%=HelpConstants.APPLICATION_CONTROL_POLICY_TRUSTED_USERS%>");}
            }
            </c:if>
            
        });

        <c:if test="${param.osType == UNIX_OS}">
            $('wpreg').style.display = 'none';
        </c:if>

        <c:if test = "${isAuthorizedToViewUpdaterRules == false}">
			$j('#tab_updaterTabId').hide();	
		</c:if>	


		<c:if test = "${isAuthorizedToViewTrustedUserRules == false}">
			$j('#tab_trustedUsersTabId').hide();	
		</c:if>	

		$j('[id^="tab_"]:visible').each(
				function( index ) {
					if(index === 0){
						tabSwapper.swap($(this.id));
					}
			});
    }

    OrionCore.addLoadHandler(fnSetTabStrip);
</script>

<script type="text/javascript">

    var getVoFor = function (list)
    {
        var vo = [];

        var rows = list.getRows();
        for (var rowKey in rows)
        {
            var row = rows[rowKey];
            if (row != null && row != undefined)
            {
                vo.push({"field": OrionCore.trim(row['field']), "filter" : ( OrionCore.trim(row['filter']) == "Include" ? "Include" : "Exclude") });
            }
        }
        return vo;
    }

    function savePrevGroupData() {
        var rpFiles = getVoFor(rppathFilterList) ;
        var wpRegs = getVoFor(registryFilterList) ;
        var wpFiles = getVoFor(ccPathFilterList) ;
        var updaters = scor.rg.awl.updaters.getUpdaters();
        
        <c:if test="${param.osType == WIN_OS}">
	        var trustedUsers = getTrustedUsers();
	        var trustedGroups = getTrustedGroups();
        </c:if>

        var i;
        for (i = 0; i < ccPolDetailedVOs.length; i++) {
            var ccPolDetailedVO = ccPolDetailedVOs[i];
            if (currentListGroupSelected === ccPolDetailedVO.common.getProperty("groupName")) {
                ccPolDetailedVO.common.setProperty("rpFiles", rpFiles);
                ccPolDetailedVO.common.setProperty("wpRegs", wpRegs);
                ccPolDetailedVO.common.setProperty("wpFiles", wpFiles);
                ccPolDetailedVO.common.setProperty("updaters", updaters);
                <c:if test="${param.osType == WIN_OS}">
		                ccPolDetailedVO.common.setProperty("trustedUsers", trustedUsers);
		                ccPolDetailedVO.common.setProperty("trustedGroups", trustedGroups);
                </c:if>
                break;
            }
        }
    }
    var _applyPolicySuccess = function ()
    {
        fnGoBack(); // This is a Mercury function and recommended.
    }

    var epoApplyPolicySettings = function  ()
    {
        if (currentListGroupSelected) {
            savePrevGroupData();
        }

        var jsonVo = [];
        for (i = 0; i < ccPolDetailedVOs.length; i++) {
            jsonVo.push(ccPolDetailedVOs[i].common.getVO());
        }

        var ccPolVosJSON = JSON.stringify(jsonVo);
        scor.actions.doAsyncAction("<%=URLConstants.SAVE_CC_POLICY_URL%>", ["<%=Constants.SCOR_CC_POLICY_DATA_JSON%>", ccPolVosJSON], _applyPolicySuccess);
    }
    var getCcPolDetailedVOFromJson = function(jsonData) {
        var id = jsonData['id'];
        var groupName = jsonData['groupName'];
        var platform = jsonData['platform'];
        var type = jsonData['type'];
        var readOnly = jsonData['readOnly'];

        var wpFiles = jsonData['wpFiles'];
        var wpRegs = jsonData['wpRegs'];
        var rpFiles = jsonData['rpFiles'];
        var updaters = jsonData['updaters'];
        var trustedGroups = jsonData['trustedGroups'];
        var trustedUsers = jsonData['trustedUsers'];

        var vo = scor.vos.profile.cc.CCPolicyDetailedVO(id, groupName, platform, readOnly, type, wpFiles, wpRegs, rpFiles, updaters, trustedGroups, trustedUsers);

        return vo;
    }

    var fillList = function (obj, list)
    {
        scor.utils.clearMagicListWidget(list);

        obj = obj ? obj : {}
        for (var i = 0; i < obj.length; i++)
        {
            var newObj = {"field" : obj[i].field, "filter" : (obj[i].filter == "Include" ? "Include" : "Exclude") }
            list.insert(newObj);
        }
    }

</script>


<script type="text/javascript">
    var setReadOnly = function(readOnly) {
        var enable = !readOnly;

        <c:if test = "${isAuthorizedToViewUpdaterRules == true}">	
    		enableUpdaterList(enable && ${isAuthorizedToEditUpdaterRules});
    	</c:if>
    	
        <c:if test="${param.osType == WIN_OS}">
	        <c:if test = "${isAuthorizedToViewTrustedUserRules == true}">
	        	enableTrustedUsersList(enable && ${isAuthorizedToEditTrustedUserRules});    
	        </c:if>
        </c:if>

        if (rppathFilterList != null) {
            rppathFilterList.setEnabled(enable)
        }

        if (ccPathFilterList != null) {
        	ccPathFilterList.setEnabled(enable)
        }

        if (registryFilterList != null) {
            registryFilterList.setEnabled(enable)
        }

        // "Delete group" button
        var removeButton = new Button("scorCCPolicyDeleteGroup");
        removeButton.setEnabled(false); //reset to disabled first

        if ("${epoReadOnlyPolicyObject}" === "false") {
            removeButton.setEnabled(!enable); // Only the "Ungrouped" group is editable. UI shouldn't allow to remove this group.
        }

    }

    var doReadOnly = function (forcedReadOnly) {


        if ("${epoReadOnlyPolicyObject}" === "true") {  // have to disable the policy if this
            forcedReadOnly = true;                      // condition is met irrespective of forcedReadOnly's value
        }                                               //so setting forcedReadOnly to true

        setReadOnly(forcedReadOnly);
    }

    function getCCVoFor(groupName) {
        var i;
        for (i = 0; i < ccPolDetailedVOs.length; i++) {
            var ccPolDetailedVO = ccPolDetailedVOs[i];
            if (groupName === ccPolDetailedVO.common.getProperty("groupName")) {
                return ccPolDetailedVO.common.getVO();
            }
        }

        return null; //no match found

    }

    <c:if test="${scorCCPolicyDataJSON != null}">
    var jsonData = JSON.parse('${orion:escapeJavaScript(scorCCPolicyDataJSON)}');

    (function() {
        var i;
        for (i = 0; i < jsonData.length; i++) {
            var ccPolDetailedVO = getCcPolDetailedVOFromJson(jsonData[i]);
            ccPolDetailedVOs.push(ccPolDetailedVO);
        }
        scor.widgets.policyVOs = ccPolDetailedVOs;
    }());
    </c:if>
    function initUI() {
    	var scorCCNonExistentRGCounterObj = scor.utils.counter(0);
        var i;

        for (i = 0; i < ccPolDetailedVOs.length; i++) {
            var ccPolDetailedVO = ccPolDetailedVOs[i];          
            var groupName = ccPolDetailedVO.common.getProperty("groupName");
            var groupId = ccPolDetailedVO.common.getProperty("id");
            addNewRow("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", groupName, groupId, scorCCNonExistentRGCounterObj);
        }

        //make initial call
        OrionList.setSelectedItem("<%=Constants.POLICY_LIST_NAME%>", 0);
        groupChange(OrionList.getSelectedItemText("<%=Constants.POLICY_LIST_NAME%>"));

    }

    function groupChange(groupName) {

        if (currentListGroupSelected === groupName) {
            return;
        }

        if (currentListGroupSelected) {
            savePrevGroupData();
        }

        currentListGroupSelected = groupName;

        var ccVO = getCCVoFor(groupName);

        if (ccVO) {

            var wpFiles = ccVO['wpFiles'];
            var wpRegs = ccVO['wpRegs'];
            var rpFiles = ccVO['rpFiles'];
            var updaters = ccVO['updaters'];
<c:if test="${param.osType == WIN_OS}">
            var trustedGroups = ccVO['trustedGroups'];
            var trustedUsers = ccVO['trustedUsers'];
</c:if>
            var readOnly = (ccVO['readOnly'] === "true") ? true : false;


            fillList(wpFiles, ccPathFilterList);
            fillList(rpFiles, rppathFilterList);
            fillList(wpRegs, registryFilterList);
            scor.rg.awl.updaters.populateUpdaters(updaters, ccVO['type']);
            <c:if test="${param.osType == WIN_OS}">
            rePopulateTrustedUsersGroups(trustedUsers, trustedGroups);
            </c:if>
        }
        doReadOnly(readOnly);   //now set accordingly
    }


    OrionCore.addLoadHandler(initUI);

</script>

<script type="text/javascript">
    <%-- functions to support group management --%>
    var scor;
    scor = scor || {};
    scor.grpMgmt = scor.grpMgmt || {};
    scor.ccpolicy = scor.ccpolicy || {};
    scor.ccpolicy.validation = scor.ccpolicy.validation || {};
    scor.widgets.policyVOs = scor.widgets.policyVOs || [];

    scor.grpMgmt.loadGroup = function(group) {
        var itemKey, groupName, groupId;

        if (!group) {
            return;
        }

        groupName = group['groupName'];
        groupId = group['id'];
        addNewCCPolicyGroups([group]);
      //No need to send 4th parameter in addNewRow function call as this parameter is need when initializing page and policy VO has RGs that do not exist.
        itemKey = addNewRow("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", groupName, groupId);
        groupChange(groupName);
        OrionList.setSelectedItem("<%=Constants.POLICY_LIST_NAME%>", itemKey);
    }


    scor.grpMgmt.adjustUiItems = function() {
        $('ccPolicyListBox').style.display = "none";
        $('scorCCdivider').style.display = "none";
		<c:if test="${param.osType == WIN_OS}">
			adjustGroupUIEnableSearchGroup();
		</c:if>
    }


    scor.grpMgmt.getGroup = function() {
        savePrevGroupData();
        return ccPolDetailedVOs[0].common.getVO();
    }
    scor.ccpolicy.validation.isPathFilterValid = function (onOkClick, os) {
        var isValid = true;
        var msg = "";
        var fieldElement = scor.utils.GetElementFromDialogBox('field','input');
        var fieldValue = $j.trim(fieldElement.value);  
        var validationObj = scor.validation.emptyValidater(fieldElement);
        if(validationObj.getIsValid()){
	    	  validationObj = scor.validation.wildCardCCPolicy(fieldValue, os); 
	          scor.common.validation.showWarningOnStarCharactor(validationObj,fieldValue, os); // show warning on entering star characters
	     }
        msg = validationObj.msg;
        isValid = validationObj.isValid;
        handleError(isValid, msg);
        OrionCore.enableDialogBoxOkButton(isValid);
        return isValid;
    }

</script>
