<!-- COPYRIGHT:		Copyright (C) 2019 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>


<orion:message key="scor.cpe.export.radio.copyClipBoard.text" var="copytoclipboard" escape="html"/>
<orion:message key="scor.cpe.export.xml.button.text" var="xmltext" escape="html"/>
<orion:message key="scor.cpe.export.xml.otherFieldCpeValue.text" var="otherValue" escape="html"/>
<orion:message key="scor.cpe.exportCustomDictionary.dialog.error" var="errorMessage" escape="html"/>

<script>
  //  OrionCore.addLoadHandler(init);
    function getXml(){
        var searchTxt=document.getElementById("otherText").value;
        if(searchTxt!=undefined && searchTxt==="")
        {
            cleanInput();
        }
        else{
            document.getElementById("filterText").style.display="none"
            exportCustomXml();
        }
        return true;
    }
    function exportCustomXml(){
        var selectedIds =  MFSTable.get("cpeTableId").getSelected();
        //var parama = new Array()
        var params = ['selectedIds',selectedIds,'otherText',  $j("#otherText").val()];
        OrionCore.doAsyncFormAction('/SOLIDCORE_META/copyClipboardCustomDictionaryDialog.do', params, exportSuccess, exportFailure);
        return true;
    }
    function exportSuccess(result){
        $j("#txtCpexml").val(result);
        copyStringToClip(result);
        return  true;

    }

    function cleanInput()
    {
        document.getElementById("filterText").style.display="block";
        document.getElementById("txtCpexml").value="";
    }


    function exportFailure( status, results ){
        $j("#txtCpexml").val("");
        document.getElementById("otherText2").style.display="block"
        OrionCore.doAction("/core/showFriendlyErrorMessage.do", [], 'get');
    }

    function copyStringToClip(str) {

        var el = document.createElement('textarea');
        el.value = str;
        el.setAttribute('readonly', '');
        el.style = "{position: 'absolute', left: '-9999px'}";
        document.body.appendChild(el);
        el.select();
        document.execCommand('copy');
        document.body.removeChild(el);
    }

</script>
<table class="orionSummary" width="100%">
    <tbody>
        <tr>
            <td class="orionSum maryHeader">
                <orion:message key="scor.cpe.export.header.text" />
            </td>
            <td class="orionSummaryColumn">
                <!-- no escape needed, since we already escaped it before we sent it to the screen, and there is some required html for warning messages-->
                <c:forEach items="${CopyClipboardCpeInformation}" var="info">
                    ${info}<br>
                </c:forEach>
            </td>
        </tr>
        <tr>
            <td class="orionSummaryHeader">
                    ${copytoclipboard}
            </td>
            <td class="orionSummaryColumn">
                <table>
                    <tr>
                        <td>
                            ${otherValue}
                            <orion:textbox id="otherText" required="true" size="50" maxlength="255"  />
                        </td>
                        <td  align="right">
                            <orion:button id="txtCopy" onclick="getXml();" text="${xmltext}"  />
                        </td>

                    </tr>
                    <tr>
                        <td>
                            <label id="filterText" style="display: none; color:darkred">${errorMessage}</label>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2">
                            <orion:textarea id="txtCpexml" name="description"
                                            maxlength="80000"
                                            value=""
                                            required="false"  cols="50"
                                            rows="20"/>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </tbody>
</table>
