<%-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.event.EventConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<orion:message key="scor.SCOR_EVENTS.aef.editfiltercriteria" var="editFilterCriteria"  escape="none"/>
<orion:message key="scor.SCOR_EVENTS.aef.selectaef" var="selectAef"/>
<orion:message key="scor.SCOR_EVENTS.aef.removeaef" var="removeButtonText" escape="none"/>
<orion:message key="scor.SCOR_EVENTS.aef.updateaef" var="updateButtonText" escape="none"/>
<orion:message key="scor.SCOR_EVENTS.aef.closeaef" var="closeButtonText" escape="none"/>
<orion:message key="scor.SCOR_EVENTS.aef.selectfilterwithvalue" var="selectFilterValue" escape="javascript"/>
<orion:message key="scor.SCOR_EVENTS.aef.invalidfilterconfig" var="notValidAef" escape="javascript"/>


<orion:core>
   <orion:corehead>
	<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
	


<script type="text/javascript">
//	OrionCore.addLoadHandler(onPageLoad);
    var savedxmlstr = "${orion:escapeJavaScript(scorEventAdvancedFilterXML)}";

    function onPageLoad()
    {	OrionHelp.setHelpId("${helpPageId}");
        CriteriaBuilder.setChangeHandler( _onCriteriaChange );
		<c:choose>
    		<c:when test="${!empty criteria_error}">
        		<orion:message key="query_criteria_error_title" var="criteria_error_title"
                       	escape="html" plugin="console"/>
        		OrionCore.dialogBoxOkHandler = loadSavedCriteria;
        		OrionCore.setDialogBoxTitle( "${orion:escapeJavaScriptString(criteria_error_title)}" );
        		OrionCore.showDialogBox(true, "${orion:escapeJavaScriptString(criteria_error)}", OrionCore.DIALOG_OK);
    		</c:when>
   	   		<c:otherwise>
        		loadSavedCriteria();
       		</c:otherwise>
		</c:choose>
    }

    function loadSavedCriteria(){
        CriteriaBuilder.loadSavedCriteria( savedxmlstr );
    }

    function _onCriteriaChange( ){
            //OrionWizard.enableNavigation();
    }

    function updateFilter(){
    	if(!isValidXml()){
    		showSelectFilterWithValueDialog();    		
    		return;
    	}
       
        var paramMap = ["conditionXML", CriteriaBuilder.getCriteriaXML(),"shouldDoIt","true"];
	    OrionCore.doAction("/SOLIDCORE_META/saveEventFilterCriteria.do", paramMap, "POST","_self");	           
     }
     
    function removeFilter(){
        var paramMap = ["conditionXML", CriteriaBuilder.getCriteriaXML()];
	    OrionCore.doAction("/SOLIDCORE_META/removeEventFilterCriteria.do", paramMap, "POST","_self");	           
     }
     
    function closeCriteria(){
        var paramMap = ["conditionXML", CriteriaBuilder.getCriteriaXML()];
	    OrionCore.doAction("/SOLIDCORE_META/navigateToEventsPage.do", paramMap, "POST","_self");	           
     }
     
     function fnSuccess(){
     }
     
     function isValidXml(){
     	var conditionXml = CriteriaBuilder.getCriteriaXML();
     	if(conditionXml === '<conditions></conditions>' || conditionXml ==""){
     		return false;
     	}
     	return true;
     }
     
     function showSelectFilterWithValueDialog(){
        OrionCore.showDialogBox(true, '${selectFilterValue}', OrionCore.DIALOG_OK);
    	OrionCore.setDialogBoxTitle('${notValidAef}');
     }

</script>



   </orion:corehead>
   <orion:corebody onload="onPageLoad()">
      <orion:navigation />
      <orion:content>
<orion:vbox>


        <orion:titlebar text="${editFilterCriteria}" />
<orion:box height="49">
        	<div class="orionDescriptionArea orionBorderBottomGrey">
        		${selectAef}
        					<input type="hidden" id="conditionXML" name="conditionXML" value="" />
			</div>

</orion:box>
         <orion:criteriabuilder context="/SOLIDCORE_META"
                                       listContentURI="loadEventFilterCriteria.do"
                                       emptyText="" />



         <orion:footerbar>
         	<orion:button id="removeButton" text="${removeButtonText}" onclick="removeFilter()"/>
         	<orion:button id="updateButton" text="${updateButtonText}" onclick="updateFilter()"/>
         	<orion:button id="closeButton" text="${closeButtonText}" onclick="closeCriteria()"/>
         </orion:footerbar>

	
</orion:vbox>
      </orion:content>
   </orion:corebody> 
</orion:core> 
