<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved.  -->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://www.mcafee.com/orion/response" prefix="resp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<table>
    <c:if test="${ not empty emailConfigMessage }">
        <tr>
            <td colspan="2" class="errorText">
                ${ orion:escapeHtml( emailConfigMessage ) }
            </td>
        </tr>
    </c:if>
    <tr>
        <td>
            <orion:message key="response.command.sendemail.recipients" plugin="response" />
        </td>
        <td>
            <orion:contacts id="${instanceId}_recipients"
                            name="${instanceId}_recipients"
                            required="true" />
        </td>
    </tr>
    <tr>
        <td>
            <orion:message key="response.command.sendemail.importance" plugin="response" />
        </td>
        <td>
            <orion:select id="${instanceId}_importance"
                		  name="${instanceId}_importance"
                		  items="${importanceItems}" />
        </td>
    </tr>
    <tr>
        <td height="8"></td>
    </tr>
    <tr>
        <td>
            <orion:message key="response.command.sendemail.subject" plugin="response" />
        </td>
        <td>
            <orion:textbox id="${instanceId}_subject"
                		   name="${instanceId}_subject"
                		   size="100" maxlength="250" />
        </td>
    </tr>
    <tr>
        <td></td>
        <td><resp:tokeninsert id="${instanceId}_subject_tk" fieldId="${instanceId}_subject"/></td>
    </tr>
    <tr>
        <td valign="top">
            <orion:message key="response.command.sendemail.body" plugin="response" />
        </td>
        <td>
            <orion:textarea id="${instanceId}_body"
                			name="${instanceId}_body"
                			rows="5"
                            cols="100" />
        </td>
    </tr>
    <tr>
        <td></td>
        <td><resp:tokeninsert id="${instanceId}_body_tk" fieldId="${instanceId}_body"/></td>
    </tr>
</table>

<script type="text/javascript">
ComponentManager.registerComponent(${orion:escapeJavaScriptString(instanceId)}, {

    setData : function(data)
    {
    	$("${orion:escapeJavaScriptString(instanceId)}_subject").value = data.subject;
        $("${orion:escapeJavaScriptString(instanceId)}_importance").value = data.importance;
        $("${orion:escapeJavaScriptString(instanceId)}_recipients").value = data.recipients;
        $("${orion:escapeJavaScriptString(instanceId)}_body").value = data.body;
    },

    getData : function()
    {
        var data = {};
        data["subject"] = $("${orion:escapeJavaScriptString(instanceId)}_subject").value;
        data["importance"] = $("${orion:escapeJavaScriptString(instanceId)}_importance").value;
        data["recipients"] = $("${orion:escapeJavaScriptString(instanceId)}_recipients").value;
        data["body"] = $("${orion:escapeJavaScriptString(instanceId)}_body").value;

        return data;
    }

} );
</script>

