<%-- Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved. --%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<orion:core>
    <orion:corehead/>
    <orion:corebody>
		<orion:navigation/>
        <orion:content>
<%@ page import="com.mcafee.orion.core.OrionCore" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<%@page import="com.mcafee.scor.inventory.InventoryConstants"%>
<%@page import="com.mcafee.scor.imagedev.ImageDevConstants"%>

<%@page import="com.mcafee.scor.imagedev.db.model.ImageDevDetailsModelConstants"%>
<%@page import="com.mcafee.scor.imagedev.db.model.ImageDevDetailsExtendedModelConstants"%>
<%@page import="com.mcafee.scor.imagedev.util.ImageDevDeviationType"%>


<%@page import="com.mcafee.scor.imagedev.ImageDevConstants.IMAGE_DEV_DETAILS_VIEW_TYPES_ENUM"%>
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>


<orion:message var="imageDevTitleText" key="scor.imgdev.page2.titlebar" escape="none"/>
<orion:message var="filterByDevTypeTxt" key="scor.imgdev.page2.filterText" escape="html"/>
<orion:message var="filterByPathTxt" key="scor.imgdev.page2.filterPathText" escape="html"/>
<orion:message var="addedTxt" key="scor.imgdev.added" escape="none"/>
<orion:message var="modifiedTxt" key="scor.imgdev.modified" escape="none"/>
<orion:message var="execMismatchTxt" key="scor.imagedev.execmismatch" escape="none"/>
<orion:message var="deletedTxt" key="scor.imgdev.deleted" escape="none"/>
<orion:message var="updateFilters" key="scor.imagedev.details.updateFilters" escape="none"/>
<orion:message var="viewTypeTitleText" key="scor.imagedev.details.viewTypeTitleText" escape="none"/>
<orion:message var="appsTreeTitle" key="scor.imagedev.details.appsTreeTitle" escape="none"/>
<orion:message var="binaryTableTitle" key="scor.imagedev.details.binaryTableTitle" escape="none"/>
<orion:message var="appDetails" key="scor.reporting.inventory.appView.appTree.button.appDetails" escape="none"/>

		<orion:vbox width="auto"> 
			<orion:titlebar text="${imageDevTitleText}: ${requestScope.targetSystemName}"/>
			<orion:hbox id="imageDevDetailsViewTypeAndFiltersHboxId" height="90">      
				<orion:vbox id="filterVbox" width="auto">
					<orion:hbox>
						<orion:vbox width="250">      
							<orion:box>
								<table height="100%">
	        		     			<tr><td style="font-weight:bold;">&nbsp;${filterByDevTypeTxt}:</td></tr>
									<tr><td style="font-weight:bold;">&nbsp;${filterByPathTxt}:</td></tr>
									<tr><td>&nbsp;</td></tr>
								</table>
							</orion:box>
						</orion:vbox>
						<orion:vbox width="auto"> 
								<table height="40%">
	        		     			<tr><td>
										<orion:checkbox id="addedDeviation" 
											style="margin-left: 0; width: 30;" 
											name="deviationTypes" 
											text="${addedTxt}     "/>
							</td>
							<td>
										<orion:checkbox id="modifiedDeviation" 
											name="deviationTypes" 
											text="${modifiedTxt}     "/>
							</td>
							<td>											
										<orion:checkbox id="execMismatchedDeviation" 
											name="deviationTypes"
											text="${execMismatchTxt}  "/>
							</td>
							<td>											
										<orion:checkbox id="deletedDeviation" 
											name="deviationTypes"
											text="${deletedTxt}     "/>
						            </td></tr>
								</table>
								<table height="60%">
									<tr><td>
										<orion:textbox id="searchFilePath" 
										style="margin-left: 0;" 
										size="50" maxlength="150" 
										value="${requestScope.searchFilePath}"/> 
									</td></tr>
									<tr><td>
							       			<orion:button id="updateFiltersId"  
											text="${updateFilters}" 
											disabled="false" 
											style="margin-left: 0; font-weight:bold;"
											onclick="scor.imagedev.details.getImageDevDetails()"/> 
									</td></tr>
								</table>
						</orion:vbox>
					</orion:hbox>
				</orion:vbox>
				<orion:vbox id="viewTypeVbox" width="250">
					<orion:box>
						<table height="70%" width="90%">
							<tr><td style="font-weight: bold; text-align: right;">
								${viewTypeTitleText}&nbsp;<orion:select id="viewTypeId" style="width: 150;" items="${imageDevDetailsViewTypeList}" 
									onChange="scor.imagedev.details.getImageDevDetails();"/>
							</td></tr>
							<tr><td>&nbsp;</td></tr>
						</table>
					</orion:box>
				</orion:vbox>
			</orion:hbox>      
			
			<orion:hbox id="imageDevDetailsTableContainer" height="auto">
				<!--  Application Tree -->
				<orion:vbox id="imageDevAppListContainer" width="350">
					<orion:titlebar text="${appsTreeTitle}"/>
					
					<orion:tree id="appTreeId" 
						treeDataAttr="<%=InventoryConstants.INVENTORY_TREE_DATA_PROVIDER_ATTR%>" 
						selectable="true" showRootNode="false" persistBranchState="false"/>
					
					<orion:listbuttonarea>
						<orion:button id="addItemButton"  text="${appDetails}" onclick="scor.imagedev.details.getAppId()"/>
					</orion:listbuttonarea>

				</orion:vbox>  
				
				<orion:vdivider id="appBinaryDividerId" resizeTarget="imageDevAppListContainer"/> 
				
				<!-- Binary Table -->
				<orion:vbox width="auto">			 
					<orion:table2 id="imageDevBinaryTableId" titleText="${binaryTableTitle}" 
						cellRendererAttr="<%=ImageDevConstants.SCOR_IMAGE_DEV_DETAILS_CR_ATTR%>" 
						datasourceAttr="<%=ImageDevConstants.SCOR_IMAGE_DEV_DETAILS_DS_ATTR%>" 
						showCheckboxColumn="false" enableDrilldown="false" allowExport="true" allowConfiguration="true" 
						allowAdvancedFilter="true" allowAction="true" showFilters="true" allowFilter="true"
						sortOrder="0" sortColumn="<%=ImageDevDetailsExtendedModelConstants.PROP_DEVIATION_TYPE%>"
						properties="<%=ImageDevDetailsExtendedModelConstants.PROP_FILE_PATH + \",\" +
						ImageDevDetailsExtendedModelConstants.PROP_DEVIATION_TYPE + \",\" + 
						ImageDevDetailsExtendedModelConstants.PROP_TARGET_ENT_TRUST_LEVEL + \",\" +
						ImageDevDetailsExtendedModelConstants.PROP_EFFECTIVE_LEVEL_REASON + \",\" +
						ImageDevDetailsExtendedModelConstants.PROP_TARGET_CLOUD_TRUST_LEVEL + \",\" +
						ImageDevDetailsExtendedModelConstants.PROP_CERTIFICATE_SUBJECT + \",\" +
						ImageDevDetailsExtendedModelConstants.PROP_TARGET_EXEC_ALLOWED%>"
						
						columnWidths="20,10,13,13,14,16,14"/>
				</orion:vbox>
			</orion:hbox>
			<orion:hbox height="35">
				<orion:box>
					<%@ include file="../BackCloseFooter.jsp" %>
				</orion:box>
			</orion:hbox>
		</orion:vbox>
	</orion:content>
    </orion:corebody>
</orion:core>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.IMAGE_DEVIATION_DETAILS_PAGE%>");
</script>
<script type="text/javascript">
	var scor = scor || [];
	scor.imagedev = scor.imagedev || [];
	scor.imagedev.details = scor.imagedev.details || [];

	OrionForm.markInputExempt('searchFilePath');

 	scor.imagedev.details.getAppId = function (node) {
		
		node = OrionTree.getSelectedNode("appTreeId");
		nodeKey = OrionTree.getNodeKey(node);
		nodeKeyArray = nodeKey.split('<%=InventoryConstants.INV_APP_TREE_KEY_DELIMITER%>'); 
		if (nodeKeyArray[0] === '<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>'){
			appId = nodeKeyArray[1];
			if (appId != '<%=InventoryConstants.INV_APP_TREE_OTHER_BINARIES_KEY%>') {
				var paramMap = ["<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>", appId];
				OrionCore.doAction("/SOLIDCORE_META/showAppDetails.do", paramMap, "GET","_self");
			}	 
		}	
	};


	scor.imagedev.details.getImageDevDetails = function () {
		var deviationTypes = [];
		if ($('addedDeviation').checked) {
			deviationTypes.push('<%=ImageDevDeviationType.ADDED%>');
		}
		if ($('modifiedDeviation').checked) {
			deviationTypes.push('<%=ImageDevDeviationType.MODIFIED%>');
		}
		if ($('execMismatchedDeviation').checked) {
			deviationTypes.push('<%=ImageDevDeviationType.EXEC_ALLOWED_MISMATCH%>');
		}
		if ($('deletedDeviation').checked) {
			deviationTypes.push('<%=ImageDevDeviationType.DELETED%>');
		}
		
		var searchFilePath = $('searchFilePath').value;

		var viewType = $('viewTypeId').value;
		
		var searchFilters = new Array();

		searchFilters.push (JSON.stringify(deviationTypes));
		searchFilters.push (searchFilePath);
		var searchCriteria = searchFilters.join('<%=ImageDevConstants.JSON_PARAMS_DELIMITER%>');
		
		var paramMap = new Array();
		paramMap.push ("<%=ImageDevConstants.TARGET_SYSTEM_AGENT_GUID%>");
		paramMap.push ('${orion:escapeJavaScript(requestScope.targetSystemAgentGUID)}');
		paramMap.push ("<%=ImageDevConstants.SEARCH_CRITERIA%>");
		paramMap.push (searchCriteria);
		paramMap.push ("<%=ImageDevConstants.IMAGE_DEV_DETAILS_VIEW_TYPE%>");
		paramMap.push (viewType);
		
		
		OrionCore.doAction("/SOLIDCORE_META/showImageDevDetails.do", paramMap , 'GET', '_self');   
	};

	scor.imagedev.details.fetchBinaries = function (selectedNodePath) {
		var searchCriteria = '${orion:escapeJavaScript(requestScope.searchCriteria)}';
		var jsonData = searchCriteria.split('<%=ImageDevConstants.JSON_PARAMS_DELIMITER%>');

		var filters = new Array();
		filters.push ('${orion:escapeJavaScript(requestScope.targetSystemAgentGUID)}');
		filters.push (jsonData[0]);
		filters.push (jsonData[1]);
		filters.push ('${orion:escapeJavaScript(requestScope.imageDevDetailsViewType)}');
		filters.push (JSON.stringify(selectedNodePath));
		
		var searchFilter = filters.join('<%=ImageDevConstants.JSON_PARAMS_DELIMITER%>');

		var binaryTable = MFSTable.get("imageDevBinaryTableId");
		binaryTable.setFilter(searchFilter);
	
	};
	
	scor.imagedev.details.appSelected = function (node) {
		OrionCore.setEnabledById("addItemButton", false); 
		var nodeKeyArray = OrionTree.getNodeKey (node).split('<%=InventoryConstants.INV_APP_TREE_KEY_DELIMITER%>');

		var selectedNodePath = new Array();
		if (nodeKeyArray[0] != '<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>') {
			selectedNodePath.push(nodeKeyArray[0]);
		} else {
		 
			selectedNodePath = OrionTree.getNodePath(node).split(OrionTree.PATH_DELIMITER);
			
			if(!(isNaN(parseInt(nodeKeyArray[1])))){ 
				OrionCore.setEnabledById("addItemButton", true); 
			} 
		}

		scor.imagedev.details.fetchBinaries (selectedNodePath);
	};

	scor.imagedev.details.initUI = function () {
		OrionTree.setSelectHandler( scor.imagedev.details.appSelected );

		var searchCriteriaAttr = '${orion:escapeJavaScript(requestScope.searchCriteria)}';
		var jsonData = searchCriteriaAttr.split("<%=ImageDevConstants.JSON_PARAMS_DELIMITER%>");

		deviationTypes = JSON.parse(jsonData[0]);

		for (var i = 0; i < deviationTypes.length; i++) {
			if (deviationTypes[i] === '<%=ImageDevDeviationType.ADDED%>') {
				$('addedDeviation').checked = true;
			} else if (deviationTypes[i] === '<%=ImageDevDeviationType.MODIFIED%>') {
				$('modifiedDeviation').checked = true;
			} else if (deviationTypes[i] === '<%=ImageDevDeviationType.EXEC_ALLOWED_MISMATCH%>') {
				$('execMismatchedDeviation').checked = true;
			} else if (deviationTypes[i] === '<%=ImageDevDeviationType.DELETED%>') {
					$('deletedDeviation').checked = true;
			}
		}

		$('searchFilePath').value = jsonData[1]; 

		var viewTypeVal = '${orion:escapeJavaScript(requestScope.imageDevDetailsViewType)}'; 

		if (viewTypeVal === '<%=ImageDevConstants.IMAGE_DEV_DETAILS_VIEW_TYPES_ENUM.APPS.getValue()%>') {
			$('viewTypeId').selectedIndex = 0;			
			$('imageDevAppListContainer').style.display = "";
			$('appBinaryDividerId').style.display = "";

			var selectedNodePath = JSON.parse('${orion:escapeJavaScript(requestScope.appTreeNodePath)}').join(OrionTree.PATH_DELIMITER);
			OrionTree.expandToPath('appTreeId', selectedNodePath);
		} else {
			$('viewTypeId').selectedIndex = 1;
			$('imageDevAppListContainer').style.display = "none";
			$('appBinaryDividerId').style.display = "none";

			scor.imagedev.details.fetchBinaries('');

			OrionForm.markInputExempt("addedDeviation");
			OrionForm.markInputExempt("modifiedDeviation");
			OrionForm.markInputExempt("execMismatchedDeviation");
			OrionForm.markInputExempt("deletedDeviation");
			OrionForm.markInputExempt("searchFilePath");
			OrionForm.markInputExempt("viewTypeId");
		}
	};

	OrionCore.addLoadHandler(scor.imagedev.details.initUI);
	
</script>
