<%-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved.  --%>
<%@ page import="com.mcafee.scor.common.URLConstants"%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@ page import="com.mcafee.orion.core.OrionCore" %>
<%@ page import="com.mcafee.scor.inventory.InventoryConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<%
	request.setAttribute("ALLOW_BAN_BINARIES_CANCEL_UI_URL", URLConstants.ALLOW_BAN_BINARIES_CANCEL_UI_URL + request.getAttribute("scor_csrf_param_lq"));
%>

<orion:core>
	<orion:corehead />
	<orion:corebody>
		<orion:navigation />
		<orion:content>
			<script type="text/javascript">
                OrionHelp.setHelpId("${scorInvAllowBanBinaryHelpPageId}");
            </script>
			<orion:script context="/core" src="/majic.js"/>
			<orion:script context="/core" src="/corebundle.js" />
			<orion:script context="/core" src="/core.js" />
			<orion:script context="/core" src="/formlib.js" />
			<orion:script context="/core" src="/wizardlib.js" />
			<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>" />
			
			<orion:message key="scor.inventory.allowban.wizardTitle" var="allowBanBinaryWizardTitle" escape="none" />
			<orion:message key="scor.inventory.allowBan.wizard.allowBinariesTxt" var="allowBinariesTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.banBinariesTxt" var="banBinariesTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.addToWhitelistTxt" var="addToWhitelistTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.addToRuleGroupTxt" var="addToRuleGroupTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.rulegroup.none" var="noneRuleGroup" escape="javascript"/>
			<orion:message key="scor.inventory.allowBan.wizard.selectRuleGroupTxt" var="selectRuleGroupTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.userDefinedRuleGroupsOnlyNoteTxt" 
				var="userDefinedRuleGroupsOnlyNoteTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.createRuleGroupTxt" var="createRuleGroupTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.newRuleGroupNameTxt" var="newRuleGroupNameTxt" escape="html"/>
			<orion:message key="scor.inventory.allowBan.wizard.platformTxt" var="platformTxt" escape="html"/>
			<orion:message key="scor.inventory.allowban.wizard.ruleGroupAlreadyExists" var="ruleGroupAlreadyExists" escape="html" />
			
			<c:set var="invPageSource" value="${orion:escapeHtml(requestScope.invPageSource)}" scope="request"/>
			<c:set var="allowBanActionType" value="${orion:escapeHtml(requestScope.allowBanActionType)}" scope="request"/>
			<c:set var="ruleGroupRadio" value="${orion:escapeHtml(requestScope.ruleGroupRadio)}" scope="request"/>
			<c:set var="selectedRuleGroupId" value="${orion:escapeHtml(requestScope.selectedRuleGroupId)}" scope="request"/>
			<c:set var="newRuleGroupName" value="${orion:escapeJavaScript(requestScope.newRuleGroupName)}" scope="request"/>
			<c:set var="allowBanBinaryValidationResult" value="${orion:escapeHtml(requestScope.allowBanBinaryValidationResult)}" 
				scope="request"/>
			
			<script type="text/javascript">
				var invPageSource = '<c:out value="${invPageSource}" />';
				var allowBanActionType = '<c:out value="${allowBanActionType}" />';
				var ruleGroupRadio = '<c:out value="${ruleGroupRadio}" />';
				var selectedRuleGroupId = '<c:out value="${selectedRuleGroupId}" />';
				var newRuleGroupName = '<c:out value="${newRuleGroupName}" />';
				var allowBanBinaryValidationResult = '<c:out value="${allowBanBinaryValidationResult}" />';
				
			</script>


			<orion:vbox>
				<orion:box id="allowBanBinaryWizardDiv" height="24">
					<orion:wizard id="allowBanBinaryWizard" currentStep="selectRuleGroup" 
					wizardInfo="${allowBanBinaryWizardInfo}" 
					text="${allowBanBinaryWizardTitle}" cancelURI="${ALLOW_BAN_BINARIES_CANCEL_UI_URL}" editMode="false" />
				</orion:box>

				<orion:box id="selectRuleGroupDiv">
					<table style="height: auto; width: 50%;">
			 			<c:choose>
			 				<c:when test="${allowBanActionType == 'allow'}">
							 	<tr><td> <b>${allowBinariesTxt}</b> </td></tr>
			 				</c:when>
			 				<c:when test="${allowBanActionType == 'ban'}">
							 	<tr><td> <b>${banBinariesTxt}</b> </td></tr>
					 		</c:when>
			 			</c:choose>
						<c:choose>
							<c:when test="${(invPageSource != 'invPageSourceApp') && (allowBanActionType == 'allow')}">
								<tr><td>
									<input type="radio" name="ruleGroupRadio" id="addToWhitelist" 
										value="addBinariesToWhitelist" onclick="scor.inventory.wizard.allowBanBinary.showRuleGroupConfig();" />
									<label>${addToWhitelistTxt}</label>
								</td></tr>
							</c:when>
						</c:choose>
						<tr><td>
							<input type="radio" id="addToRuleGroupRadio" name="ruleGroupRadio" value="existingRuleGroup" 
								onclick="scor.inventory.wizard.allowBanBinary.showRuleGroupConfig();"/>
							<label>${addToRuleGroupTxt} </label>
						</td></tr>	
						<tr id="addToRuleGroupConfigRow1" style="display:none;">
							<td width="70%"> 
								&nbsp;&nbsp;&nbsp;
								<label>${selectRuleGroupTxt}: </label> 
							</td>
							<td width="30%"> <label>${platformTxt}:</label> </td>					
						</tr>
						<tr id="addToRuleGroupConfigRow2" style="display:none;">
							<td width="70%"> 
								&nbsp;&nbsp;&nbsp;
								<orion:select id="addToRuleGroup" name="selectedRuleGroupId" items="${ruleGroups}"/>
							</td>
							<td width="30%">
								<orion:select id="existingRuleGroupOS" items="${existingRuleGroupPlatforms}" 
									name="existingRuleGroupOS" onchange="scor.inventory.wizard.allowBanBinary.fetchRuleGroupsByPlatform();"/>
							</td>
						</tr>
						<tr id="ruleGroupNote" style="display:none;">
							<td> <label style="color:red;">${userDefinedRuleGroupsOnlyNoteTxt}</label> </td>
						</tr>
						
						<tr><td>
							<input type="radio" id="createRuleGroupRadio" name="ruleGroupRadio" 
								value="newRuleGroup" onclick="scor.inventory.wizard.allowBanBinary.showRuleGroupConfig();"/>
							<label>${createRuleGroupTxt} </label>
						</td></tr>
						<tr id="createRuleGroupConfigRow1" style="display:none;">
							<td width="70%">    
								&nbsp;&nbsp;&nbsp;
								<label>${newRuleGroupNameTxt}:</label>
							</td>
							<td width="30%"> <label>${platformTxt}:</label> </td>
						</tr>
						<tr id="createRuleGroupConfigRow2" style="display:none;">
							<td width="70%">
								&nbsp;&nbsp;&nbsp;
								<orion:textbox id="newRuleGroupName" name="newRuleGroupName" value="" 
									maxlength="255" onChange="scor.inventory.wizard.allowBanBinary.checkNoneRuleGroups();"/>
							</td>
							<td width="30%">
								<orion:select id="newRuleGroupOS" name="newRuleGroupOS" items="${platforms}" 
									onchange="scor.inventory.wizard.allowBanBinary.checkToShowErrTxt();"/>
							</td>
						</tr>
						<tr id="validationErrTxtId" style="display:none;">
					                <td> <span class="errorText">${ruleGroupAlreadyExists}</span> </td>
						</tr>
					</table>
				</orion:box>

				<orion:footerbar>
					<orion:previous-next id="selectRuleGroupPrevNext" currentStep="selectRuleGroup"
						wizardInfo="${allowBanBinaryWizardInfo}" />
				</orion:footerbar>
			</orion:vbox>
		</orion:content>
	</orion:corebody>
</orion:core>

<script type="text/javascript">

var scor;
scor = scor || {};
scor.inventory = scor.inventory || {};
scor.inventory.wizard = scor.inventory.wizard || {};
scor.inventory.wizard.allowBanBinary  = scor.inventory.wizard.allowBanBinary  || {};

scor.inventory.wizard.allowBanBinary.disableNext = function() {
	OrionWizard.disableNavigation();	
};

scor.inventory.wizard.allowBanBinary.enableNext = function () {
	OrionWizard.enableNavigation();	
};


scor.inventory.wizard.allowBanBinary.checkToShowErrTxt = function () {
	if (allowBanBinaryValidationResult === "ruleGroupAlreadyExists") {
		$('validationErrTxtId').style.display = "";
		allowBanBinaryValidationResult = "";	
	} else {
		$('validationErrTxtId').style.display = "none";
	}	
};

scor.inventory.wizard.allowBanBinary.checkNoneRuleGroups = function () {

	// some user action has happened since last error, so, check if err msg should be reset.
	scor.inventory.wizard.allowBanBinary.checkToShowErrTxt();

	var addToRuleGroupRadio = $('addToRuleGroupRadio');
	var createRuleGroupRadio = $('createRuleGroupRadio');

	if (addToRuleGroupRadio.checked == true) {
		var selectId = $('addToRuleGroup');
		if (selectId.options.length == 0) {
			selectId.options.length = 1;
			selectId.options[0].value = 0;
		}

		if (selectId.options[0].value == 0) {
			selectId.options[0].text = '    ' + '${noneRuleGroup}' + '    ';
			scor.inventory.wizard.allowBanBinary.disableNext();
			return;
		} 	 
	} else if (createRuleGroupRadio.checked == true) {
		var inputId = $('newRuleGroupName');
		if (inputId.value === '') {
			scor.inventory.wizard.allowBanBinary.disableNext();
			return;
		}
	} 
	
	// reaching here means either non-empty input Or Add to Whitelist option
	scor.inventory.wizard.allowBanBinary.enableNext();
};

scor.inventory.wizard.allowBanBinary.showRuleGroupConfig = function() {
	var addToRuleGroupRadio = $('addToRuleGroupRadio');
	var createRuleGroupRadio = $('createRuleGroupRadio');

	if (addToRuleGroupRadio.checked == true) {
		$('addToRuleGroupConfigRow1').style.display = "";
		$('addToRuleGroupConfigRow2').style.display = "";
		$('createRuleGroupConfigRow1').style.display = "none";
		$('createRuleGroupConfigRow2').style.display = "none";
		$('ruleGroupNote').style.display = "";
	} else if (createRuleGroupRadio.checked == true) {
		$('addToRuleGroupConfigRow1').style.display = "none";
		$('addToRuleGroupConfigRow2').style.display = "none";
		$('createRuleGroupConfigRow1').style.display = "";
		$('createRuleGroupConfigRow2').style.display = "";
		$('ruleGroupNote').style.display = "none";
	} else {
		// Add to Whitelist
		$('addToRuleGroupConfigRow1').style.display = "none";
		$('addToRuleGroupConfigRow2').style.display = "none";
		$('createRuleGroupConfigRow1').style.display = "none";
		$('createRuleGroupConfigRow2').style.display = "none";
		$('ruleGroupNote').style.display = "none";
	}
	scor.inventory.wizard.allowBanBinary.checkNoneRuleGroups();
};


scor.inventory.wizard.allowBanBinary.refreshRuleGroupList = function (data) {
	var selectId = $('addToRuleGroup');

	var beans = JSON.parse(data);
	var ruleGroupList = beans.optionItems;

	selectId.options.length = ruleGroupList.length;

	var i;
	for (i = 0; i < ruleGroupList.length; i++) {
		selectId.options[i].value = ruleGroupList[i].value;
		selectId.options[i].text = ruleGroupList[i].text; 	 
	}
	scor.inventory.wizard.allowBanBinary.checkNoneRuleGroups();
};

scor.inventory.wizard.allowBanBinary.fetchRuleGroupsByPlatform = function () {
	var selectId = $('existingRuleGroupOS');

	var params = new Array();
	params.push ("<%=InventoryConstants.EXISTING_RULE_GROUP_OS%>");
	params.push (selectId.options[selectId.selectedIndex].value);

	scor.actions.doAsyncAction("<%=URLConstants.FETCH_RULE_GROUPS_BY_OS_URL%>", params, 
			scor.inventory.wizard.allowBanBinary.refreshRuleGroupList, null);
};

scor.inventory.wizard.allowBanBinary.allowBanBinaryUiInit = function () {
	if (ruleGroupRadio == 'existingRuleGroup') {
		
		$('addToRuleGroupRadio').checked = true;

		var selectId = $('addToRuleGroup');
		for (var i = 0; i < selectId.options.length; i++) {
			if (selectId.options[i].value === selectedRuleGroupId) {
				selectId.selectedIndex = i;
				break;
			}
		}
		
	} else if (ruleGroupRadio == 'newRuleGroup') {

		$('createRuleGroupRadio').checked = true;

		/* group name needs to be unescaped before populating it in a textfield to show it properly */
		$('newRuleGroupName').value = OrionCore.unescapeHtml(newRuleGroupName);

	} else if (ruleGroupRadio == 'addBinariesToWhitelist' && 
			allowBanActionType == 'allow') {

		$('addToWhitelist').checked = true;
		
	} else {
		// default case
		$('createRuleGroupRadio').checked = true;

	}

	OrionEvent.registerHandlerById('newRuleGroupName', 
			scor.inventory.wizard.allowBanBinary.checkNoneRuleGroups, null, 'keyup', false);
	scor.inventory.wizard.allowBanBinary.showRuleGroupConfig();
};

OrionCore.addLoadHandler(scor.inventory.wizard.allowBanBinary.allowBanBinaryUiInit);
</script>
