<%-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>


<orion:message key="scor.reporting.inventory.appDetails.detailPageTitle" var="appDetailPageTitle" escape="none"/>
<orion:message key="scor.reporting.inventory.appDetails.properties" var="appProperties" escape="none"/>

<orion:message key="scor.inventory.da.displayName" var="displayNameVar" escape="html"/>
<orion:message key="scor.inventory.da.displayVersion" var="displayVersionVar" escape="html"/>
<orion:message key="scor.inventory.da.displayVendor" var="displayVendorVar" escape="html"/>
<orion:message key="scor.inventory.da.prevalence" var="prevalenceVar" escape="html"/>
<orion:message key="scor.inventory.da.numberOfBinaries" var="numberOfBinariesVar" escape="html"/>
<orion:message key="scor.inventory.da.enterpriseTrustLevel" var="enterpriseTrustLevelVar" escape="html"/>
<orion:message key="scor.navigation.back" var="backButtonText" escape="none" />
<orion:message key="scor.navigation.close" var="closeButtonText" escape="none" />

<c:set var="displayName" value="${scorInventoryLocAppPropMap['displayName']}"/>
<c:set var="displayVersion" value="${scorInventoryLocAppPropMap['displayVersion']}"/>
<c:set var="displayVendor" value="${scorInventoryLocAppPropMap['displayVendor']}"/>
<c:set var="prevalence" value="${scorInventoryLocAppPropMap['prevalence']}"/>
<c:set var="numberOfBinaries" value="${scorInventoryLocAppPropMap['numberOfBinaries']}"/>
<c:set var="enterpriseTrustLevel" value="${scorInventoryLocAppPropMap['enterpriseTrustLevel']}"/>

<orion:core>
    <orion:corehead>
		
		<%@ page import="com.mcafee.scor.common.URLConstants" %>
		<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
	</orion:corehead>
    <orion:corebody>
		<orion:navigation/>
        <orion:content>
        	<script type="text/javascript">
                OrionHelp.setHelpId("${scorInvAppDetailHelpPageId}");
            </script>
            <orion:vbox>
				<orion:titlebar text="${appDetailPageTitle} ${displayName}" />

				<orion:box height="7" background="#474747"/>
				<orion:hbox height= "150">

					<orion:box width="auto" >
							<orion:titlebar text="${appProperties}" /> 
						<table style="border-bottom: 0;width:100%">
							<tr ><td style = "width:90%">
								<table class="orionPList" cellspacing="0" style="border-bottom: 0">
									
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" width="250" style="border-right: 0; text-align: left">
											${displayVersionVar} :
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     		${orion:escapeHtml(displayVersion)}
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" width="250" style="border-right: 0; text-align: left">
											${displayVendorVar} :
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     		${orion:escapeHtml(displayVendor)}
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" width="250" style="border-right: 0; text-align: left">
											${prevalenceVar} :
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     		${orion:escapeHtml(prevalence)}
										</td>
										</tr>	

										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" width="250" style="border-right: 0; text-align: left">
											${numberOfBinariesVar} :
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     		${orion:escapeHtml(numberOfBinaries)}
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" width="250" style="border-right: 0; text-align: left">
											${enterpriseTrustLevelVar} :
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     		${orion:escapeHtml(enterpriseTrustLevel)}
										</td>
										</tr>	
						
								</table>	
							 </td>							

							 </tr>
						</table>
					 </orion:box>					
				</orion:hbox>				
			
				<orion:box height="7" background="#474747"/>
				<orion:tabstrip id="myTabStrip" tabStripInfo="${tabInfo}" async="true"/>
				
				<orion:footerbar align="right">
					<orion:button id="back" text="${backButtonText}" onclick="OrionNavigation.back();"/>
					<orion:button id="close" text="${closeButtonText}" onclick="OrionNavigation.lastAnchorPage();"/>
				</orion:footerbar>

            </orion:vbox>

        </orion:content>	
		

		<script type="text/javascript">
		dosegmentRollover = function(element){
			element.style.backgroundColor = '#c1d3e3';
			element.style.cursor = 'pointer';
		}

		dosegemntRollout = function(element){
			element.style.testAlign='center';
			element.style.fontSize='10px';
			element.style.fontWeight='normal';
			element.style.backgroundColor = 'white'
		}			
		</script>
    </orion:corebody>
</orion:core>