<!-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved-->

<%@taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@page import="com.mcafee.scor.common.ScorReturnCodes"%>
<%@page import="com.mcafee.scor.inventory.InventoryConstants"%>
<%@page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<jsp:include page="/common/includejQuery.jsp"/>


<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.INVENTORY_BY_SYSTEMS_PAGE%>");
</script>

<orion:message key="scor.reporting.inventory.systemView.systemTableTitle" var="systemTableTitle" escape="none"/>
<orion:message key="scor.inventory.savedsearches" var="savedSearchesText"/>
<orion:message key="scor.inventory.select" var="selectDropdownOption"/>
<orion:message key="scor.inventory.filter.advance.filter" var="aef"/>
<orion:message key="scor.inventory.filter.advanced.filtered" var="advanceFilteredText" escape="none"/>
<orion:message key="scor.inventory.fetchInvTitle" var="fetchInvTitle" escape="javascript"/> 
<orion:message key="scor.inventory.markSystemBinaryGood" var="markSystemBinaryGood" escape="javascript"/>
<orion:message key="scor.inventory.fetchInventoryConfirmText1" var="fetchInventoryConfirmText1" escape="javascript"/> 
<orion:message key="scor.inventory.fetchInventoryConfirmText2" var="fetchInventoryConfirmText2" escape="javascript"/> 
<orion:message key="scor.inventory.fetchInventoryConfirmText3" var="fetchInventoryConfirmText3" escape="javascript"/> 
<orion:message key="scor.inventory.filter.remove.advance.filter" var="removeAef"/>
<orion:message key="scor.inv.aef.duplicateaef" var="duplicateAef"/>
<orion:message key="scor.inv.aef.editandupdateaef" var="editAef"/>
<orion:message key="scor.inv.aef.renamesavedfilter" var="renameAef"/>
<orion:message key="scor.inv.aef.renamesavedfilter" var="renameAefText" escape="javascript" />
<orion:message key="scor.inv.aef.deleteaef" var="deleteAef"/>
<orion:message key="scor.inv.aef.addsavedfilter" var="addSavedFilter"/>
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DUPLICATE.getDisplayKey()%>" var="cantDuplicateSavedSearch" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DELETE.getDisplayKey()%>" var="cantDeleteSavedSearch" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_RENAME.getDisplayKey()%>" var="cantRenameSavedSearch" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_DUPLICATE_NAME_EXISTS.getDisplayKey()%>" var="duplicateNameExists" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_ID_NOT_EXISTS.getDisplayKey()%>" var="nonExistentSearchSpecified" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.INV_INVALID_CHARACTERS_IN_NAME.getDisplayKey()%>" var="unsupportedCharactersInName" escape="javascript" />
<orion:message key="scor.inv.aef.savedFilterName" var="savedFilterName" escape="html" />
<orion:message key="scor.inv.aef.emptySearchNameErrorMsg" var="emptySearchNameErrorMsg" escape="html" />

<orion:vbox>
	    <orion:box height="50">
	        <table width="100%" height="100%" cellspacing="1px" cellpadding="1px" style="background-color: rgb(235, 235, 235); width: 100%;">
	             <tr>	       
	                <td> &nbsp;&nbsp;${savedSearchesText} : 
	                	<SELECT name="invSavedSearchId" id="invSavedSearchId" onchange="goToSavedSearch()">
	                			<OPTION value="-1"> ${addSavedFilter} </OPTION>
	                			<OPTION value="-2" disabled> ------ </OPTION>
	                			<OPTION value="-3" SELECTED> ${selectDropdownOption} </OPTION>
	                      <c:forEach var="savedSearch" items="${scorInvSavedSeraches}">
								<OPTION value="${savedSearch.searchId}"  <c:if test="${invSearchName eq savedSearch.searchName}"> selected </c:if> > 
									${savedSearch.searchName} 
								</OPTION>
						  </c:forEach>
						</SELECT>
						&nbsp;
	  	                <a href="#" id="dupSearchLinkId" onclick="askForDupSearchName()" >${duplicateAef}</a>
					<c:if test="${scorIsSavedSearchEditable == 'true'}">	
					 	| <a href="#" onclick="editSavedFilter()">${editAef}</a>
					 	| <a href="#" onclick="askForSearchName()">${renameAef}</a>
					 	| <a href="#" onclick="deleteSavedFilter()">${deleteAef}</a>
					</c:if>
					</td>
	  	        </tr>
	        </table>
	    </orion:box>
        <orion:table2 id="systemTableId" titleText="${requestScope.tableTitle}" 
        	cellRendererAttr="<%=InventoryConstants.INVENTORY_SYSTEM_CELL_RENDR_ATTR%>"
            datasourceAttr="<%=InventoryConstants.INVENTORY_SYSTEM_DATASOURCE_ATTR%>" 
            showCheckboxColumn="false" allowConfiguration="true" allowExport="true" enableDrilldown="false" 
            allowAdvancedFilter="true" sortOrder="0" sortColumn="systemName" 
            properties="systemName,groupPath,inventoryFetchStatus,lastSuccessfulInventoryFetch,actions" />
            
            
<div id="scor.inv.askforsearchname" style="display:none;">
<table>
    <tr>
        <td>${savedFilterName}:</td>
        <td><orion:textbox id="scor.inv.savedsearch.name.ask" name="scor.inv.savedsearch.name.ask" required="true"/> </td>
    </tr>    
	<tr> 
		<td></td>
		<td id="searchNameErrorMsgId" name="searchNameErrorMsgId" style="display: none; color: red;">${emptySearchNameErrorMsg}
		</td>
	</tr>
</table>
</div>
</orion:vbox>


<script type="text/javascript">


	function returnIfInvalidSearch(){
		var savedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
     
		if(savedSearchId < 0){
			return;
		}	
	}

     function navigateToInvPage(){
        var invPageSourceValue = "invPageSourceSystem";
        var paramMap = ["invPageSource",invPageSourceValue];
        OrionCore.doAction("/SOLIDCORE_META/navigateToInv.do", paramMap, "GET","_self");
     }

	function showDialogBox(message,title){
        OrionCore.showDialogBox(true, message, OrionCore.DIALOG_OK);
    	OrionCore.setDialogBoxTitle(title);
	}

	
	function validateNewSearchName () {
		var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
		var isValid = OrionValidate.isNotEmpty(searchElem.value);
		var errorElem = $j('#searchNameErrorMsgId');
		var showError = !isValid;
		errorElem.toggle( showError );
	
		return isValid;
	}

	function duplicateFilter(){
	      var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
		  var isValid = validateNewSearchName();
		  if (isValid === false) {
			OrionEvent.registerHandler(searchElem,validateNewSearchName, null, "keyup", false);
			return false;
		  }

		  OrionEvent.unregisterHandler(searchElem,validateNewSearchName, null, "keyup", false); 
		  
		  var invPageSourceValue = "invPageSourceSystem";
	      var searchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
	      
	      var searchName = searchElem.value;
	    
	      var paramMap = ["invSavedSearchId", searchId,"invPageSource",invPageSourceValue,'invSearchName',searchName];
	      
	      scor.actions.doAsyncAction("/SOLIDCORE_META/duplicateSearch.do",paramMap, handleAfterDuplicate);
	      
	      OrionCore.showPleaseWait(true);	
	}

	function handleAfterDuplicate(duplicateSuccessfulId, ret, msg){
	       OrionCore.showPleaseWait(false);
	        
		   if(duplicateSuccessfulId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
		   	navigateToInvPage(); 
		   }else if (duplicateSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DUPLICATE.getCode()%>){
			   showDialogBox('${cantDuplicateSavedSearch}','');
		   }else if(duplicateSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_DUPLICATE_NAME_EXISTS.getCode()%>){
			   showDialogBox('${duplicateNameExists}','');
		   }else if(duplicateSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_ID_NOT_EXISTS.getCode()%>){
			   showDialogBox('${nonExistentSearchSpecified}','');
		   }else if(duplicateSuccessfulId === <%=ScorReturnCodes.INV_INVALID_CHARACTERS_IN_NAME.getCode()%>){
			   showDialogBox('${unsupportedCharactersInName}','');
		   }
	}

function editSavedFilter(){
returnIfInvalidSearch();
goToAef("true");
}

function askForSearchName(){
		returnIfInvalidSearch();

		OrionCore.dialogBoxOkHandler = renameSavedFilter;
		OrionCore.showDialogBox(true, $('scor.inv.askforsearchname').innerHTML);
		OrionCore.setDialogBoxTitle("${renameAefText}"); 
}

function askForDupSearchName(){
	returnIfInvalidSearch();
	
	OrionCore.dialogBoxOkHandler = duplicateFilter;
	OrionCore.showDialogBox(true, $('scor.inv.askforsearchname').innerHTML);
	OrionCore.setDialogBoxTitle("${duplicateAefText}"); 
}

function renameSavedFilter(){
	  var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
	  var isValid = validateNewSearchName();
	  if (isValid === false) {
		OrionEvent.registerHandler(searchElem,validateNewSearchName, null, "keyup", false);
		return false;
	  }

	  OrionEvent.unregisterHandler(searchElem,validateNewSearchName, null, "keyup", false); 	  
    
	  var invPageSourceValue = "invPageSourceSystem";
      var savedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
      var savedSearchName = searchElem.value;
    
      var paramMap = ["invSavedSearchId", savedSearchId,"invPageSource",invPageSourceValue,'invSearchName',savedSearchName];
      
      scor.actions.doAsyncAction("/SOLIDCORE_META/renameSavedSearch.do",paramMap, handleAfterRename);
      
      OrionCore.showPleaseWait(true);	
}

function handleAfterRename(renameSuccessfulId, ret, msg){
    OrionCore.showPleaseWait(false);
     
	   if(renameSuccessfulId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
	   		 navigateToInvPage(); 
	   }else if (renameSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_RENAME.getCode()%>){
		   showDialogBox('${cantRenameSavedSearch}','');
	   }else if(renameSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_DUPLICATE_NAME_EXISTS.getCode()%>){
		   showDialogBox('${duplicateNameExists}','');
	   }else if(renameSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_ID_NOT_EXISTS.getCode()%>){
		   showDialogBox('${nonExistentSearchSpecified}','');
	   }else if(renameSuccessfulId === <%=ScorReturnCodes.INV_INVALID_CHARACTERS_IN_NAME.getCode()%>){
		   showDialogBox('${unsupportedCharactersInName}','');
	   }
}

function deleteSavedFilter(){
	  returnIfInvalidSearch();

      var invPageSourceValue = "invPageSourceSystem";
      var savedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
    
      var paramMap = ["invSavedSearchId", savedSearchId,"invPageSource",invPageSourceValue];
      
      scor.actions.doAsyncAction("/SOLIDCORE_META/deleteInvAdvFilter.do",paramMap, handleAfterDelete);
      
      OrionCore.showPleaseWait(true);	
}

function handleAfterDelete(deleteSuccessfulId, ret, msg){
       OrionCore.showPleaseWait(false);
        
	   if(deleteSuccessfulId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
	   		 navigateToInvPage(); 
	   }else if (deleteSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DELETE.getCode()%>){
	   		showDialogBox('${cantDeleteSavedSearch}','');
	   }
}


 function goToAef(shouldEdit){
  	var selectedSavedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
 	var paramMap = ["invPageSource", "invPageSourceSystem","shouldEdit",shouldEdit,"scorInvSavedSearchId",selectedSavedSearchId];
 	
 	OrionCore.doAction("/SOLIDCORE_META/showInvAdvFilterCriteria.do", paramMap, "GET","_self");
 }

 function goToSavedSearch(){
 	var selectedSavedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
 	

    if(selectedSavedSearchId === "-1"){
	  	goToAef("false");
 	 }
 	 
    if(selectedSavedSearchId === "-3"){
	  	 goToRemoveAef();
 	 } 	 
 	 
 	 if(selectedSavedSearchId > 0){ 	
 		var paramMap = ["invSavedSearchId", selectedSavedSearchId,"invPageSource", "invPageSourceSystem"];
 		OrionCore.doAction("/SOLIDCORE_META/loadInvSavedSearch.do", paramMap, "GET","_self");
 	}
 }

	function goToRemoveAef(){
		  var paramMap = ["invPageSource", "invPageSourceSystem"];
		  scor.actions.doAsyncAction("/SOLIDCORE_META/removeInvAdvFilterCriteria.do",paramMap, navigateToInvPage);
	}

  markSystemBinaryGood =  function (uid){
	  OrionCore.showAsyncDialogBox(true, "<%=URLConstants.MARK_SYSTEM_BINARY_GOOD_CONFIRM_URL%>" 
				+ '?' + '<%=InventoryConstants.AGENT_GUID%>' + '=' + uid, null, null);
		OrionCore.setDialogBoxTitle('${markSystemBinaryGood}');
		OrionCore.dialogBoxOkHandler = function () {
			var agentGuid = $('markBinaryGoodAgentGuidDiv').innerHTML;
	  		var paramMap = ['<%=InventoryConstants.AGENT_GUID%>', agentGuid]; 
			scor.actions.doAsyncAction ('<%=URLConstants.MARK_SYSTEM_BINARY_GOOD_URL%>', paramMap, 
					null, null, "POST"); 
	 	};
  } 
  
  fetchSystemInventory = function (uid) { 
	OrionCore.showAsyncDialogBox(true, "<%=URLConstants.FETCH_INVENTORY_CONFIRM_URL%>" 
			+ '?' + '<%=InventoryConstants.AGENT_GUID%>' + '=' + uid, null, null);
	OrionCore.setDialogBoxTitle('${fetchInvTitle}');
	OrionCore.dialogBoxOkHandler = function () {
		var agentGuid = $('agentGuidDiv').innerHTML;
  		var paramMap = ['<%=InventoryConstants.AGENT_GUID%>', agentGuid]; 
		scor.actions.doAsyncAction ('<%=URLConstants.FETCH_SYSTEM_INVENTORY_URL%>', paramMap, 
			null, null, "POST"); 
 	};
 };  
 function checkAndHideDupSearhLink () {
		var selectedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
	     
		if(selectedSearchId < 0) {
			document.getElementById('dupSearchLinkId').style.display = 'none';
		}
	 }

 OrionCore.addLoadHandler(checkAndHideDupSearhLink);
</script>


