<%-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@ page import="com.mcafee.scor.common.Constants"%>

<orion:message key="policy.mon.advanced.addRule" var="addRule" escape="none" />
<orion:message key="scor.policy.awl.obExclusion.rule" var="rule" escape="html"/>
<orion:message key="scor.policy.awl.obExclusion.rule" var="ruleJS" escape="javascript"/>
<orion:message key="scor.policy.awl.obExclusion.delete" var="delete" escape="html"/>
<orion:message key="policy.mon.adv.and" var="andVar" escape="html"/>
<orion:message key="policy.mon.adv.applyEventFilter" var="applyEventFilterVar" escape="none"/>
<orion:message key="policy.mon.adv.and" var="andVarJS" escape="javascript"/>
<orion:message key="scor.policy.awl.eventAndObFilterDescriptionText.text" var="awlEventAndObFilterDescriptionText" escape="html"/>
<orion:message key="scor.policy.awl.eventFilterDescriptionText.text" var="awlEventFiltersDescriptionText" escape="html"/>
<orion:message key="scor.policy.mon.adv.isOnlyOnOldHosts" var="isOnlyOnOldHosts" escape="none"/>

<orion:message key="scor.policy.im.eventFilterDescriptionText.text" var="imEventFilterDescriptionText" escape="html"/>
<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupFilterRules" authToken = "isAuthorizedToEditFilterRules"/>

<jsp:include page="/common/includejQuery.jsp" />
<orion:style context="/SOLIDCORE_META" url="/css/override.css" />

<style type="text/css">
.filtersDescriptionArea {
	background-color:#EDEDED;
	border-color:#E0E0E0;
	border-style:none none solid;
	border-width:1px;
	color:#4A4A4A;
	font-size:10px;
	font-weight:normal;
	overflow:hidden;
	width:99%;
	margin-bottom: 10px;
	padding:5px;
}
	
	.inputFieldClass {
		width:40%;
	}
	
	.deleteLinkClass {
		text-decoration: underline; 
		cursor: pointer; 
		cursor: hand;
	}
	
	.keyDivClass{
		padding-bottom: 3px;
	}
	
	.orLineDivClass{
		float: left; width: 48%; padding-bottom: 5px;
	}
	
	.orDivClass{
		width: 100%; float: left;
	}
</style>

<%!
    final String KEY_EVENT = "Event";
	final String KEY_FILE = "file";
	final String KEY_PROCESS = "process";	
	final String ID_KEY = "key";
	final String ID_CRITERIA = "criteria";
	final String ID_VALUE = "value";
	final String ID_DELETE = "delete";
	final String RULE_FILTER_DIV = "filterDiv";
	final String HTML_RULE_FILTER_DIV = "html-filterDiv";
	final String EVENT_ID_VALUE = KEY_EVENT+"-"+ID_VALUE;
	final String ERROR_DIV = "obErrorDiv";
%>

<script type="text/javascript">
		var scor = scor || {};
		scor.awl = scor.awl || {};
		scor.awl.filter = scor.awl.filter ||{};
		scor.awl.filter.sectionCount = scor.awl.filter.sectionCount || 0;
		scor.awl.filter.filterSections = scor.awl.filter.filterSections || [];
		scor.awl.filter.filterMappedBySectionId = scor.awl.filter.filterMappedBySectionId || {};
		
		scor.awl.filter.checkAndMarkIsObChecked = function (aefRule) {
			if (aefRule.isObFilter &&
					typeof aefRule.isIgnoreRule === 'boolean' && aefRule.isIgnoreRule &&
					!$j('#isObAefIgnored').is(':checked')) {
				$j('#isObAefIgnored').attr('checked', true);
			}
		};

   		scor.awl.filter.addRule = function (aefRule, readOnly) {   
   	   		var rootDivElement = $j('#allFilterRulesDiv');

   			var childFilterRulesSectionDiv = $j('#filterRuleDiv').clone();
   			childFilterRulesSectionDiv.attr("id", "filterRuleDiv_"+scor.awl.filter.sectionCount).css('display','inline');
   			scor.awl.filter.setSectionIDInChildDivs(childFilterRulesSectionDiv);	  
   			scor.awl.filter.showApplyEventChkbox(childFilterRulesSectionDiv);   				
	   		rootDivElement.append(childFilterRulesSectionDiv);
	   		var filterRule = scor.awl.filter.addMagicwidgetInChildSection(readOnly); 
	   		if (aefRule) {
	   		 	var ruleItems = aefRule.ruleItems;
				for(var ruleItemIndex = 0; ruleItemIndex < ruleItems.length; ruleItemIndex++){
					var ruleItem = ruleItems[ruleItemIndex];
					filterRule.add();
					var rowId =  filterRule.id;          
					scor.awl.filter.setruleItems(ruleItem, rowId);			
				}
				scor.awl.filter.setApplyEventFilterChkbox(aefRule, scor.awl.filter.sectionCount);
				scor.awl.filter.checkAndMarkIsObChecked(aefRule);
   		    }else{   	  
   		    	filterRule.add(); 		    
   		    	myEpoEnableApplyButton();
   	   		}  	   	   		 	   		
	   		scor.awl.filter.filterSections.push(childFilterRulesSectionDiv.get(0)); 
	   		scor.awl.filter.filterMappedBySectionId[scor.awl.filter.sectionCount] = filterRule;
	   		scor.awl.filter.registerHandlersForSection(scor.awl.filter.sectionCount);
	   		if(readOnly){
   	   			scor.awl.filter.doFormatingForReadOnlyGroupForObRuleDiv(childFilterRulesSectionDiv);   	
   	   	   	}	   	   	
	   		scor.awl.filter.sectionCount++;	   		
   		}

   		scor.awl.filter.showHideDescriptionArea = function(){
   			if(scor.awl.filter.type.isAWL() && scor.awl.filter.type.isWIN_OS()){
   				$j('#awlEventAndObFilterDescriptionArea').show();
   			}else if(!scor.awl.filter.type.isAWL()){
   				$j('#imEventFilterDescriptionArea').show();
			//	$j("</br></br>").insertBefore('#imEventFilterDescriptionArea');
			//	$j("#imEventFilterDescriptionArea").prepend("</br></br>");
   	   		}else{   	   			
   	   			$j('#awlEventFiltersDescriptionArea').show();   	   		
   	   	   	}   			
   	   	}

   		scor.awl.filter.showApplyEventChkbox = function(childObRuleDiv){
   	   		if(scor.awl.filter.type.isAWL() && scor.awl.filter.type.isWIN_OS()){
   	   		    var applyEventDiv = $j(childObRuleDiv).find('div#applyEventFilterDiv_'+scor.awl.filter.sectionCount);
				var applyEventChkBox = $j(applyEventDiv).find('#scorEventFilter');
				var applyEventlabel = $j(applyEventDiv).find('#scorEventFilter_label');
				applyEventChkBox.attr("id", applyEventChkBox.attr("id")+"_"+scor.awl.filter.sectionCount);
				applyEventlabel.attr("for", applyEventChkBox.attr("id"));
				$j(applyEventDiv).show();
   	   		}
   	   	}

   		scor.awl.filter.setruleItems = function(ruleItem, rowId){
			var key = ruleItem.key;
			var criteria = ruleItem.criteria;
			var value = ruleItem.value;
   			var keySeclectBox = $j("#<%=ID_KEY%>" + "_" + scor.awl.filter.sectionCount + "_" + rowId);
   			$j(keySeclectBox).val(key);
  			var criteriaSeclectBox = $j("#<%=ID_CRITERIA%>" + "_" + scor.awl.filter.sectionCount + "_" + rowId);
   			$j(criteriaSeclectBox).val(criteria);
   			var valueSelectBox = $j("#obType-value" + "_" + scor.awl.filter.sectionCount + "_" + rowId);
   			var valueTextBox = $j("#<%=ID_VALUE%>" + "_" + scor.awl.filter.sectionCount + "_" + rowId);
   	   		if(key === "<%=KEY_EVENT%>"){   	   			
   				$j(valueSelectBox).val(value);
   	   		}else{   	   			
   				$j(valueTextBox).val(value);
   	   	   	}
   	   		var map = {'key': keySeclectBox, 'valueBox' :valueTextBox, 'valueSelectBox':valueSelectBox,'criteriaBox': criteriaSeclectBox, 
   	    	   		'id': scor.awl.filter.sectionCount, 'rowId': rowId};
   	   		scor.awl.filter.onKeySelectdoFormating(map);
   	   	}
   		
   		scor.awl.filter.setSectionIDInChildDivs = function(childObRuleDiv){
   			var allDivsInObRule = $j(childObRuleDiv).children('div');
   			for(var divIndex = 0 ; divIndex < allDivsInObRule.length; divIndex++){
	   	   			var div = allDivsInObRule[divIndex];
	   	   			var divKey = $j(div).attr('id');	   	   			  	   				
	   	   			$j(div).attr("id", divKey+"_"+scor.awl.filter.sectionCount);	   	   			   	   	   	   		
	   	   	}	
   	   	}

   		scor.awl.filter.setApplyEventFilterChkbox = function(aefRule, sectionId){
   			if(scor.awl.filter.type.isAWL() && scor.awl.filter.type.isWIN_OS()){
   		 		var eventFilterChkbox = $j("#scorEventFilter" + "_" + sectionId);
   		 		var isObFilter = aefRule.isObFilter;	 
   				var isEventFilter = aefRule.isEventFilter;	
   		 		if((isEventFilter == null && isObFilter == null) || isEventFilter){    
   					$j(eventFilterChkbox).attr('checked', true);
   	    		}else{
   	    			$j(eventFilterChkbox).attr('checked', false);
   	    		}
   			}
   		}   		   	   	


   		scor.awl.filter.doFormatingForReadOnlyGroupForObRuleDiv = function(inputDiv){
   			var allDivsInFilterRule = $j(inputDiv).find('div');
   			var sectionId = scor.awl.filter.sectionCount;
   			for(var divIndex = 0 ; divIndex < allDivsInFilterRule.length; divIndex++){
	   	   			var div = allDivsInFilterRule[divIndex];
	   	   			var divKey = $j(div).attr('id');
	   	   			if(!divKey){
	   	   				continue;
		   	   		}
	   	   			if(divKey.indexOf("<%=ID_DELETE%>") !== -1)
	   	   			{
	   	   				$j(div).html('${ruleJS}');
	   	   				continue;
		   	   		}
	   	   			if(divKey.indexOf("<%=RULE_FILTER_DIV%>") !== -1)
	   	   			{
	   	   				var eventFilterChkbox = $j("#scorEventFilter" + "_" + sectionId);
	   	   				$j(eventFilterChkbox).attr("disabled", true);
	   	   				var filterRule = scor.awl.filter.filterMappedBySectionId[sectionId]
	   	   				var rowIds = filterRule.getRowIds();
         		 		for (var index = 0; index < rowIds.length; index++) {
         		 		 	var rowId = rowIds[index];
         	   		 		var keyBox = $j("#<%=ID_KEY%>" + "_" + sectionId + "_" + rowId); 
         	   		 		$j(keyBox).attr("disabled", true);
         	   		 		var criteriaBox = $j("#<%=ID_CRITERIA%>" + "_" + sectionId + "_" + rowId); 
         	   		 		$j(criteriaBox).attr("disabled", true);
         	   				var valueTextBox = $j("#<%=ID_VALUE%>" + "_" + sectionId + "_" + rowId); 
         	   				$j(valueTextBox).attr("disabled", true);
         	   				var valueSelectBox = $j("#obType-value" + "_" + sectionId + "_" + rowId);
         	   				$j(valueSelectBox).attr("disabled", true); 
         		 		}
	   	   			}   	   	   	   		
	   	   	}
   	   	}

   		scor.awl.filter.addMagicwidgetInChildSection = function(readOnly){
   			var filterHtmlContent = $j("#<%=HTML_RULE_FILTER_DIV %>").html();
	   	 	while (filterHtmlContent.indexOf("@SECTIONID") > -1){  
	   			filterHtmlContent = filterHtmlContent.replace("@SECTIONID", scor.awl.filter.sectionCount);	 
	   	 	}  		
	   	 	var obj = new majic.AddWidget({
	         container:"<%=RULE_FILTER_DIV%>" + "_" + scor.awl.filter.sectionCount,
	         content:filterHtmlContent,
	         readOnly: readOnly,
	         addCallback: scor.awl.filter.rowAdded,
	         removeCallback: scor.awl.filter.rowRemove
	     	});  
	     	return obj;	 	
   	   	}

   		scor.awl.filter.rowAdded = function(row){
   			var parentDivId = $j(row).parent().attr("id");
   			var sectionCounter = scor.awl.filter.getDivNumber(parentDivId);
   			var rowId = row.id;
   		   	var rowCounter = scor.awl.filter.getDivNumber(rowId);
   		   	scor.awl.filter.insertAndLabel(row);
   		 	scor.awl.filter.registerHandlersForRows(sectionCounter, rowCounter);   		    
   		    myEpoEnableApplyButton();
   	   	}

   		scor.awl.filter.rowRemove = function(){
   	   		var lastChild = this.cntr.lastChild;
   	   		var isAndLabelPresent = $j(lastChild).find("#andLabel");
   	   		if(isAndLabelPresent || isAndLabelPresent.length > 0){
   	   			$j(isAndLabelPresent).remove();
   	   	   	}
   		 	myEpoEnableApplyButton();   	   	
   	   	}

   		scor.awl.filter.getDivNumber = function(divId){
   			return (divId).split(/_/).pop();
   	   	}

   		scor.awl.filter.insertAndLabel = function(currentRow){
   	   		if(currentRow.previousSibling){
   	   	   		var isAndLabelPresent = $j(currentRow.previousSibling).find("#andLabel");
   	   	   		if(!isAndLabelPresent || isAndLabelPresent.length === 0){
   	   	   			var isPresentBreakElement = $j(currentRow.previousSibling).find('br');
					if(isPresentBreakElement.length !== 0){   				
						$j(isPresentBreakElement).before("<span id=\"andLabel\">${andVarJS}<\span>");
	   	   			}else{
   						$j(currentRow.previousSibling).append("<span id=\"andLabel\">${andVarJS}<\span>");
	   	   			}
   	   	   		}
   	   		}
   	   	}

   		scor.awl.filter.registerHandlersForRows = function(sectionId, rowId){
   	   		var keyBoxid = "<%=ID_KEY%>"+"_"+sectionId+"_"+rowId;
   	   		var keyBox = $j('#'+keyBoxid);
   	   		
   	   		var valueTextBoxid = "<%=ID_VALUE%>"+"_"+sectionId+"_"+rowId;
   	   		var valueTextBox = $j('#'+valueTextBoxid);

   			var valueSelectBoxid = "obType-value"+"_"+sectionId+"_"+rowId;
   	   		var valueSelectBox = $j('#'+valueSelectBoxid);
   	   		    	
   	   		var criteriaBoxid = "<%=ID_CRITERIA%>"+"_"+sectionId+"_"+rowId;;
	   		var criteriaBox = $j('#'+criteriaBoxid);
	   		    	
   	   		var map = {'key': keyBox, 'valueBox' :valueTextBox, 'valueSelectBox':valueSelectBox,'criteriaBox': criteriaBox, 
   	    	   		'id': sectionId, 'rowId': rowId};
   	   		  		
   	   		OrionEvent.registerHandler(valueTextBox.get(0), scor.awl.filter.onChangeValueTextBox, map, "keyup", true);	
	   		OrionEvent.registerHandler(criteriaBox.get(0), scor.awl.filter.onCriteriaSelectTextBox, map, "change", true);
	   		OrionEvent.registerHandler(keyBox.get(0), scor.awl.filter.onKeySelectBox, map, "change", true);   		   	   		
   	   	}

   		scor.awl.filter.registerHandlersForSection = function(sectionId){
   	   			var deleteLink = "#<%=ID_DELETE%>"+"_"+sectionId;
   	   			var deleteDiv = $j(deleteLink);
   	   			var map = {'sectionId': sectionId};
  				OrionEvent.registerHandler(deleteDiv.get(0), scor.awl.filter.onClickOfDeleteLink, map, "click", true);		
   	   	} 

   		scor.awl.filter.onClickOfDeleteLink = function(evt){
   			var map = OrionEvent.getUserProperty(evt);
   			var sectionId = map.sectionId;
   	   		delete scor.awl.filter.filterMappedBySectionId[sectionId];
   		 	myEpoEnableApplyButton();
   	   	}

   		scor.awl.filter.onChangeValueTextBox = function(evt) {
   			var map = OrionEvent.getUserProperty(evt);
   			scor.awl.filter.validateValueTextBox(map);
   	        myEpoEnableApplyButton();
   	     }
   		
   		scor.awl.filter.onCriteriaSelectTextBox = function(evt) {
   			var map = OrionEvent.getUserProperty(evt);
   			scor.awl.filter.validateValueTextBox(map);
   	        myEpoEnableApplyButton();
   	    }

   		scor.awl.filter.onKeySelectBox = function(evt){
   			var map = OrionEvent.getUserProperty(evt);  
   			scor.awl.filter.onKeySelectdoFormating(map) ;			
   	   	}

   		scor.awl.filter.onKeySelectdoFormating = function(map){
   			var key = map.key;
   			var keyText = $j(key).val();
   			if(keyText !== "<%=Constants.ADV_RULE_COND_EVENT%>"){
   	   			var valueSelectBox = map.valueSelectBox;
   	   			$j(valueSelectBox).parent().css('display','none');
   			 	var valueBox = map.valueBox;
   			 	$j(valueBox).parent().css('display','inline')
    		    var criteriaBox = map.criteriaBox;
   			 	$j(criteriaBox).attr("disabled", false);
   			}else{
   	   			var valueSelectBox = map.valueSelectBox;
   	   			$j(valueSelectBox).parent().css('display','inline');
   			 	var valueBox = map.valueBox;
   			 	$j(valueBox).parent().css('display','none')
    		    var criteriaBox = map.criteriaBox;
   				$j(criteriaBox).val("<%=Constants.MATCH_TYPE_EQUALS%>");
   			 	$j(criteriaBox).attr("disabled", true);
   	   		}	
   			scor.awl.filter.validateValueTextBox(map);	   
   		 	myEpoEnableApplyButton();
   		 }

   		scor.awl.filter.validateValueTextBox = function(map){

   		    var criteriaBox = map.criteriaBox;   		  
   		    var criteriaText = $j(criteriaBox).val();   		    
   		    var isValid = true;
   		    var msg = "";
   			var id = map.id;
   		  	var rowId = map.rowId;
   		  	
   		 	if(criteriaText !== '<%=Constants.MATCH_TYPE_EQUALS%>') {
   		 		isValid = true;
   		 		scor.awl.filter.handleAefValidationError(isValid, msg, id, rowId);
   	        	return;
   	    	}
   	   		var key = map.key;
   	   		var keyText = $j(key).val();
   		    var valueBox = map.valueBox;
   		 	var valueText = $j(valueBox).val();

   		 	if(keyText === "<%=Constants.ADV_RULE_COND_EVENT%>"){
   		 		isValid = true;
		 		scor.awl.filter.handleAefValidationError(isValid, msg, id, rowId);
	        	return;
			}

			if(keyText === "<%=Constants.ADV_RULE_COND_FILE%>"){
   		    	var isValidObj = scor.validation.validatePath(valueText, '${orion:escapeJavaScriptString(param.osType)}');
   		    	if (isValidObj) {
   		        	isValid = isValidObj.isValid;
   		        	msg = isValidObj.msg;
   		    	}
   		    	scor.awl.filter.handleAefValidationError(isValid, msg, id, rowId);
			}
			if(keyText === "<%=Constants.ADV_RULE_COND_PROGRAM%>"){
   		    	var isValidObj = isProcessValid(valueText, '${orion:escapeJavaScriptString(param.osType)}');
   		    	if (isValidObj) {
   		        	isValid = isValidObj.isValid;
   		        	msg = isValidObj.msg;
   		    	}
   		    	scor.awl.filter.handleAefValidationError(isValid, msg, id, rowId);
			}
			if(keyText === "<%=Constants.ADV_RULE_COND_USER%>"){
   		    	var isValidObj = isUserValid(valueText, '${orion:escapeJavaScriptString(param.osType)}');
   		    	if (isValidObj) {
   		        	isValid = isValidObj.isValid;
   		        	msg = isValidObj.msg;
   		    	}
   		    	scor.awl.filter.handleAefValidationError(isValid, msg, id, rowId);
			}
			if(keyText === "<%=Constants.ADV_RULE_COND_REGISTRY%>"){
   		    	var isValidObj = isRegistryValid(valueText, '${orion:escapeJavaScriptString(param.osType)}');
   		    	if (isValidObj) {
   		        	isValid = isValidObj.isValid;
   		        	msg = isValidObj.msg;
   		    	}
   		    	scor.awl.filter.handleAefValidationError(isValid, msg, id, rowId);
			}
   		}

   		
   		scor.awl.filter.handleAefValidationError = function(isValid, msg, id, rowId){
			var row = $j("#<%=RULE_FILTER_DIV%>"+"_"+id+"_awrow_"+rowId);
   			var errorDiv = $j("#<%=ERROR_DIV %>").clone();
   			var errorDivId = "<%=ERROR_DIV %>"+"_"+id+"_"+rowId;
   	   		errorDiv.attr("id", errorDivId); 
   			if(!isValid){
   				var isPresentBreakElement = $j(row).find('br');
   				if(!isPresentBreakElement || isPresentBreakElement.length === 0){   				
					row.append("<br/>");
   	   	   		}
   				var isErrorDivPresent = $j(row).parent().find("#"+errorDivId);
   	   	   		if(!isErrorDivPresent || isErrorDivPresent.length === 0){   				
					$j(errorDiv).css({'display':'inline'});
					$j(errorDiv).html(" " + msg);								
					row.append(errorDiv);
   	   	   		}else{
   	   	   			$j("#"+errorDivId).html(" ");
   	   	   			$j("#"+errorDivId).html(" " + msg);
   	   	   	   	}
			}else{
				$j("#"+errorDivId).html(" ");
				$j("#"+errorDivId).remove();
				$j(row).find('br').remove();
			}   					
     	 }


   		scor.awl.filter.getRulesVO = function(){
     		  var finalFilterVOToSave = [];
     		  var sectionId;
     		  var isIgnored = $j('#isObAefIgnored').is(':checked');
     		  if (!isIgnored) {
     			  isIgnored = null;
     		  }
     		 	for (sectionId in  scor.awl.filter.filterMappedBySectionId) {
         		 		if(!(sectionId in scor.awl.filter.filterMappedBySectionId)){
             		 		continue;
         		 		}
             		 	var filterRules = scor.awl.filter.filterMappedBySectionId[sectionId];
             		 	if(!filterRules){
      	   	   		 		continue;
      	   	   		 	}
             		 	var isEventFilter = true;
            			var isObFilter = false;
             		 	if(scor.awl.filter.type.isAWL() && scor.awl.filter.type.isWIN_OS()){
         	            	isObFilter=true;
             		 		var eventFilterElem = $j("#scorEventFilter_"+sectionId);
             	            if($j(eventFilterElem).is(':checked')){
             	            	isEventFilter=true;
             	            }else{
             	            	isEventFilter=false;
             	             }                 		 	
                 		}
         	   		 	var ruleItems = [];
             		 	var rowIds = filterRules.getRowIds();
             		 	for (var index = 0; index < rowIds.length; index++) {
                 		 	var rowId = rowIds[index];
         	   		 		var keyBox = $j("#<%=ID_KEY%>" + "_" + sectionId + "_" + rowId);                
                    		if (!keyBox || keyBox.length === 0) {   //maybe a deleted entry
                       			continue;
                    		}
                    		var key = $j(keyBox).val();
                    		var criteriaBox = $j("#<%=ID_CRITERIA%>" + "_" + sectionId + "_" + rowId); 
                    		var criteria = $j(criteriaBox).val();
                    		var value;
    						if(key ===  "<%=Constants.ADV_RULE_COND_EVENT%>"){
    							var selectValueBox = $j("#obType-value" + "_" + sectionId + "_" + rowId); 
    							value = $j(selectValueBox).val();
    						}else{
    							var textValueBox = $j("#<%=ID_VALUE%>" + "_" + sectionId + "_" + rowId); 
    							value = $j(textValueBox).val();
    						}
    				    	if (value === '') {
    			             	continue;       //skip empty values
    			        	}
                        	var item = {"key": key, "value": value, "criteria": criteria};
                    		ruleItems.push(item);
         	   			}     		 	                                               		 	
             		
         		 	if(ruleItems.length === 0) { continue; } //skip empty Rules
         		 	var _ruleItem = {"ruleItems": ruleItems, "isEventFilter":isEventFilter, "isObFilter":isObFilter, 'isIgnoreRule': isIgnored};
 	        		finalFilterVOToSave.push(_ruleItem);  
     		 	}
         		 return finalFilterVOToSave; 	
     	   	}
   		
   		
   		scor.awl.filter.showHideIsObRequired = function () {
   			if (!scor.awl.filter.type.isAWL() || !scor.awl.filter.type.isWIN_OS()) {
   				$j('#isObAefIgnoredContainer').hide();
   			}
   			
   		};

   		scor.awl.filter.createAdvancedUI = function(filtersObj, readOnly, ruleGroupType, osType){
   			var isFilterRulesReadOnly = readOnly;
   	    	<c:if test="${isAuthorizedToEditFilterRules == false}">
   	    		isFilterRulesReadOnly = true;
   	        </c:if>
   			scor.awl.filter.clearAdvancedUI();         	
         	scor.awl.filter.type.setRuleType(ruleGroupType);
         	scor.awl.filter.type.setOsType(osType);
   	   		scor.awl.filter.showHideDescriptionArea();
   	   		scor.awl.filter.showHideIsObRequired(isFilterRulesReadOnly);
   	   		if (!filtersObj){
         		return;
     		}
         	for (var i = 0; i < filtersObj.length; i++) {
             	if ((!filtersObj[i].ruleItems) || (filtersObj[i].ruleItems.length == 0)) {
                 	continue;
             	}
             	scor.awl.filter.addRule(filtersObj[i], isFilterRulesReadOnly);
         	}    	   		
   	   	}
   	   	

   		scor.awl.filter.clearAdvancedUI = function() {
   	        while (scor.awl.filter.filterSections.length !== 0) {
   	        	scor.awl.filter.deleteRule(scor.awl.filter.filterSections[0], true);
   	        }
   	     	scor.awl.filter.filterSections = [];
   	     	scor.awl.filter.filterMappedBySectionId = {};
   	     	scor.awl.filter.sectionCount = 0;
   	     	$j('#isObAefIgnored').attr('checked', false);
   	    }


   		scor.awl.filter.deleteRule = function (obj, fromCode) {
   		    for (var i = 0; i < scor.awl.filter.filterSections.length; i++) {
   		        var div = scor.awl.filter.filterSections[i];

   		        if (div == obj) {
   		        	scor.awl.filter.filterSections.splice(i, 1);
   		            obj.parentNode.removeChild(obj);
   		            obj = null;     // Required for IE
   		            break;
   		        }
   		    }
   		}
   	    

  		scor.awl.filter.ruleGroupReadOnly = function(enabled){
   			OrionCore.setEnabledById( "SCORAddObExclusionRule", enabled);
   			
   			if (typeof enabled === 'boolean' && enabled) {
				$j('#isObAefIgnored').attr('disabled', false);
   			} else {
				$j('#isObAefIgnored').attr('disabled', true);
   			}
   	   	}

  		scor.awl.filter.type = function() {
  			var isAppControl = false;
  			var isWinOs = false;
  			return {
  				isAWL : function() {
  					return isAppControl;
  				},
  				isWIN_OS : function() {
  					return isWinOs;
  				},
  				setRuleType : function(ruleGroupType) {
  					isAppControl = (ruleGroupType == 'application_control');
  				},
  				setOsType : function(osType){
  					isWinOs = (osType == 'WIN');
  	  			}
  			}
  		}();

  </script>
  
<orion:box >  
<div id="allFilterRulesDiv" style="padding-left: 10px;">
	<div id="awlEventAndObFilterDescriptionArea" class ="filtersDescriptionArea" style="display: none;">
		${awlEventAndObFilterDescriptionText }<br/>
	</div> 
	<div id="awlEventFiltersDescriptionArea" class ="filtersDescriptionArea" style="display: none;">
		${awlEventFiltersDescriptionText }<br/>
	</div> 
	<br></br>
	<div id="imEventFilterDescriptionArea" class ="filtersDescriptionArea" style="display: none;">
		${imEventFilterDescriptionText }<br/>
	</div> 
</div>
<div id="addRuleButtonBox" style="padding-left: 10px;">
	<orion:button id="SCORAddObExclusionRule" onclick="scor.awl.filter.addRule(null, false);" text="${addRule}"/>
</div>
<c:if test="${param.osType == WIN_OS}">
	<div id="isObAefIgnoredContainer" style="padding-left: 10px">
		<orion:checkbox id="isObAefIgnored" name="isObAefIgnored" text="${isOnlyOnOldHosts}"/>
	</div>
</c:if>
            
</orion:box>



<div id="filterRuleDiv" style="display: none;">
	<div style="margin-bottom: 3px;margin-left: 3px;" id="<%=ID_DELETE%>">${rule} | <a class="deleteLinkClass" onclick="scor.awl.filter.deleteRule(this.parentNode.parentNode, false)"> ${delete} </a> <br />
	</div>
	
	<div id= "<%=RULE_FILTER_DIV %>" style="margin-left: 3px;"></div>
	<div id="applyEventFilterDiv" style="display:none;margin-bottom: 3px;">	
		<orion:checkbox id="scorEventFilter" name="scorEventFilter" text="${applyEventFilterVar}"/>
	</div>
	<div id="scorObExclusionOrBar" style='width: 100%; float: left;'>
		<div class = "orLineDivClass">
			<HR>
		</div>
		<div style="float: left; font-size: small;"><orion:message key="policy.mon.adv.or" escape="html" /></div>
		<div class = "orLineDivClass">
			<HR>
		</div>
		<br />
	</div>
</div>

<div id= "<%=HTML_RULE_FILTER_DIV %>" style="display: none;font-size: 10px;">
	 <select id="<%=ID_KEY + "_" + "@SECTIONID_@ID"%>" name="<%=ID_KEY + "_" + "@SECTIONID_@ID"%>" tabindex="0">
       	<option value="<%=Constants.ADV_RULE_COND_FILE%>"><orion:message key="scor.policy.mon.adv.evtFileName" escape="html"/></option>
        <option value="<%=Constants.ADV_RULE_COND_EVENT%>"><orion:message key="scor.policy.mon.adv.evtDisplayKey" escape="html"/></option>
        <option value="<%=Constants.ADV_RULE_COND_PROGRAM%>"><orion:message key="scor.policy.mon.adv.evtProgName" escape="html"/></option>
        <c:if test="${param.osType == WIN_OS}">
        	<option value="<%=Constants.ADV_RULE_COND_REGISTRY%>"><orion:message key="scor.policy.mon.adv.evtRegValueData" escape="html"/></option>
        </c:if>
        <option value="<%=Constants.ADV_RULE_COND_USER%>"><orion:message key="scor.policy.mon.adv.evtUserName" escape="html"/></option>     
    </select>
    	
	<select id="<%=ID_CRITERIA + "_" + "@SECTIONID_@ID"%>" name="<%=ID_CRITERIA + "_" + "@SECTIONID_@ID"%>" tabindex="0">
	 	<option value="<%=Constants.MATCH_TYPE_EQUALS%>"><orion:message key="scor.policy.mon.adv.match.equals" escape="html"/></option>
        <option value="<%=Constants.MATCH_TYPE_BEGINS_WITH%>"><orion:message key="scor.policy.mon.adv.match.beginsWith" escape="html"/></option>
        <option value="<%=Constants.MATCH_TYPE_ENDS_WITH%>"><orion:message key="scor.policy.mon.adv.match.endsWith" escape="html"/></option>
        <option value="<%=Constants.MATCH_TYPE_CONTAINS%>"><orion:message key="scor.policy.mon.adv.match.contains" escape="html"/></option>
        <option value="<%=Constants.MATCH_TYPE_DOES_NOT_CONTAIN%>"><orion:message key="scor.policy.mon.adv.match.doesNotContain" escape="html"/></option>
	</select> 
		
	<div id="<%=EVENT_ID_VALUE + "-div"%>" style="display:none;">
		<orion:select id="obType-value_@SECTIONID_@ID" items="${eventDisplayKeys}"/>	
	</div>
		
	<div id="<%=ID_VALUE+"-div"%>" style="display:inline;">
       	<input id="<%=ID_VALUE + "_" + "@SECTIONID_@ID"%>" class="orionInput" tabindex="0" type="text" style="width:40%"/>
    </div>    	
</div>

<div id="<%=ERROR_DIV %>" style="display:none;color:red"> </div>
