<!-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<orion:message key="policy.users.filters" var="policyUsersFilters"  escape="none"/>
<orion:message key="policy.program.filters" var="policyProgramFilters"  escape="none"/>
<orion:message key="policy.extn.filters" var = "policyExtnFilters"  escape="none"/>
<orion:message key="policy.file.filters" var = "policyFileFilters"  escape="none"/>
<orion:message key="policy.reg.filters" var = "policyRegFilters"  escape="none"/>
<orion:message key="policy.exclude" var = "policyExclude"  escape="none"/>
<orion:message key="policy.include" var = "policyInclude"  escape="none"/>
<orion:message key="policy.add" var = "policyAdd"  escape="none"/>


<script type= "text/javascript">

	function _success(){
	fnGoBack();
	}
	
	function _failure(){
	}

	function tablesToXml(tableIdArray, doc){
		var elements = new Array();
		for(var i = 0; i < tableIdArray.length; i++){
	 		readTable(tableIdArray[i],elements,doc);
		}
		
		return elements;
	}


	function epoApplyPolicySettings(){
		OrionCore.showPleaseWait(true);
	
		var tableIdArray = new Array("mon-usertable","mon-proctable","mon-extntable","mon-filetable","mon-regtable");
		var doc = OrionCore.getXMLDocument("<mon></mon>");
		var children = tablesToXml(tableIdArray, doc);
		for(var i = 0; i < children.length; i++) {
			var child = children[i];
			doc.documentElement.appendChild(child);
		}
		OrionCore.doAsyncXMLAction("/SOLIDCORE_META/savePolicies.do",doc,_success,_failure,"POST");
	}
	
	function readTable(tableId,elements,doc){
		var table = document.getElementById(tableId);
		var rows = table.getElementsByTagName("tr");
		for(var i = 1; i < rows.length; i++){	
			var row = rows[i];
			var cells = row.getElementsByTagName("td");
			
			var filterValue = cells[0].firstChild.nodeValue;
			var patternValue = cells[1].firstChild.nodeValue;
			var typeValue = tableId;
			
			var elem = doc.createElement("monrule");
			elem.setAttribute("action",filterValue);
			elem.setAttribute("pattern", patternValue);
			elem.setAttribute("type",typeValue);

			elements.push(elem);			
		}
	}

	function addRow(tableId,name,includeRadio,excludeRadio){
		epoEnableApplyButton();
	
         var table = document.getElementById(tableId);  
         var rowCount = table.rows.length;  
         var row = table.insertRow(rowCount);  
         var cell1 = row.insertCell(0);  
	     var textValue = "include";
	     var includeRadio = document.getElementById(includeRadio).checked;
	     if(!includeRadio)
	   		textValue = "exclude";
	     var element1 = document.createTextNode(textValue);  
         cell1.appendChild(element1);  
   	     var cell2 = row.insertCell(1);  
	     var textValue = document.getElementById(name).value;
	     var textNode1 = document.createTextNode(textValue);
	     cell2.appendChild(textNode1);
            
   
             var cell3 = row.insertCell(2);  
	     var element2 = document.createElement("a");  
             element2.setAttribute('href', '#');
	     element2.appendChild(document.createTextNode('Delete'));
	     cell3.appendChild(element2);
	     element2.onclick=function(){deleteRow(tableId,rowCount)};

	}
function deleteRow(tableId,rowid){
	var table = document.getElementById(tableId);  
	table.deleteRow(rowid);
	}
</script>


 <orion:box>
  	<orion:titlebar text="${policyUsersFilters}"></orion:titlebar>
  	<div id="user" style="left:1%;top:10%;position:static;width:100%;overflow:hidden;background-color:#EBEBEB;">
  	<table>
  	<tbody>
  	<tr>
  	<td>
  	<orion:textbox name ="mon_rule_user_input" id="mon_rule_user_input"/>
  
  	</td>
  	<td>
  	<orion:radiobutton id="mon_rule_user_radio_include" name="mon_rule_user_radio"
                               value="none" text="${policyInclude}" checked="false" disabled="true"/><br/>
    <orion:radiobutton id="mon_rule_user_radio_exclude" name="mon_rule_user_radio"
                               value="none" text="${policyExclude}" checked="true"/><br/>
  	</td>
  	<td>
  	<orion:button id="addButtonUser"
                  text="${policyAdd}"
                  onclick="addRow('mon-usertable','mon_rule_user_input','mon_rule_user_radio_include','mon_rule_user_radio_exclude')" />
  	</td>
  	</tr>
  	</tbody>
  	</table>
  	<table id="mon-usertable"> 
  	<tr>
  	<td><orion:message key="policy.mon.filter" /></td>
  	<td><orion:message key="policy.mon.user" /></td>
  	<td><orion:message key="policy.mon.action" /></td>
  	</tr>
       <c:forEach var="pso"   items="${requestScope.users}" varStatus="rowCounter">
        <tr>      
        <td>${pso.includeExcludeStr}</td>  
        <td>${pso.field}</td>        
        <td><a href="#" onClick="deleteRow('mon-usertable',${rowCounter.count})"><orion:message key="policy.mon.delete" /></a></td>
        </tr>
       </c:forEach>
</table>
  	</div>
  	
 	 	
  	<orion:titlebar text="${policyProgramFilters}"></orion:titlebar>
  	
  	<div style="left:1%;top:10%;position:static;width:100%;overflow:hidden;background-color:#EBEBEB;">
  	<table>
  	<tbody>
  	<tr>
  	<td>
  	<orion:textbox name ="mon_rule_program_input" id="mon_rule_program_input"/>
  
  	</td>
  	<td>
  	<orion:radiobutton id="mon_rule_program_radio_include" name="mon_rule_program_radio"
                               value="none" text="${policyInclude}" checked="false"/><br/>
    <orion:radiobutton id="mon_rule_program_radio_exclude" name="mon_rule_program_radio"
                               value="none" text="${policyExclude}" checked="true"/><br/>
  	</td>
  	<td>
  	<orion:button id="addButtonProgram"
                  text="${policyAdd}"
                  onclick="addRow('mon-proctable','mon_rule_program_input','mon_rule_program_radio_include','mon_rule_program_radio_exclude')" />
  	</td>
  	</tr>
  	</tbody>
  	</table>
  	<table id="mon-proctable"> 
  	<tr>
  	<td><orion:message key="policy.mon.filter" /></td>
  	<td><orion:message key="policy.mon.program" /></td>
  	<td><orion:message key="policy.mon.action" /></td>
  	</tr>
       <c:forEach var="pso"   items="${requestScope.processes}" varStatus="rowCounter">
        <tr>      
        <td>${pso.includeExcludeStr}</td>  
        <td>${pso.field}</td>     
         <td><a href="#" onClick="deleteRow('mon-proctable',${rowCounter.count})"><orion:message key="policy.mon.delete" /></a></td>
        </tr>
       </c:forEach>
</table>

  	</div>
  	
  
  	<orion:titlebar text="${policyExtnFilters}"></orion:titlebar>
 
  	<div style="left:1%;top:10%;position:static;width:100%;overflow:hidden;background-color:#EBEBEB;">
  	<table>
  	<tbody>
  	<tr>
  	<td>
  	<orion:textbox name ="mon_rule_extn_input" id="mon_rule_extn_input"/>
  
  	</td>
  	<td>
  	<orion:radiobutton id="mon_rule_extn_radio_include" name="mon_rule_extn_radio"
                               value="none" text="${policyInclude}" checked="false"/><br/>
    <orion:radiobutton id="mon_rule_extn_radio_exclude" name="mon_rule_extn_radio"
                               value="none" text="${policyExclude}" checked="true"/><br/>
  	</td>
  	<td>
  	<orion:button id="addButtonProgram"
                  text="${policyAdd}"
                  onclick="addRow('mon-extntable','mon_rule_extn_input','mon_rule_extn_radio_include','mon_rule_extn_radio_exclude')" />
  	</td>
  	</tr>
  	</tbody>
  	</table>
  	<table id= "mon-extntable"> 
  	<tr>
  	<td><orion:message key="policy.mon.filter" /></td>
  	<td><orion:message key="policy.mon.extn" /></td>
  	<td><orion:message key="policy.mon.action" /></td>
  	</tr>
       <c:forEach var="pso"   items="${requestScope.extensions}" varStatus="rowCounter">
        <tr>      
        <td>${pso.includeExcludeStr}</td>  
        <td>${pso.field}</td>
        <td><a href="#" onClick="deleteRow('mon-extntable',${rowCounter.count})"><orion:message key="policy.mon.delete" /></a></td>
        </tr>
       </c:forEach>
</table>

  	</div>
  
  	<orion:titlebar text="${policyFileFilters}"></orion:titlebar>
  
  	<div style="left:1%;top:10%;position:static;width:100%;overflow:hidden;background-color:#EBEBEB;">
  	<table>
  	<tbody>
  	<tr>
  	<td>
  	<orion:textbox name ="mon_rule_file_input" id="mon_rule_file_input"/>
  
  	</td>
  	<td>
  	<orion:radiobutton id="mon_rule_file_radio_include" name="mon_rule_file_radio"
                               value="none" text="${policyInclude}" checked="false"/><br/>
    <orion:radiobutton id="mon_rule_file_radio_exclude" name="mon_rule_file_radio"
                               value="none" text="${policyExclude}" checked="true"/><br/>
  	</td>
  	<td>
  	<orion:button id="addButtonProgram"
                  text="${policyAdd}"
                  onclick="addRow('mon-filetable','mon_rule_file_input','mon_rule_file_radio_include','mon_rule_file_radio_exclude')" />
  	</td>
  	</tr>
  	</tbody>
  	</table>
  	<table id ="mon-filetable"> 
  	<tr>
  	<td><orion:message key="policy.mon.filter" /></td>
  	<td><orion:message key="policy.mon.path" /></td>
  	<td><orion:message key="policy.mon.action" /></td>
  	</tr>
       <c:forEach var="pso"   items="${requestScope.paths}" varStatus="rowCounter">
        <tr>      
        <td>${pso.includeExcludeStr}</td>  
        <td>${pso.field}</td>
        <td><a href="#" onClick="deleteRow('mon-filetable',${rowCounter.count})"><orion:message key="policy.mon.delete" /></a></td>
        </tr>
       </c:forEach>
</table>

  	</div>
  	
  	<orion:titlebar text="${policyRegFilters}"></orion:titlebar>
 
  	<div style="left:1%;top:10%;position:static;width:100%;overflow:hidden;background-color:#EBEBEB;">
  	<table>
  	<tbody>
  	<tr>
  	<td>
  	<orion:textbox name ="mon_rule_reg_input" id="mon_rule_reg_input"/>
  
  	</td>
  	<td>
  	<orion:radiobutton id="mon_rule_reg_radio_include" name="mon_rule_reg_radio"
                               value="none" text="${policyInclude}" checked="false"/><br/>
    <orion:radiobutton id="mon_rule_reg_radio_include" name="mon_rule_reg_radio"
                               value="none" text="${policyExclude}" checked="true"/><br/>
  	</td>
  	<td>
  	<orion:button id="addButtonProgram"
                  text="${policyAdd}"
                  onclick="addRow('mon-regtable','mon_rule_reg_input','mon_rule_reg_radio_include','mon_rule_reg_radio_include')" />
  	</td>
  	</tr>
  	</tbody>
  	</table>
  	<table id= "mon-regtable"> 
  	<tr>
  	<td><orion:message key="policy.mon.filter" /></td>
  	<td><orion:message key="policy.mon.reg" /></td>
   	<td><orion:message key="policy.mon.action" /></td>
  	</tr>
       <c:forEach var="pso"   items="${requestScope.registries}" varStatus="rowCounter">
        <tr>      
        <td>${pso.includeExcludeStr}</td>  
        <td>${pso.field}</td>   
        <td><a href="#" onClick="deleteRow('mon-regtable',${rowCounter.count})"><orion:message key="policy.mon.delete" /></a></td>
        </tr>
       </c:forEach>
</table>

  	</div>
</orion:box>

  
<script type="text/javascript">
    
</script>
