<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved.  -->
<%@ page import="com.mcafee.scor.awl.AWLConstants" %>
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.rulegroup.RuleGroupConstants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>


<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="<%=URLConstants.JS_AWL_VOS%>"/>

<orion:script context="/core" src="/majic.js"/>

<orion:message key="scor.saveGroup.button.txt" var="saveGroupButtonTxt" escape="none"/>
<orion:message key="scor.cancel.button.txt" var="cancelButtonTxt" escape="none"/>

<c:set var="WIN_OS" scope="request" value="<%=RuleGroupConstants.RULE_GROUP_OS.WIN.getValue()%>"/>
<c:set var="UNIX_OS" scope="request" value="<%=RuleGroupConstants.RULE_GROUP_OS.UNIX.getValue()%>"/>

<c:if test="${groupType == 'application_control'}">
	<orion:message var="scorGroupTypeBreadcrum" key="scor.policy.groups.addGroup.dialog.groupType.applicationControl" escape="none"/>
</c:if>
<c:if test="${groupType == 'change_control'}">
	<orion:message var="scorGroupTypeBreadcrum" key="scor.policy.groups.addGroup.dialog.groupType.changeControl" escape="none"/>
</c:if>
<c:if test="${groupType == 'mon'}">
	<orion:message var="scorGroupTypeBreadcrum" key="scor.policy.groups.addGroup.dialog.groupType.mon" escape="none"/>
</c:if>

<c:if test="${param.osType == WIN_OS}">
	<orion:message var="scorOsTypeBreadcrum" key="scor.policy.groups.addGroup.dialog.groupPlatform.windows" escape="none"/>
</c:if>
<c:if test="${param.osType == UNIX_OS}">
	<orion:message var="scorOsTypeBreadcrum" key="scor.policy.groups.addGroup.dialog.groupPlatform.unix" escape="none"/>
</c:if>
<orion:message key="scor.general.alertFailureMsg" var="alertFailureMsg" escape="javascript" />
<orion:titlebar text="${scorGroupTypeBreadcrum} > ${scorOsTypeBreadcrum} > ${scorRuleGroupName}" ></orion:titlebar>

            <orion:vbox>
                <orion:box>
                    <c:if test="${groupType == 'application_control'}">
                        <jsp:include page="<%=URLConstants.JSP_AWL%>"/>
                    </c:if>
                    <c:if test="${groupType == 'change_control'}">
                        <jsp:include page="<%=URLConstants.JSP_CHANGE_CONTROL%>"/>
                    </c:if>
                    <c:if test="${groupType == 'mon'}">
                        <jsp:include page="<%=URLConstants.JSP_POLICY%>"/>
                    </c:if>
                </orion:box>
            <c:choose>
	            <c:when test="${hideFooterInRuleGroup == 'true'}">
	            <%-- No Footer bar--%>
            	</c:when>
            	<c:otherwise>
					<orion:footerbar align="right">
						<orion:button id="saveGroup" text="${saveGroupButtonTxt}"
							onclick="scor.grpMgmt.scorSaveGroup();" />
						<orion:button id="cancelButton" text="${cancelButtonTxt}"
							onclick="scor.grpMgmt.showPreviousPage();" />
					</orion:footerbar>
				</c:otherwise>
			</c:choose>

</orion:vbox>

<script type="text/javascript">
    var scor;
    scor = scor || {};
    scor.grpMgmt = scor.grpMgmt || {};

    scor.grpMgmt.grpType = '${orion:escapeJavaScriptString(groupType)}';
    scor.grpMgmt.osType  = '${orion:escapeJavaScriptString(param.osType)}';
    
    <%--This function epoEnableApplyButton is here to avoid JS errors due to the jsps used in d policy page--%>
    function epoEnableApplyButton() {

    }
    scor.grpMgmt.saveGrpSuccess = function() {
        OrionCore.showPleaseWait(false);
        OrionCore.doAction('<%=URLConstants.SHOW_RULE_GROUPS_TABS_URL%>',
                ['<%=Constants.GROUP_TYPE_PARAMETER%>',scor.grpMgmt.grpType
                    ,'<%=Constants.GROUP_PLATFORM%>', scor.grpMgmt.osType,"currentTab","ScorPolicyGroups","sectionId","orion.configuration","tabId","scor.tab.configuration"],"GET");
    }
    scor.grpMgmt.saveGrpFailure = function() {
        OrionCore.showPleaseWait(false);
        alert('${alertFailureMsg}');
    }
    scor.grpMgmt.scorSaveGroup = function() {
        var updatedGrp = scor.grpMgmt.getGroup();
        var updatedGrpJSON = JSON.stringify(updatedGrp);
        scor.actions.doAsyncAction('<%=URLConstants.UPDATE_GROUP_RULES_URL%>',
                ['<%=Constants.GROUP_DATA%>', updatedGrpJSON, '<%=Constants.GROUP_TYPE%>',scor.grpMgmt.grpType],
                scor.grpMgmt.saveGrpSuccess,
                scor.grpMgmt.saveGrpFailure,
                "POST");
    }
    scor.grpMgmt.showPreviousPage = function(){
        OrionCore.doAction('<%=URLConstants.SHOW_RULE_GROUPS_TABS_URL%>',
                ['<%=Constants.GROUP_TYPE_PARAMETER%>',scor.grpMgmt.grpType
                    ,'<%=Constants.GROUP_PLATFORM%>', scor.grpMgmt.osType,"currentTab","ScorPolicyGroups","sectionId","orion.configuration","tabId","scor.tab.configuration"],"GET");
    }
    
    scor.grpMgmt.init = function() {
        var group = JSON.parse('${orion:escapeJavaScript(groupJson)}');
        if(group) {
          var enabled = ( group['readOnly'] === "true" ) ? false : true;
          
          <c:choose>
          	<c:when test="${hideFooterInRuleGroup == 'true'}">
          	
          	<%-- Nothing to be done --%>
          	</c:when>
          	<c:otherwise>
          	var saveButton = new Button("saveGroup");
          	saveButton.setEnabled(enabled);
          	</c:otherwise>
          </c:choose>
        }
        scor.grpMgmt.loadGroup(group);
        scor.grpMgmt.adjustUiItems();
    }
    OrionCore.addLoadHandler(scor.grpMgmt.init);
    
</script>
