<%--
//-----------------------------------------------------------------------------
// Copyright (c) 2011-2012 XEROX Corporation.  All rights reserved
//-----------------------------------------------------------------------------
// Revision History:
// -----------------
// AR Number      Author   Date         Change Description
// ---------      ------   ----         ------------------
//
// CQGbl00349040  bvu      01/04/2012   Created       
//-----------------------------------------------------------------------------
--%>

<%--
  This is the page for the Software "more" page.
--%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>

<orion:core>

  <orion:corehead>

    <script type="text/javascript">

      // Goes back to the main view (Xerox MFP table) of the Xerox extension
      function backToExtensionHome() {
        OrionCore.doAction("/XeroxMFP/backToExtensionHome.do", null);
      }

    </script>

  </orion:corehead>

  <orion:corebody>

    <orion:navigation tabId="XeroxMFP.tab"/>
    <orion:content>

      <orion:vbox>

        <orion:box height="auto">

          <orion:message key="XeroxMFP.systemSoftwareMore.title" escape="none" var="systemSoftwareMoreTitle" />
          <orion:titlebar id="listTitle" text="${systemSoftwareMoreTitle}" />

          <table id="systemSoftwareMore" width="100%" cellspacing="0">

            <tr>
              <td colspan="2" class="orionSummaryHeader">
                <orion:message key="XeroxMFP.device.details.software.more.installed"/>
              </td>
            </tr>

            <c:choose>
              <c:when test="${softwareStatus != ''}">
              <tr>
                <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;" width="35%">
                  <orion:message key="XeroxMFP.device.details.software.version"/>
                </td>
                <td class="orionSummaryColumn"><c:out value="${systemSoftware}"/></td>
              </tr>

              <tr>
                <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;">
                  <orion:message key="XeroxMFP.device.details.software.status"/>
                </td>
                <td class="orionSummaryColumn"><c:out value="${softwareStatus}" escapeXml="false"/></td>
              </tr>
              </c:when>

              <c:otherwise>
              <tr>
                <td colspan="2" class="orionSummaryColumn">
                  <orion:message key="XeroxMFP.device.details.dataUnavailable"/>
                </td>
              </tr>
            </c:otherwise>
          </c:choose>

        <tr>
          <td colspan="2" class="orionSummaryHeader">
            <orion:message key="XeroxMFP.device.details.software.more.available"/>
          </td>
        </tr>

        <c:choose>
          <c:when test="${softwareInfo != null}">
          <tr>
            <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;">
              <orion:message key="XeroxMFP.device.details.software.version"/>
            </td>
            <td class="orionSummaryColumn"><c:out value="${softwareInfo.version}"/></td>
          </tr>

          <tr>
            <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;">
              <orion:message key="XeroxMFP.device.details.software.more.releasedDate"/>
            </td>
            <td class="orionSummaryColumn"><c:out value="${softwareInfo.releaseDate}"/></td>
          </tr>

          <tr>
            <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;">
              <orion:message key="XeroxMFP.device.details.software.more.fileSize"/>
            </td>
            <td class="orionSummaryColumn"><c:out value="${softwareInfo.fileSize}"/></td>
          </tr>

          <tr>
            <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;">
              <orion:message key="XeroxMFP.device.details.software.more.fileFormat"/>
            </td>
            <td class="orionSummaryColumn"><c:out value="${softwareInfo.fileFormat}"/></td>
          </tr>

          <tr>
            <td class="orionSummaryColumn" style="border-right: 1px solid #E1E1E1;">
              <orion:message key="XeroxMFP.device.details.software.more.link"/>
            </td>
            <td class="orionSummaryColumn">
              <a href='<c:out value="${softwareInfo.filePath}"/>' target=_blank>
                <orion:message key="XeroxMFP.device.details.software.more.download"/>
              </a>
            </td>
          </tr>
          </c:when>

          <c:otherwise>
          <tr>
            <td colspan="2" class="orionSummaryColumn">
              <orion:message key="XeroxMFP.device.details.software.more.notAvailable"/>
            </td>
          </tr>
          </c:otherwise>
        </c:choose>
      </table>

    </orion:box>

    <orion:box height="32">

      <orion:footerbar>
        <orion:message key="XeroxMFP.label.close" escape="none" var="closeLabel" />     
	<orion:button id="close" onclick="backToExtensionHome();" text="${closeLabel}"/>
                
      </orion:footerbar>
    </orion:box>

  </orion:vbox>

</orion:content>
</orion:corebody>
</orion:core>

