<!-- COPYRIGHT:		Copyright (C) 2008-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="orion" uri="http://www.mcafee.com/orion" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@ page import="com.mcafee.scor.common.CommonURLConstants" %>
<orion:message key="${noRecordsKey}" var="norecords" escape="HTML"/>
<orion:script context="/SOLIDCORE_META" src="/jsFiles/scorDialogTable.js"/>
<%-- This sets up all the attributes, etc... --%>
${scor:tableTagInit(pageContext)}

<style type="text/css">
	.dlgContentTd{
		text-indent:8px;
		vertical-align:middle;
	}
	.dlgHeaderTd{
		font-weight:bold;
		background-color: rgb(235, 235, 235);
		cursor: default;
	}
</style>

<c:set var="htmlId" value="${orion:escapeHtml(id)}"/>
<c:set var="jsId" value="${orion:escapeJavaScriptString(id)}"/>
<%-- create the vbox DIV for layout --%>
<div id = "${htmlId}_scorDialogTableMain">
<span id="${htmlId}_norecordsfound" style="display: none;"> ${norecords} </span>
<%-- create the layout DIV for the title and column headers--%>
<div id = "${htmlId}_scorDialogTableLayout" style= "display: block;">
<table style="table-layout:fixed; border-collapse:collapse;" cellspacing="0" cellpadding="0" border="0" width="100%">
<tbody id="${htmlId}_body" class="tableHeaderBody">
<tr class="orionTableRowAlt">
    <c:if test="${showCheckboxColumn && !singleSelect}">
        <td style="width:22px;" id="orion.table.uid.col"><input type="checkbox" id="${htmlId}_selectall" name="${htmlId}_selectall" onclick="ScorDialogTable.selectAll('${htmlId}')"></input></td>
    </c:if>

    <c:if test="${showCheckboxColumn && singleSelect}">
        <td style="width:22px;" id="orion.table.uid.col"></td>
    </c:if>

    <c:forEach var="idx" begin="0"
               end="${fn:length(propertyNames)-1}" step="1">
        <td id="${htmlId}_col_${idx}" class="dlgHeaderTd" <c:if test="${scor:collectionContains(hiddenProperties,propertyNames[idx]) }">style="display: none"</c:if> >
            <div style="cursor: default;" title="${orion:escapeHtml(headerNames[propertyNames[idx]])}">${orion:escapeHtml(headerNames[propertyNames[idx]])}</div></td>
    </c:forEach>
</tr>
</tbody>
</table>
<%-- close layout DIV for title and column headers --%>
</div>




<c:if test="${paginated || showCheckboxColumn}">
<div id = "${htmlId}_scorDialogTableFooter" class="layout_box_26">
<table class="orionTableFooter" id="${htmlId}_tableFooter" width="100%" cellspacing="0" cellpadding="0">
<tr>

<c:if test="${paginated}">
<td align="right">

    <%-- Current position info --%>
    <span class="positionText" id="${htmlId}_tableLocationText">
    </span>
    <%-- white space --%>
    &nbsp;&nbsp;
    <%-- "jump to page" text --%>
    <span class="positionText">${tableJumpToText}</span>

    <%-- "jump to page" input field --%>
    <orion:textbox width="3" maxlength="6" id="${htmlId}_pageNumber"
           onkeydown="ScorDialogTable.jump(event, '${jsId}', this);"
           onblur="ScorDialogTable.jump(event, '${jsId}', this);"
           class="orionJumpToInput"/>
</td>

<%-- jump to first page --%>
<td class="orionTableFooterNavButton">

<c:choose>
      <c:when test="${isEpoVersionGreaterThanEqualTo4_6}">
   <img border="0" width="28" height="26" id="${htmlId}_firstPage" title="${tablePaginationFirst}" src="/core/images/contentwindow_selectionbar_pagination_beginning.png" />
      </c:when>

      <c:otherwise>
    <img border="0" width="28" height="26" id="${htmlId}_firstPage" title="${tablePaginationFirst}" src="/core/img/contentwindow_selectionbar_pagination_beginning.png" />
      </c:otherwise>
</c:choose>



</td>

<%-- divider--%>
<td class="orionTableFooterNavButtonDivider">
    <img border="0" width="2" height="26" id="${htmlId}_navDivider0"
         src="/core/images/table/table-footer-divider.png">
</td>

<%-- previous page--%>
<td class="orionTableFooterNavButton">

<c:choose>
      <c:when test="${isEpoVersionGreaterThanEqualTo4_6}">
   <img border="0" width="28" height="26" id="${htmlId}_prevPage" title="${tablePaginationPrevious}" src="/core/images/contentwindow_selectionbar_pagination_backward.png" />
      </c:when>

      <c:otherwise>
     <img border="0" width="28" height="26" id="${htmlId}_prevPage" title="${tablePaginationPrevious}" src="/core/img/contentwindow_selectionbar_pagination_backward.png" />
      </c:otherwise>
</c:choose>




</td>

<%-- divider--%>
<td class="orionTableFooterNavButtonDivider">
    <img border="0" width="2" height="26" id="${htmlId}_navDivider1"
         src="/core/images/table/table-footer-divider.png">
</td>

<%-- next page --%>
<td class="orionTableFooterNavButton">
<c:choose>
      <c:when test="${isEpoVersionGreaterThanEqualTo4_6}">
   <img border="0" width="28" height="26" id="${htmlId}_nextPage" title="${tablePaginationNext}" src="/core/images/contentwindow_selectionbar_pagination_forward.png" />
      </c:when>

      <c:otherwise>
     <img border="0" width="28" height="26" id="${htmlId}_nextPage" title="${tablePaginationNext}" src="/core/img/contentwindow_selectionbar_pagination_forward.png" />
      </c:otherwise>
</c:choose>

</td>

<%-- divider --%>
<td class="orionTableFooterNavButtonDivider">
    <img border="0" width="2" height="26" id="${htmlId}_navDivider2"
         src="/core/images/table/table-footer-divider.png">
</td>

<%-- jump to last page --%>
<td class="orionTableFooterNavButton">
<c:choose>
      <c:when test="${isEpoVersionGreaterThanEqualTo4_6}">
   <img border="0" width="28" height="26" id="${htmlId}_lastPage" title="${tablePaginationLast}" src="/core/images/contentwindow_selectionbar_pagination_end.png" />
    </c:when>

	<c:otherwise>
   <img border="0" width="28" height="26" id="${htmlId}_lastPage" title="${tablePaginationLast}" src="/core/img/contentwindow_selectionbar_pagination_end.png" />
      </c:otherwise>
</c:choose>



</td>

</c:if>
</tr>
</table>
</div>

</c:if>

<%-- close layout DIV for entire table. --%>

</div>


<script type="text/javascript">
initializeTag = function()
{



    ScorDialogTable.locationText = "${tableLocationText}";

    ScorDialogTable.tableParameters["${jsId}"] = {
        id : "${jsId}",
        initialized: false,
        sortable : ${sortable},
        paginated : ${paginated},
        showCheckboxColumn :  ${showCheckboxColumn},
        singleSelect :  ${singleSelect},
        registeredType : "",
        datasourceAttr : "${orion:escapeJavaScriptString(datasourceAttr)}",
        tableCellRendererAttr : "${orion:escapeJavaScriptString(cellRendererAttr)}",
        columnWidths : "${columnWidths}",
        propertyNames : [${propertyNamesJS}],
        data : [],
        uidMap : [],
        hiddenColumns : [${hiddenPropertiesJS}] 
    };
   ScorDialogTable.initializeTables('${jsId}');

}

initializeTag();

ScorDialogTable.refresh("${jsId}",null,10);

</script>

