<!-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved-->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="orion" uri="http://www.mcafee.com/orion" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<orion:message key="scor.policy.awl.option.tab.features.feature.enforce" escape="none" var="enforce"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.activex" escape="none" var="activex"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.execution-control" escape="none" var="executionControl"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.ob-logging" escape="none" var="oblogging"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.mp" escape="none" var="mp"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.mp-nx" escape="none" var="mpnx"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.mp-casp" escape="none" var="mpcasp"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.mp-vasr" escape="none" var="mpvasr"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.pkg-ctrl" escape="none" var="pkgctrl"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.pkg-ctrl-bypass" escape="none" var="pkgctrlbypass"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.pkg-ctrl-allow-uninstall" escape="none" var="pkgctrlallowuninstall"/>
<orion:message key="scor.policy.awl.option.tab.features.feature.sau" escape="none" var="sau"/>

<jsp:include page="/common/includejQuery.jsp"/>



<c:set var="htmlId" value="${orion:escapeHtml(id)}"/>
<c:set var="featuresStr" value="${orion:escapeHtml(features)}"/>

<table id="featuresTable" width='100%'>
<tr>

	<td class="orionSummaryHeader" id="feature_control_header">
		<orion:message key="scor.policy.awl.option.tab.features.feature.featureControl" escape="html"/>
	</td>	
	<td class="orionSummaryColumn" id="feature_control_column">
		<table>
			<tr>
				<td>
					<orion:checkbox  id="enforce_feature" name="enforce_feature_ckbox" onclick="enforceFeatures()" text="${enforce}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="activex_ckbox" name="activex" onclick="epoEnableApplyButton()" text="${activex}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="execution-control_ckbox" name="execution-control" onclick="epoEnableApplyButton()" text="${executionControl}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="mp_ckbox" name="mp" onclick="epoEnableApplyButton()" text="${mp}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="mp-casp_ckbox" name="mp-casp" onclick="epoEnableApplyButton()" text="${mpcasp}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="mp-nx_ckbox" name="mp-nx" onclick="epoEnableApplyButton()" text="${mpnx}"/>
				</td>
			</tr>
			<tr style="display:none">
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="mp-vasr_ckbox" name="mp-vasr" onclick="epoEnableApplyButton()" text="${mpvasr}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="ob-logging_ckbox" name="ob-logging" onclick="epoEnableApplyButton()" text="${oblogging}"/>
				</td>
			</tr>
			<tr>				
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="pkg-ctrl_ckbox" name="pkg-ctrl" onclick="epoEnableApplyButton()" text="${pkgctrl}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="pkg-ctrl-bypass_ckbox" name="pkg-ctrl-bypass" onclick="epoEnableApplyButton()" text="${pkgctrlbypass}"/>
				</td>
			</tr>
			<tr>
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="pkg-ctrl-allow-uninstall_ckbox" name="pkg-ctrl-allow-uninstall" onclick="epoEnableApplyButton()" text="${pkgctrlallowuninstall}"/>
				</td>
			</tr>
			<tr>				
				<td>
					&nbsp;&nbsp;&nbsp;&nbsp;<orion:checkbox  id="sau_ckbox" name="sau" onclick="epoEnableApplyButton()" text="${sau}"/>
				</td>
			</tr>
		</table>
	</td>	


</tr>
</table>

<script type="text/javascript">


/**
 @constructor
 */
var scor = scor || {};

scor.features = function(){

var populateData = function(features,enforcePolicy,isReadOnlyPolicyObject){
	var dataFromDBContainsPkgCtrlAllowUninstall = false;
	$j.each(features,
			function (index,feature){
		var featureName=feature['featureName'];
		var featureValue=feature['status'];
		var featureValueBool = (featureValue === 'true');
		var ckboxBoxId="#"+featureName+"_ckbox";
		$j(ckboxBoxId).attr('checked',featureValueBool);
		
		if (featureName === 'pkg-ctrl-allow-uninstall') {
			dataFromDBContainsPkgCtrlAllowUninstall = true;
		}
		
		}
	);
	
	if (dataFromDBContainsPkgCtrlAllowUninstall === false) {
		var pkgctrlckboxstatus = $j('#pkg-ctrl_ckbox').is(':checked');
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('checked',pkgctrlckboxstatus);
	}
	
	
	$j('#enforce_feature').attr('checked',enforcePolicy);
	scor.features.isReadOnlyPolicyObject = isReadOnlyPolicyObject;
	enableDisableFeaturesCheckBox();
	disablePkgCtrlAllowUninstallCheckBoxForBypass();
}


var getEnforceData = function(){
	var enforce_status=$j('#enforce_feature').is(':checked');
	return enforce_status.toString();
}


var getData = function(){
    var featuresData=[];
    var features=$j('#featuresTable input[id$="ckbox"]');
    $j.each(features,
 	 function(index,obj){
	   var feature_name =  obj.name;
	   if(feature_name == 'enforce_feature_ckbox')
		{	
			return true;
		}		
	   var ckboxid="#"+feature_name+"_ckbox";
	   var feature_status=$j(ckboxid).is(':checked');
	   var featureVo={};
	   featureVo['featureName']=feature_name;
	   featureVo['status']=feature_status.toString();
	   featuresData.push(featureVo);							 		
	});	
      		
return featuresData;
}

var disable = function(){
	$j('#featuresTable :checkbox').attr('disabled',true);
}

return {
	populateData: populateData,
	getData: getData,
	getEnforceData: getEnforceData,
	disable : disable	
};

}();

<!-- When user checks on Enforce Feature control from ePO, all checkboxes should get enabled. -->
<!-- The pkg-ctrl allow uninstallation suboptions should remain disabled, if pkg-ctrl-bypass is selected. -->
function enforceFeatures(){

epoEnableApplyButton();
enableDisableFeaturesCheckBox();
disablePkgCtrlAllowUninstallCheckBoxForBypass();

}


function enableDisableFeaturesCheckBox(){
	if( $j('#enforce_feature').is(':checked') == true && scor.features.isReadOnlyPolicyObject != true){
		$j('#featuresTable input[id$="ckbox"]').attr('disabled',false);
	}else{
		$j('#featuresTable input[id$="ckbox"]').attr('disabled',true);
	}
}

function checkPkgCtrlIfSubfeatureChecked() {
	if ($j('#pkg-ctrl-bypass_ckbox').is(':checked') == true ||
		$j('#pkg-ctrl-allow-uninstall_ckbox').is(':checked') == true) {
			$j('#pkg-ctrl_ckbox').attr('checked',true);
	}
}

function handleChangesInPkgCtrlCheckbox() {
	var pkgCtrlCheckBoxStatus = $j('#pkg-ctrl_ckbox').is(':checked');
	
	if (pkgCtrlCheckBoxStatus == true) {
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('checked',pkgCtrlCheckBoxStatus);
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('disabled',false);
	} else {
		$j('#pkg-ctrl-bypass_ckbox').attr('checked',pkgCtrlCheckBoxStatus);
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('checked',pkgCtrlCheckBoxStatus);
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('disabled',false);
	}
}

function handleChangesInPkgCtrlBypassCheckbox() {
	var pkgCtrlBypassCheckBoxStatus = $j('#pkg-ctrl-bypass_ckbox').is(':checked');
	if (pkgCtrlBypassCheckBoxStatus == true) {
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('disabled',true);
	} else {
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('disabled',false);
	}
}

function disablePkgCtrlAllowUninstallCheckBoxForBypass() {
	var pkgCtrlBypassCheckBoxStatus = $j('#pkg-ctrl-bypass_ckbox').is(':checked');
	if (pkgCtrlBypassCheckBoxStatus == true) {
		$j('#pkg-ctrl-allow-uninstall_ckbox').attr('disabled',true);
	}
}

function registerCallBackHandlers(){

$j('#mp_ckbox').bind('click',function(){
var mp_feature_status=$j('#mp_ckbox').is(':checked');
 if(mp_feature_status == true){
	 checkMPBoxes(true);
	
}else{
	 checkMPBoxes(false);
	
  }
});

$j('#mp-nx_ckbox').bind('click',checkForAllMPboxes);
$j('#mp-casp_ckbox').bind('click',checkForAllMPboxes);
$j('#mp-vasr_ckbox').bind('click',checkForAllMPboxes);

$j('#pkg-ctrl_ckbox').bind('click',handleChangesInPkgCtrlCheckbox);

$j('#pkg-ctrl-bypass_ckbox').bind('click',checkPkgCtrlIfSubfeatureChecked);
$j('#pkg-ctrl-bypass_ckbox').bind('click',handleChangesInPkgCtrlBypassCheckbox);

$j('#pkg-ctrl-allow-uninstall_ckbox').bind('click',checkPkgCtrlIfSubfeatureChecked);

}

function checkMPBoxes(check){
	$j('#mp-nx_ckbox').attr('checked',check);
	$j('#mp-casp_ckbox').attr('checked',check);
	$j('#mp-vasr_ckbox').attr('checked',check);
	 
}

function disableMPBoxes(state){
 	 $j('#mp-nx_ckbox').attr('disabled',state);
	 $j('#mp-casp_ckbox').attr('disabled',state);
	 $j('#mp-vasr_ckbox').attr('disabled',state);
}

function checkForAllMPboxes(){
if( $j('#mp-nx_ckbox').is(':checked') == true ||
    $j('#mp-casp_ckbox').is(':checked') == true ||
    $j('#mp-vasr_ckbox').is(':checked') == true ){
		$j('#mp_ckbox').attr('checked',true);
	
}
if( $j('#mp-nx_ckbox').is(':checked') == false &&
    $j('#mp-casp_ckbox').is(':checked') == false &&
    $j('#mp-vasr_ckbox').is(':checked') == false ){
	 $j('#mp_ckbox').attr('checked',false);
	
 
}
			

}



 OrionCore.addLoadHandler(registerCallBackHandlers);

</script>






