<!-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri='http://java.sun.com/jsp/jstl/core' prefix='c' %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ page import="com.mcafee.scor.common.ScorUtilities" %>
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>


<orion:message key="scor.task.server.extract.infoLbl" var="extractinfoLbl" />
<orion:message key="scor.task.server.extract.preMsg" var="extractPreMsg" />
<orion:message key="scor.task.server.extract.postMsg" var="extractPostMsg" />
<orion:message key="scor.task.server.extract.nwInfoMsg" var="nwInfoMsg" />
<orion:message key="scor.task.server.extract.nwDomain" var="nwDomainParam" />
<orion:message key="scor.task.server.extract.nwUser" var="nwUserParam" />
<orion:message key="scor.task.server.extract.nwPwd" var="nwPwdParam" />
<orion:message key="scor.task.server.extract.testBtn" var="tstBtnTxt" escape="none"/>
<orion:message key="scor.error.dialogBox.title" var="scorErrorDialogBoxTitle" escape="javascript"/>
<orion:message key="scor.task.server.extract.addToRuleGrpLbl" var="addToRuleGrpLbl" escape="HTML"/>
<orion:message key="scor.task.server.testBtn.success" var="testBtnSuccess" escape="javascript"/>
<orion:message key="scor.error.duplicate" var="errorDuplicateJs" escape="javascript"/>
<orion:message key="scor.error.duplicate" var="errorDuplicateHtml" />


<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.SERVER_TASK_SCAN_SOFTWARE_REPOSITORY%>");
</script>





<table id="ExtractCertConfig_${orion:escapeHtml(parentIndex)}" width="100%" style="border: 1px solid ;">
    <tr>
		<td>
			${extractinfoLbl}
		</td>
	</tr>
	<tr>		
		<td>
			<div>
			${extractPreMsg}
			<orion:textbox id="binaryPath_${parentIndex}" name="binaryPath_${parentIndex}"  required="true"/>
			</div>
		</td>		
	</tr>			
	<tr>		
		<td>
			<div id="nwConfigPanel">				
				<table>
					<tr>
						<td colspan="2">
							 <div style="margin-top: 5px;margin-bottom: 5px">${nwInfoMsg}</div>
						</td>
					</tr>
					<tr>
						<td>${nwDomainParam}</td>
						<td>
							<input type="text" id="domainId_${parentIndex}" />
						</td>						
					</tr>				
					<tr>
						<td>${nwUserParam}</td>
						<td>
							<input type="text" autocomplete="off" id="userId_${parentIndex}" />
						</td>
					</tr>	
					<tr>
						<td>${nwPwdParam}</td>
							<td><input type="password" autocomplete="new-password" id="pwdId_${parentIndex}" />
						</td>
					</tr>	
					<tr>
				<td>
					<orion:button disabled="true" id="testBtnId_${parentIndex}" text="${tstBtnTxt}" onclick="testCredentials_${orion:escapeJavaScriptString(parentIndex)}();"/>
				</td>
			</tr>			
				</table>
			</div>
			<div id="info_test_con_${parentIndex}" style="display:none;">
        	*&nbsp;${errorDuplicateHtml}
   			</div>			
		</td>		
	</tr>				
</table>

<table id="RuleGroupConfig_${orion:escapeHtml(parentIndex)}" width="100%" style="border: 1px solid; background-color: rgb(235, 235, 235);">
	<tr>
		<td>
			<input type="checkbox" id="addToRuleGrpChkBox_${parentIndex}" onclick="_enableRuleGroupAdd_${parentIndex}(this);"/>
			<label>${addToRuleGrpLbl}</label>
			<orion:select id="ruleGroupId_${parentIndex}" disabled ="true" name="userGroupSelect_${parentIndex}" items="${userDefinedGroups}"/>
		</td>		
	</tr>
</table>

<script type="text/javascript">

_scorCheckUncAndUpdateTestBtn= function() {
	var binary_path=$('binaryPath_${orion:escapeHtml(parentIndex)}').value;
	var test_btn = $('testBtnId_${orion:escapeHtml(parentIndex)}');
	var testButton = new Button('testBtnId_${orion:escapeHtml(parentIndex)}');
	var domainBox = $('domainId_${orion:escapeHtml(parentIndex)}');
	var userBox = $('userId_${orion:escapeHtml(parentIndex)}');
	var pwdBox = $('pwdId_${orion:escapeHtml(parentIndex)}');

	if(binary_path.length >= 2 && "\\" === binary_path.charAt(0) && "\\" === binary_path.charAt(1)) {
		testButton.setEnabled(true);
		domainBox.disabled = false;
		userBox.disabled = false;
		pwdBox.disabled = false;
	} else {
		testButton.setEnabled(false);
		domainBox.disabled = true;
		userBox.disabled = true;
		pwdBox.disabled = true;
	}
}


OrionEvent.registerHandlerById('binaryPath_${orion:escapeHtml(parentIndex)}', _scorCheckUncAndUpdateTestBtn,  null, 'keyup', false);

_enableRuleGroupAdd_${orion:escapeJavaScriptString(parentIndex)}=function(chkBox)
{
	var enable = chkBox.checked;
	OrionCore.setEnabledById( "ruleGroupId_${orion:escapeHtml(parentIndex)}", enable );
}

scorResult = function(resObj) {
    var vo = {
        "returnCode":resObj.returnCode.code,
        "msg":resObj.msg,

        "result":resObj.result
    };
 
    return {
       
        "getReturnCode": function() {
            return vo.returnCode;
        },"getMsg": function() {
            return vo.msg;
        },"getResult": function() {
            return vo.result;
        },"isSuccess": function() {
            return vo.returnCode === 0;
        },"isFailure": function() {
            return !(this.isSuccess());
        }
    };
};

doAsyncAction = function(action, params, callbackSuccess, callbackfailure, method) {
    method = method ? method : "POST";
   

    OrionCore.doAsyncAction(action,
            params,
            function(result) {
                asyncActionDefSuccess(result, callbackSuccess);
            },
            function() {
                asyncActionDefFailure(callbackfailure);
            },
            method);
};

asyncActionDefSuccess = function(result, callbackSuccess) {
	OrionCore.showPleaseWait(false);
    var resultObj = JSON.parse(result);
    var resultVO = scorResult(resultObj);
    if (resultVO.isFailure()) {
        OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
        OrionCore.showDialogBox(true, resultVO.getMsg(), OrionCore.DIALOG_OK);
    }else{
        callbackSuccess(resultVO.getResult(),resultVO.getReturnCode(),resultVO.getMsg());
    }
};

asyncActionDefFailure = function(callbackfailure) {
   
    if (typeof callbackfailure === 'function') {
        callbackfailure();
    } else {
    	OrionCore.showPleaseWait(false);
        OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
        OrionCore.showDialogBox(true, '${scorDefAsyncFailureMsg}', OrionCore.DIALOG_OK);
    }
};

getDataValue = function (input){
	if(input === undefined||input ===null){
		return "";
	} 
	return input;
}


formatDataValue = function (input){
	if(input === undefined||input ===null){
		return "";
	} 
	return input;
}

cleanInfoDiv_${orion:escapeJavaScriptString(parentIndex)}= function(msg){
	 var infoDiv = $('info_test_con_${orion:escapeHtml(parentIndex)}');
	 infoDiv.innerHTML='*&nbsp;${errorDuplicateJs}';	
	 infoDiv.style.display = "none";   
}

showInfoMsg_${orion:escapeJavaScriptString(parentIndex)} = function(msg){
	 var errorDiv = $('info_test_con_${orion:escapeHtml(parentIndex)}');
    if (msg) {
        errorDiv.innerHTML = msg;
    } else {
        errorDiv.innerHTML='*&nbsp;${errorDuplicateJs}';
    }
    errorDiv.style.display = (msg ? "block" :"none");
}

_testCredentialsSuccess_${orion:escapeJavaScriptString(parentIndex)}=function(result){
	 showInfoMsg_${orion:escapeJavaScriptString(parentIndex)}('${testBtnSuccess}');
}

testCredentials_${orion:escapeJavaScriptString(parentIndex)} = function(){
	  cleanInfoDiv_${orion:escapeJavaScriptString(parentIndex)}();
	  OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
	  var binaryPathVal = $('binaryPath_${orion:escapeHtml(parentIndex)}').value;
	  var domainVal = formatDataValue($('domainId_${orion:escapeHtml(parentIndex)}').value);
	  var userVal = formatDataValue($('userId_${orion:escapeHtml(parentIndex)}').value);
	  var pwdVal =  formatDataValue($('pwdId_${orion:escapeHtml(parentIndex)}').value);
	  OrionCore.showPleaseWait(true);
	  doAsyncAction("<%=URLConstants.TEST_CONNECTION_URL%>",
	             ["BINARY_PATH", binaryPathVal,"DOMAIN",domainVal,"USER",userVal,"PWD",pwdVal],_testCredentialsSuccess_${orion:escapeJavaScriptString(parentIndex)});
}

_setData = function(container, data){
	var pathToExtract = OrionCore.getChildNodeById(container, "binaryPath_${orion:escapeHtml(parentIndex)}");
	pathToExtract.value = getDataValue(data.pathToExtract);
	var domainName = OrionCore.getChildNodeById(container, "domainId_${orion:escapeHtml(parentIndex)}");
	domainName.value=getDataValue(data.domainName);
	var userName = OrionCore.getChildNodeById(container, "userId_${orion:escapeHtml(parentIndex)}");
	userName.value=getDataValue(data.userName);	
	var pwdTxt = OrionCore.getChildNodeById(container, "pwdId_${orion:escapeHtml(parentIndex)}");
	pwdTxt.value=getDataValue(data.pwdTxt);		
	var rgID=getDataValue(data.ruleGrpID);
	//setup rule group UI
	var shouldAdd = OrionCore.getChildNodeById(container,"addToRuleGrpChkBox_${orion:escapeHtml(parentIndex)}");
	shouldAdd.checked = false;
	if ((rgID === undefined || rgID === null)) {		
		return;
    }else{    	
    	rgID = OrionCore.trim(String(rgID));    	
    	var ruleGrpID = OrionCore.getChildNodeById(container, "ruleGroupId_${orion:escapeHtml(parentIndex)}");
    	var grpOptions=ruleGrpID.options;
        for(var i = 0; i < grpOptions.length; i++){
            var option=grpOptions[i];
            if(option.value === rgID ){
                //If valid rule group found
                option.selected=true;
                shouldAdd.checked = true;
                OrionCore.setEnabledById( "ruleGroupId_${orion:escapeHtml(parentIndex)}", true );
                break;
            }
        }
    }	
	_scorCheckUncAndUpdateTestBtn();
};

_getData = function(container){
	var ret = new Object();
	var pathToExtract = OrionCore.getChildNodeById(container, "binaryPath_${orion:escapeHtml(parentIndex)}");
	ret["pathToExtract"] = pathToExtract.value;
	var domainName = OrionCore.getChildNodeById(container, "domainId_${orion:escapeHtml(parentIndex)}");
	ret["domainName"]=domainName.value;	
	var userName = OrionCore.getChildNodeById(container, "userId_${orion:escapeHtml(parentIndex)}");
	ret["userName"]=userName.value;
	var pwdTxt = OrionCore.getChildNodeById(container, "pwdId_${orion:escapeHtml(parentIndex)}");
	ret["pwdTxt"]=pwdTxt.value;
	var shouldAdd = OrionCore.getChildNodeById(container,"addToRuleGrpChkBox_${orion:escapeHtml(parentIndex)}");
	if(shouldAdd.checked){
		var ruleGroupElement = OrionCore.getChildNodeById(container,"ruleGroupId_${orion:escapeHtml(parentIndex)}");
		var grpOptions=ruleGroupElement.options;
        if(grpOptions.length !==0){     	
	    var ruleGrpID= ruleGroupElement.options[ruleGroupElement.selectedIndex];
		ret["ruleGrpID"]=ruleGrpID.value;
		}
	}	
	return ret;
};

_allowSubmit = function(){ return true;};

</script>